unit NoteBlock;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TNoteForm = class(TForm)
    NoteMemo: TMemo;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NoteForm: TNoteForm;

implementation

uses Imagopas;

{$R *.DFM}

procedure TNoteForm.FormResize(Sender: TObject);
begin
  NoteMemo.width := width-8;
  NoteMemo.height := ClientHeight-8;
end;

procedure TNoteForm.FormCreate(Sender: TObject);
begin
  NoteMemo.lines.add(' ');
  NoteMemo.lines.clear;        {clear notes initially, just to be sure}
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'n';
end;

procedure TNoteForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Imagoo.NoteBlockMenu.checked := false;
end;

end.
