{jos yksi (tai muutama) rele jtetn, kun muut osat poistetaan, releisiin j
 tarpeetonta tietoa (nkyy *.sld-tiedostossa) 19.3.2007}
 
unit recloser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Menus, PQRelay, ExtCtrls, Utildef, StdCtrls,Skemproc, ReclData, Userdef,
  EMTP, Skemadef, Imagodef, Buttons;

procedure RCParamHide  (ipComp: longint); far;
procedure RCRelayShow  (ipComp: longint); far; {show parameters and graph }
procedure RCRelayPar   (ipComp: longint); far;
procedure RCRelayHide  (ipComp: longint); far;
function  RCGridCalc: TGridCalc;
function  pRCGridCalc: TpGridCalc;

type
  TRecloserForm = class(TForm)
    RCmenu: TMainMenu;
    FileMenu: TMenuItem;
    LabelGrid: TStringGrid;
    ValueGrid: TStringGrid;
    ParamItem: TMenuItem;
    CurvePanel: TPanel;
    CurveImage: TImage;
    OptionMenu: TMenuItem;
    HighlightItem: TMenuItem;
    PlaneMenu: TMenuItem;
    PhaseItem: TMenuItem;
    NegSeqItem: TMenuItem;
    ColorPanel: TPanel;
    ColorImage: TImage;
    ViewMenu: TMenuItem;
    NotesItem: TMenuItem;
    DescrMemo: TMemo;
    OKBut: TButton;
    CancelBut: TButton;
    ApplyBut: TButton;
    HintBut: TButton;
    ExitItem: TMenuItem;
    CloseLabel: TLabel;
    SaveDlg: TSaveDialog;
    SaveItem: TMenuItem;
    DecMenu: TMenuItem;
    GroupMenu: TMenuItem;
    IncMenu: TMenuItem;
    CopyItem: TMenuItem;
    ModeLabel: TLabel;
    RatioLabel: TLabel;
    RatioEdit: TEdit;
    InomLabel: TLabel;
    InomEdit: TEdit;
    ConnLabel: TLabel;
    ConnEdit: TEdit;
    ModeEdit: TEdit;
    DiffEdit: TEdit;
    CTItem: TMenuItem;
    AutoBut: TRadioButton;
    ManBut: TRadioButton;
    GroupItem1: TMenuItem;
    GroupItem2: TMenuItem;
    GroupItem3: TMenuItem;
    GroupItem4: TMenuItem;
    GroupItem5: TMenuItem;
    GroupItem6: TMenuItem;
    AllItem: TMenuItem;
    AMWarnLabel: TLabel;
    AutoManMenu: TMenuItem;
    InfoItem: TMenuItem;
    InfoMemo: TMemo;
    ColMarker: TEdit;
    MomentBox: TGroupBox;
    APrimBut: TSpeedButton;
    ASecBut: TSpeedButton;
    XInomBut: TSpeedButton;
    CancelModeBut: TSpeedButton;
    ShowPanel: TPanel;
    ShowImage: TImage;
    procedure FormCreate(Sender: TObject);
    procedure LabelGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure ParamItemClick(Sender: TObject);
    procedure ValueGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure FormDestroy(Sender: TObject);
    procedure HighlightItemClick(Sender: TObject);
    procedure ValueGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FormDeactivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OKButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure ApplyButClick(Sender: TObject);
    procedure LabelGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure ValueGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CurveImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure NotesItemClick(Sender: TObject);
    procedure DescrMemoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure NegSeqItemClick(Sender: TObject);
    procedure PhaseItemClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure HintButClick(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure ValueGridEnter(Sender: TObject);
    procedure CloseLabelClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure IncMenuClick(Sender: TObject);
    procedure DecMenuClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CTItemClick(Sender: TObject);
    procedure CurvePanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CurveImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AutoManButClick(Sender: TObject);
    procedure GroupItem1Click(Sender: TObject);
    procedure GroupItem2Click(Sender: TObject);
    procedure GroupItem3Click(Sender: TObject);
    procedure GroupItem4Click(Sender: TObject);
    procedure GroupItem5Click(Sender: TObject);
    procedure GroupItem6Click(Sender: TObject);
    procedure AllItemClick(Sender: TObject);
    procedure AMWarnLabelClick(Sender: TObject);
    procedure AutoManMenuClick(Sender: TObject);
    procedure InfoItemClick(Sender: TObject);
    procedure InfoMemoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure InfoMemoKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure InfoMemoChange(Sender: TObject);
    procedure ValueGridMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ValueGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure APrimButClick(Sender: TObject);
    procedure ASecButClick(Sender: TObject);
    procedure XInomButClick(Sender: TObject);
    procedure CancelModeButClick(Sender: TObject);
    procedure ShowImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);


  private
    { Private declarations }
    CurveCol    : integer;     {may be needed for "cancel" of UD relay}
    CurveCell   : string;      {contents of the "userdef"  cell, for cancel}
    CurveInfo   : string;      {info of the curve, in InfoMemo, for cancel}
    InfoBack    : TStringList; {for backup of pAdinfo_s}
  public
    { Public declarations }
    procedure WarnWhenInAuto;
    procedure ResetInAutoWarning;
    function InfoIndex(igrp, icol: integer): integer;
    procedure GetInfoText(col: integer);
    procedure RestoreCurveCell;
  end;

var
  RecloserForm: TRecloserForm;

function GetCIname(kk : integer): string;
{function GetUserDef: integer;}
function GetActCol: integer;
function GetCurveRow: integer;
procedure GetCIcols(var cic : integer);
procedure GetCIdim(var ciw,cih: integer);
procedure GetpCurveImg(var pCurveImg: TpImage);

implementation

uses
  Imagopas, Relcurr, CopyGroup, TimeDiff, Condition, morefuses;
{$R *.DFM}

const
  FirstTime : boolean = true;
{ RelayType     = 'RC';}
  ValActCol : integer = 1;    {active column in the value grid}
  ValActRow : integer = 1;
{constants for the grids etc}
  LblFirstWidth = 40;
  LblSecndWidth = 40;
  LblThirdWidth = {270}330;
  ValFirstWidth = 154;
  ValOtherWidth = {42}44;
{row numbers}
  Row51       = 0;
  TimeC1C2Row = 1;   {caption 'C1' or 'C2' (rc) }
  CurveRow    = 2;   {row for curve parameter}
  IssRow      = 3;
  FactRow     = 4;
  TimeModRow  = 5;   {caption for time modifier (rc)}
  TimeMultRow = 6;   {time multiplier (rc)}
  TimeAddRow  = 7;   {added time term (rc)}
  TimeMinRow  = 8;   {min.response time (rc)}
  Row50       = 9;
  I1row       = 10;  {row for the current of first def.time relay}
  t1row       = 11;
  I2row       = 12;
  t2row       = 13;
  I3row       = 14;
  t3row       = 15;
  I4row       = 16;
  t4row       = 17;
  CommonRow   = 18;
  {19}
  {20}
  Zrow        = 21;  {row for the line impedance}
  fiiRow      = 22;  {row for the angle of line impedance}
  ShowRow     = 23;  {row for flag show/not the curve}
  {24}
  ColorRow    = 25;  {row for color parameter}
  {26}
  CurrRow     = 27;  {row for the title of the test current}
  CurrTestRow = 28;  {row for the test current}
  TimeTestRow = 29;  {row for the test time}
  RelCurrRow  = 30;  {row for the relative current}
  {column indices}
  ColP = 1;
  ColG = 3;
  ColQ = 5;
  {dimensions for the color palette}
  CRwidth = 16;     {width (and height) of a small color rectangle}
  CRspace = 4;      {width of space between color rectangles}
  {dimensions of a rectangle for the curve in the curve menu}
  CIwidth = 32{22};
  CIheight = 18;
  CIcols = 6;
  CIrows = 7;
  GImarg = 4;       {margin of the group image MUST BE same as in PQRelay pas (this not good...)}
  GIlinesp = 16;    {line spacing}
  CInames : array[1..CIcols*CIrows] of string =
  ('101-A ','102-1 ','103-17','104-N ','105-R ','106-4 ',
   '107-L ','111-8+','112-15','113-8 ','114-5 ','115-P ',
   '116-D ','117-B ','118-M ','119-14','120-Y ','121-G ',
   '122-H ','131-9 ','132-E ','133-C ','134-Z ','135-2 ',
   '136-6 ','137-V ','138-W ','139-16','140-3 ','141-11',
   '142-13','151-18','152-7 ','161-T ','162-KP','163-F ',
   '164-J ','165-KG','200   ','201   ','202   ','010   ');
{ ('101', '102', '103', '104', '105', '106',
   '107', '111', '112', '113', '114', '115',
   '116', '117', '118', '119', '120', '121',
   '122', '131', '132', '133', '134', '135',
   '136', '137', '138', '139', '140', '141',
   '142', '151', '152', '161', '162', '163',
   '164', '165', '200', '201', '202', '   ');}
  nUserDef = high(CInames);     {index for the user defined curve}
var
  Row_Ind  : TRowIndex;
  Col_Ind  : TColIndex;
  GridCalc : TGridCalc;

function  RCGridCalc: TGridCalc;
begin
  RCGridCalc := GridCalc;
end;

function  pRCGridCalc: TpGridCalc;
begin
  pRCGridCalc := @GridCalc;
end;

function GetUserDef: integer;
{get the index of the user defined curve}
begin
  GetUserDef := nUserDef;
end;

procedure GetCIdim(var ciw,cih: integer);
{get the widht and height of the rectangles in CurveImage for selecting the curve}
begin
  ciw := CIwidth;
  cih := CIheight;
end;

procedure GetpCurveImg(var pCurveImg: TpImage);
begin
  pCurveImg := @RecloserForm.CurveImage;
end;

function GetCIname(kk : integer): string;
begin
  if (kk >= 1) and (kk <= high(CInames)) then  GetCIname := CInames[kk]
  else GetCIname := '   ';
end;

function GetActCol: integer;
{get the index of the active column = active relay module}
begin
  GetActCol := ValActCol;
end;

function GetCurveRow: integer;
begin
  GetCurveRow := CurveRow;
end;

procedure GetCIcols(var cic : integer);
{get the number of columns in CurveImage for selecting the recloser curve}
begin
  cic := CIcols;
end;

procedure CurveInitialize(pCurve: TpImage);
{prepare the image used as a menu for selecting the curve
pCurve  pointer to the image}
var
  ii,jj : integer;  {indices}
  ipu   : integer;  {temporary}
  ix,iy : integer;  {coordinates}
  tw,th : integer;  {text width and height}
begin
  {set size and position of the curve image}
  pCurve^.width := CIcols*CIwidth+1;
  pCurve^.height := CIrows*CIheight+1;
  pCurve^.top := {16}18;
  pCurve^.left := 4;
  {fill the image with the curve numbers (identifiers), define font first}
  pCurve^.canvas.font.name := 'arial narrow';
  pCurve^.canvas.font.size := 8;
  pCurve^.canvas.font.color := clBlack;
  {write the numbers}
  for ii := 1 to CIrows do begin
    iy := (ii-1)*CIheight+2;
    for jj := 1 to CIcols do begin
      ipu := CIcols*(ii-1)+jj;
      ix := (jj-1)*CIwidth+2;
      pCurve^.canvas.textout(ix,iy,CInames[ipu]);
    end;
  end;
  {draw lines to separate the cells}
  pCurve^.canvas.pen.color := clBlue;
  for ii := 0 to CIcols do begin
    pCurve^.canvas.moveto(ii*CIwidth,0);
    pCurve^.canvas.lineto(ii*CIwidth,pCurve^.height);
  end;
  for ii := 0 to CIrows do begin
    pCurve^.canvas.moveto(0,ii*CIheight);
    pCurve^.canvas.lineto(pCurve^.width,ii*CIheight);
  end;
end;

procedure TRecloserForm.FormCreate(Sender: TObject);
var
  ii      : integer;  {index}
  ipu,ipv : integer;  {temporary}
begin
  {row indices}
  Row_Ind.Row51       := Row51;
  Row_Ind.GroupRow    := -1;            {does not exist}
  Row_Ind.TimeC1C2Row := TimeC1C2Row;   {caption 'C1' or 'C2' (rc) }
  Row_Ind.CurveRow    := CurveRow;      {row for curve parameter}
  Row_Ind.IssRow      := IssRow;
  Row_Ind.FactRow     := FactRow;
  Row_Ind.MultRow     := -1;
  Row_Ind.TimeModRow  := TimeModRow;    {caption for time modifier (rc)}
  Row_Ind.TimeMultRow := TimeMultRow;   {time multiplier (rc)}
  Row_Ind.TimeAddRow  := TimeAddRow;    {added time term (rc)}
  Row_Ind.TimeMinRow  := TimeMinRow;    {min.response time (rc)}
  Row_Ind.Row50       := Row50;
  Row_Ind.I1row       := I1Row;         {row for the current of first def.time relay}
  Row_Ind.t1row       := t1Row;
  Row_Ind.I2row       := I2Row;
  Row_Ind.t2row       := t2Row;
  Row_Ind.I3row       := I3Row;
  Row_Ind.t3row       := t3Row;
  Row_Ind.I4row       := I4Row;
  Row_Ind.t4row       := t4Row;
  Row_Ind.CommonRow   := CommonRow;
  Row_Ind.Zrow        := Zrow;          {row for the line impedance}
  Row_Ind.fiiRow      := fiiRow;        {row for the angle of line impedance}
  Row_Ind.ColorRow    := ColorRow;      {row for color parameter}
  Row_Ind.ShowRow     := ShowRow;
  Row_Ind.CurrRow     := CurrRow;       {row for the title of the test current}
  Row_Ind.CurrTestRow := CurrTestRow;   {row for the test current}
  Row_Ind.TimeTestRow := TimeTestRow;   {row for the test time}
  Row_Ind.RelCurrRow  := RelCurrRow;    {row for the relative current}
  {column indices}
  Col_Ind.ColP := ColP;
  Col_Ind.ColG := ColG;
  Col_Ind.ColQ := ColQ;
  Col_Ind.ColP2 := ColP+1;
  Col_Ind.ColG2 := ColG+1;
  Col_Ind.ColQ2 := ColQ+1;
  {set position, size etc for the label grid}
  LabelGrid.ColWidths[0] := LblFirstWidth;
  LabelGrid.ColWidths[1] := LblSecndWidth;
  LabelGrid.ColWidths[2] := LblThirdWidth;
  LabelGrid.width := LblFirstWidth+LblSecndWidth+LblThirdWidth+4;
  LabelGrid.height := LabelGrid.RowCount*(LabelGrid.DefaultRowHeight+
                      LabelGrid.GridLineWidth)+2*LabelGrid.GridLineWidth;
{  RecloserForm.width := LabelGrid.width+8;}
  {set position, size, etc for the value grid}
  ValueGrid.DefaultColWidth := ValOtherWidth;   {just copy, may be needed}
  ValueGrid.ColWidths[0] := ValFirstWidth;
  for ii := 1 to 6 do ValueGrid.ColWidths[ii] := ValOtherWidth;

  ValueGrid.width := ValFirstWidth+6*(ValOtherWidth+ValueGrid.GridLineWidth)+2;
  ValueGrid.height := ValueGrid.RowCount*(ValueGrid.DefaultRowHeight+
                                          ValueGrid.GridLineWidth)+2*ValueGrid.GridLineWidth;
  ValueGrid.top := {2}LabelGrid.top;
  {set width of the form according to the grids}
  ipu := LabelGrid.width+8;
  ipv := ValueGrid.width+8;
  if (ipu > ipv) then RecloserForm.width := ipu else RecloserForm.width := ipv;
  OKBut.top := ValueGrid.top+ValueGrid.height+8;
  CancelBut.top := OKBut.top;
  ApplyBut.top := OKBut.top;
  HintBut.top := OKBut.top;
  MomentBox.top := OKBut.top-8;
  RecloserForm.Height := MomentBox.top+MomentBox.height{OKBut.top+OKBut.height}+50;
    with ValueGrid do begin
    cells[0, 0] := '';
    cells[0, 1] := '';
    cells[0, 2] := '  Curve';
    cells[0, 3] := '  Set current';
    cells[0, 4] := '  Factor (n) OR start time (if > 3)';
    cells[0, 5] := '';
    cells[0, 6] := '  B = Time Multiplier';
    cells[0, 7] := '  C = Time Adder (s)';
    cells[0, 8] := '  tx = Min Response (s)';
    cells[0, 9] := '';
    cells[0,10] := '  Pickup Def 1 ';
    cells[0,11] := '  Delay Def 1[s]';
    cells[0,12] := '  Pickup Def 2 ';
    cells[0,13] := '  Delay Def 2 [s]';
    cells[0,14] := '  Pickup Def 3 ';
    cells[0,15] := '  Delay Def 3 [s]';
    cells[0,16] := '  Pickup Def 4 ';
    cells[0,17] := '  Delay Def 4 [s]';
    cells[0,18] := '';
    cells[0,19] := '  Max current [A, prim]';
    cells[0,20] := '  Directional  (0 = no)';
    cells[0,21] := '  | Z line| (ohms)';
    cells[0,22] := '   line ()';
    cells[0,23] := '  Show curve and Act. test';
    cells[0,24] := '  Line thickness  (0...4)';
    cells[0,25] := '  Color';
    cells[0,26] := '  Spare';
    cells[0,27] := '';
    cells[0,28] := '  current [A, prim](calc. time)';
    cells[0,29] := '  time (calculate current)';
    cells[0,30] := '  multiples of p.u. current';{initialized for recl.relay, changed below}
  end;
{!}{set some default values (temporarily ?)}
  for ii := 1 to 6 do begin
    ValueGrid.cells[ii,ColorRow] := inttostr(ii);
    ValueGrid.cells[ii,CurveRow] := inttostr(ii);
    ValueGrid.cells[ii,Zrow] := '10';
    ValueGrid.cells[ii,fiiRow] := '0';
  end;
  GridCalc := TGridCalc.Create;           {create object for procedures - - - - - - -}
  GridCalc.PutIParSet(gRC_set);           {index for the parameter set}
  GridCalc.initialize(@RecloserForm,@ValueGrid,@LabelGrid,@DescrMemo,nil,nil,nil,nil,@ShowImage,
                      @HighlightItem,@PhaseItem,@NegSeqItem,@NotesItem,@GroupMenu,
                      @IncMenu,@DecMenu,
                      @ColorPanel,@CurvePanel,nil,@ShowPanel,nil,
                      @OKBut,@CancelBut,@ApplyBut,@HintBut,
                      @RatioEdit, @InomEdit, @ConnEdit,@DiffEdit,@ModeEdit,
                      @AutoManMenu,
                      Row_Ind, Col_Ind);
  GridCalc.SetRelayType('RC');   {recloser relay, rechecked in relaypar and relayshow}
  {prepare the image used for selecting the curve}
  CurveInitialize(@CurveImage);
  CurvePanel.width := CurveImage.width+8;
  CurvePanel.height := CurveImage.top+CurveImage.height+8;
  CurvePanel.left := 16;   {just some value, changed in SelectCell}
  CurvePanel.top := ValueGrid.top+
                    (CurveRow+1)*(ValueGrid.DefaultRowHeight+ValueGrid.GridLineWidth);
  CloseLabel.left := CurvePanel.width-CloseLabel.width-8;
  {prepare the image and panel for the selection of the color of the curves}
  {PQForm.}ColorInitialize(@ColorImage);
  {size and initial position of the color panel}
  ColorPanel.width := ColorImage.width+2*CRspace;
  ColorPanel.height := ColorPanel.width;
  ColorPanel.top := ColorRow*(ValueGrid.DefaultRowHeight+ValueGrid.GridLineWidth)
                    +ValueGrid.top-ColorPanel.width;
  ColorPanel.left := ValueGrid.ColWidths[0]+ValueGrid.left;
  {prepare image and its panel for displaying the curve}
  PQForm.ShowInitialize(@ShowImage, @ShowPanel, @ValueGrid, ShowRow);
  {initialize the memo for descriptions}
  DescrMemo.top := LabelGrid.top+10;
  DescrMemo.left := LabelGrid.left+10;
  DescrMemo.width := LabelGrid.width-20;
  DescrMemo.height := LabelGrid.height-20;
  {initialize the memo for additional info}
  InfoMemo.top := 0;
  InfoMemo.left := 0;
  InfoMemo.width := ValueGrid.width;
  InfoMemo.height := 50;
  {positions etc. of auto/manual radio buttons}
  AutoBut.left := 2;
  AutoBut.top := 2;
  AutoBut.caption := 'A';
  AutoBut.width := 32;
  ManBut.left := AutoBut.left+AutoBut.width+16;
  ManBut.top := AutoBut.top;
  ManBut.width := 32;
  ManBut.caption := 'M';
  InfoBack := TStringList.create; {list for backup = cancel}
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'R';
end;

procedure TRecloserForm.LabelGridDrawCell(Sender: TObject; Col,
  Row: Longint; Rect: TRect; State: TGridDrawState);
{write fixed texts, using different colors}
const
  offs = 4;
  ctxt : array[0..11] of string =
         ('C1 -','C1 -','C2 -','C2 -','C1 -','C1 -',
          'C2 -','C2 -','C1 -','C1 -','C2 -','C2 -');
  rtxt : array[0..11] of string =
         ('ID P(1)','ID P(2)','ID P(1)','ID P(2)',
          'ID G(1)','ID G(2)','ID G(1)','ID G(2)',
          'ID Q(1)','ID Q(2)','ID Q(1)','ID Q(2)');
var
  txt : string;
begin
  LabelGrid.canvas.font.style := [fsBold];
  LabelGrid.canvas.font.name := 'Arial';
  LabelGrid.canvas.font.size := 8;
  {color tells the relay type}
  if      (row <=  3) then LabelGrid.canvas.font.color := clRed
  else if (row <=  7) then LabelGrid.canvas.font.color := clGreen
  else if (row <= 11) then LabelGrid.canvas.font.color := clBlue;
  {first column : first or second curve}
  if (col = 0) then begin
    LabelGrid.canvas.TextOut(offs+rect.left,rect.top,ctxt[row]);
  end else if (col = 1) then begin
    {second column: relay type}
    LabelGrid.canvas.TextOut(offs+rect.left,rect.top,rtxt[row]);
  end;
end;

procedure TRecloserForm.ParamItemClick(Sender: TObject);
begin
  if (ParamItem.checked) then begin
    ParamItem.checked := false;
    ParamItem.caption := 'Param.';
    ValueGrid.visible := false;
    LabelGrid.visible := true;
    CurvePanel.visible := false;
    ColorPanel.visible := false;
  end else begin
    ParamItem.checked := true;
    ParamItem.caption := 'Texts';
    ValueGrid.visible := true;
    LabelGrid.visible := false;
  end;
end;

procedure TRecloserForm.ValueGridDrawCell(Sender: TObject; Col,
  Row: Longint; Rect: TRect; State: TGridDrawState);
const
  ctxt : array[1..6] of string =('C1','C2','C1','C2','C1','C2');
  offs = 4;
var
  conn,Ipr,Isc,mode,ratio: single;   {parameters of the current trafo}
  ipu  : integer;
  text : string;
  txt  : string;
begin
  {permanent texts }
  ValueGrid.canvas.font.name := 'Arial';
  {captions in the first (0) column}
  if (col = 0) then begin
    GridCalc.Col0Captions(row,rect);
  end else if (col > 0) then begin
    if          (col = ColP) or (col = ColP+1) then begin
      GridCalc.ColPCaptions(row,rect);
    end else if (col = ColG) or (col = ColG+1) then begin
      GridCalc.ColGCaptions(row,rect);
    end else if (col = ColQ) or (col = ColQ+1) then begin
      GridCalc.ColQCaptions(row,rect);
    end else if (col = ColQ+1) then begin
      {write(3I2), where 2 is a subscript}
      if (row = Row_Ind.Row51) then begin
        ValueGrid.canvas.Font.Size := 8;
        ValueGrid.canvas.Font.Color := clBlue;
        ValueGrid.canvas.Font.Style := [fsBold];
        text := '(3I';
        ipu := ValueGrid.canvas.TextWidth(text);
        text := text+'  )';
        ValueGrid.canvas.TextOut(offs+rect.left,rect.top,text);
        ValueGrid.canvas.Font.Size := 7;
        ValueGrid.canvas.TextOut(offs+rect.left+ipu,rect.top+4,'2');  {as a subscript}
      end;
    end;
    {color the cells defining line color}
    GridCalc.ColorColorCells(col,row, rect);
    {text for the curve cells, identifying the curve}
    if (row = CurveRow) then begin
      ValueGrid.canvas.font.color := clBlack;
      ValueGrid.canvas.font.style := [];
      if (GetRelayTypeCh = 'UD') then begin           {user defined curve}
      {show the curve ID, if fuse}
        ipu := strtoint(ValueGrid.cells[col,row]);
        if (ipu >= 1000) then begin
          {hide the parameter value by drawing a rectangle over it}
          ValueGrid.canvas.pen.color := clWhite;
          ValueGrid.canvas.rectangle(rect.left,rect.top,
                           rect.left+ValOtherWidth,rect.top+ValueGrid.DefaultRowHeight);
          txt := ValueGrid.cells[col,row];         {code of the curve as parameter}
          ValueGrid.canvas.font.size := 7;
          ValueGrid.canvas.TextOut(rect.left,rect.top+1,' '+CharForm.FuseCode(txt));
        end else begin
          ValueGrid.canvas.TextOut(rect.left,rect.top,' userdef');
        end;
      end else begin                                 {normal recloser}
        txt := ValueGrid.cells[col,row];
        ipu := strtoint(txt);
        if (ipu > 0) and (ipu <= CIrows*CIcols) then text := ' '+CInames[ipu]
        else text := '   ';
        ValueGrid.canvas.TextOut(rect.left,rect.top,text);
      end;
    {the 'C1' and 'C'-captions}
    end else if (row = TimeC1C2Row) or (row = TimeModRow) or
       (row = Row50)  or (row = CommonRow) or (row = CurrRow) then begin
      if      (col <= 2) then ValueGrid.canvas.font.color := clRed
      else if (col <= 4) then ValueGrid.canvas.font.color := clGreen
      else                    ValueGrid.canvas.font.color := clBlue;
      {set background color for the "C"-cells}
      ValueGrid.canvas.pen.color := clBlack{clBtnFace};
      ValueGrid.canvas.brush.color := clBtnFace;
      ValueGrid.canvas.brush.style := bsSolid;
      ValueGrid.canvas.rectangle(rect.left-1,rect.top{-1},rect.left+1+
                    ValOtherWidth,rect.top+ValueGrid.DefaultRowHeight+1);
      ValueGrid.canvas.brush.style := bsClear;
      ValueGrid.canvas.font.style := [];
      if (row <> CurrRow) then
        ValueGrid.canvas.TextOut(offs+rect.left,1+rect.top,ctxt[col]);
      {show the status of the curve for testing}
      if (row = CurrRow) then begin
        if      (ValueGrid.cells[col,showrow] = '0') then text := 'no test'
        else if (ValueGrid.cells[col,showrow] = '1') then text := 'test'
        else if (ValueGrid.cells[col,showrow] = '2') then text := 'inv.time'
        else if (ValueGrid.cells[col,showrow] = '3') then text := 'def.time'
        else text := '';
        ValueGrid.canvas.textout(rect.left+1,rect.top+1,text);
      end;
    {same line impedance on all columns, grey-out columns 2 and 3}
    end else if ((row = Zrow  ) or (row = fiiRow)) and (col > 1 ) then begin
      GridCalc.CopyLineImpedance(row, rect);
    end;
  end;
  {if the secondary of the current transformer of this relay is connected in a delta,
   the parameters of the ground-module are greyed out. No zero seq!}
  {get the parameters of the current trafo}
  GetModeAndCTmainPar(GridCalc.GetpAct, conn, Ipr, Isc, mode, ratio);  {in skemproc.pas}
  if (conn <> 0) and (mode <> 0) then begin                     {connected in a delta}
    {columns of the sum current}
    if ((col = ColG) or (col = ColG+1)) and (row > 0) and (mode <> 0) then begin
      ValueGrid.canvas.pen.color := clBtnFace;
      ValueGrid.canvas.brush.color := clBtnFace;
      ValueGrid.canvas.rectangle(rect.left,rect.top,rect.left+
               ValueGrid.DefaultColWidth,rect.top+ValueGrid.DefaultRowHeight);
    end;
  end;
  {if sum current transformer, then no sequence or residual relay modules}
  if (GridCalc.isSumCT_c) then begin
    if ((col = ColG) or (col = colQ) or (col = ColG+1) or (col = colQ+1)) and (row > 0) then begin
      ValueGrid.canvas.pen.color := clBtnFace;
      ValueGrid.canvas.brush.color := clBtnFace;
      ValueGrid.canvas.rectangle(rect.left,rect.top,rect.left+
               ValueGrid.DefaultColWidth,rect.top+ValueGrid.DefaultRowHeight);
    end;
  end;
  {indicate the CT mode at some parameters}
  {done in DisplayCTpar, but must redo here, else may disappear}
  if (col = 0) then begin
    if (row = IssRow) or (row = I1Row) or (row = I2Row) or
       (row = I3row ) or (row = I4Row) then begin
      GridCalc.ShowMode(mode, rect);
    end;
  end;
end;

procedure TRecloserForm.FormDestroy(Sender: TObject);
begin
  GridCalc.free;     {free the object for procedures}
  InfoBack.free;
end;

procedure TRecloserForm.HighlightItemClick(Sender: TObject);
begin
  HighlightItem.checked := not HighlightItem.checked;
end;

function TRecloserForm.InfoIndex(igrp, icol: integer): integer;
{the info lines for each relay module in each parameter set are saved as one
 string (one text line) in the StringList pAdInfo_s of the relay
 The index in the string list depends on the parameter group and relay module
  = column in the grid
 igrp   index of the parameter group 1..gParSet (= 6)
 icol   index of the relay module = column, 1..gReCurv (= 6)}
begin
  if (igrp > 0) and (igrp <= gParSet) and (icol > 0) and (icol <= gReCurv) then
    InfoIndex := (igrp-1)*gParSet+icol-1
  else
    InfoIndex := 1;      {error, some value}  
end;

procedure TRecloserForm.GetInfoText(col: integer);
{get the info text corresponding to the present param.group and relay module (column)
 col  the column}
var
  igrp  : integer;  {parameter group}
begin
  if (GridCalc.GetpAct <> nil) {and (GetRelayType = 'UD')} then begin
    igrp := Recloser.RCGridCalc.ParamGroupIndex;  {get the index of the parameter group}
//  InfoMemo.text := GridCalc.GetpAct^.GetInfoLine((igrp-1)*gParSet+col-1);
    InfoMemo.text := GridCalc.GetpAct^.GetInfoLine(InfoIndex(igrp,col));
  end;
end;

procedure TRecloserForm.RestoreCurveCell;
{restore the contents of the curve cell, and info text. Needed in
 CancelButtonClick of userdef.pas
 data saved in ValueGridSelectCell (below)}
begin
  ValueGrid.cells[CurveCol,CurveRow] := CurveCell;
  InfoMemo.text := CurveInfo;
  CharForm.ReplaceInfoLine(CurveInfo);
end;

procedure TRecloserForm.ValueGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
const
  first : boolean = true;
var
  ii : integer;
  iw : integer;
//  igrp  : integer;  {parameter group}
begin
{!} ValActcol := col;
{!} ValActrow := row;
{  if (first) then first := false else}
  GridCalc.ValueGridSelectCell( Col, Row);
  {update info }
  GetInfoText(col);
  {save curve column and cell contents, maybe needed for "cancel" }
  if (row = CurveRow) then begin
    CurveCol := col;
    CurveCell := ValueGrid.cells[col,row];
    CurveInfo := InfoMemo.text;   {info of the curve, for cancel}
  end;
  {mark the column}
  iw := 0;
  for ii := 0 to col do iw := iw+ValueGrid.ColWidths[ii]+1;   {left edge of the cell}
  ColMarker.top := ValueGrid.top+ValueGrid.DefaultRowHeight+3;
  ColMarker.left := iw-ColMarker.width;
  ColMarker.visible := true;
  ColMarker.BringToFront;
end;

procedure RCParamHide(ipComp : longint);
{hide the parameter form, when minimized (but only then!)}
begin
  if (RecloserForm.WindowState = wsMinimized) then RecloserForm.visible := false;
end;

procedure RCRelayPar (ipComp: longint);
{show parameters at creation..}
var
  pComp : TpComp;
begin
  GridCalc.RelayPar(ipComp);
  {for user def.relays, reserve space for saving curves as strings in param.sets}
  if (GridCalc.GetRelayType = 'UD') then begin  {user defined relay}
    pComp := TpComp(ipComp);
    new(pComp^.pParStr_s);   {for saving curves in parameter sets}
  end;
end;

procedure RCRelayShow(ipComp : longint);
{show the form for the recloser-relays, with parameters and graphics...}
var
  pComp : TpComp;
begin
  GridCalc.RelayShow(ipComp);
  {copy info to backup, for possible "cancel"}
  pComp := TpComp(ipComp);
  RecloserForm.InfoBack.clear;
  pComp^.CopyFromAdInfo(@RecloserForm.InfoBack);
end;

procedure TRecloserForm.FormDeactivate(Sender: TObject);
begin
  if (not CharForm.visible) then
    GridCalc.FormDeactivate(sender);
  ResetInAutoWarning;  
end;

procedure RCRelayHide(ipComp : longint);
{hide the form for the recloser-relays, with parameters and graphics}
begin
  GridCalc.RelayHide(ipComp);
end;

procedure TRecloserForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {eventual "delete component" must be handled here, because the form has focus}
  if (SetComp.pActComp <> nil) then begin     {some component active}
    if (key = 46) then begin                  {delete-key}
      SetComp.FormKeyDown(Key, Shift);        {delete the component}
    end;
  end;
end;

procedure TRecloserForm.ColorImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{get the color indes from mouse coordinates}  
begin
  GridCalc.ColorImageMouseUp(X, Y);
end;

procedure TRecloserForm.OKButClick(Sender: TObject);
{accept the parameters, hide the form}
begin
  GridCalc.OKButtonClick(Sender);
  {recalculate also the time difference between two curves, if visible}
  if (TimeDiffForm.visible) then TimeDiffForm.TimeDifference;
  {when used for user-def-relay, additional forms etc. may be visible, must hide}
  CharForm.FuseGroupPanel.visible := false;
  CharForm.visible := false;
  FuseForm.visible := false;  
end;

procedure TRecloserForm.CancelButClick(Sender: TObject);
{do not accept parameters, return old, if apply-button has been used}
begin
  RCGridCalc.GetpAct^.ReplaceAdInfo(@InfoBack);
  GridCalc.CancelButClick(Sender);
  {recalculate also the time difference between two curves, if visible}
  if (TimeDiffForm.visible) then TimeDiffForm.TimeDifference;
  {when used for user-def-relay, additional forms etc. may be visible, must hide}
  CharForm.FuseGroupPanel.visible := false;
  CharForm.visible := false;
  FuseForm.visible := false;
end;

procedure TRecloserForm.ApplyButClick(Sender: TObject);
{apply the parameters, but do not yet accept}
begin
  GridCalc.ApplyButClick(Sender);
  {recalculate also the time difference between two curves, if visible}
  if (TimeDiffForm.visible) then TimeDiffForm.TimeDifference;
end;

procedure TRecloserForm.LabelGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  GridCalc.LabelGridSelectCell(Row);
end;

procedure TRecloserForm.ValueGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  GridCalc.ValueGridKeyUp(Key);
end;

procedure TRecloserForm.CurveImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  ii,jj : integer;   {index for the column, row in the curve menu}
  kk    : integer;   {index of the curve}
  pComp : TpComp;    {pointer to the relay}
  ww    : word;
begin
  ii := (X div CIwidth)+1;                {index of the row}
  jj := (Y div CIheight)+1;              {index of row}
  kk := (jj-1)*CIcols+ii;
  if (kk >= 1) and (kk <= high(pTCC)) then begin
    ValueGrid.cells[GridCalc.GetCurveCol,CurveRow] := inttostr(kk){CInames[kk]};
    {if curve changes, must recalculate act.time for test current}
    ApplyButClick(CurvePanel);            {change also the curve at once}
    ww := 13;                             {just some value}
    ValueGridKeyUp(Sender, ww , Shift);
  end;
  GridCalc.HighlightSelectedCurve(GridCalc.GetCurveCol,CurveRow);
  {close menu, if automatic closing selected}
  if (AutoBut.checked) then CurvePanel.visible := false;
end;

procedure TRecloserForm.NotesItemClick(Sender: TObject);
{show/not the memo for notes}
begin
  NotesItem.checked := not NotesItem.checked;
  DescrMemo.visible := NotesItem.checked;
  CurvePanel.visible := false;
  ColorPanel.visible := false;
end;

procedure TRecloserForm.DescrMemoMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
{move the memo for notes}
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    DescrMemo.left := DescrMemo.left+X-x0;
    DescrMemo.top  := DescrMemo.top +Y-y0;
  end else begin
    x0 := X;
    y0 := Y;
  end;
end;

procedure TRecloserForm.NegSeqItemClick(Sender: TObject);
var
  col, row : integer;
  ix,iy    : integer;  {x,y coord of the cell (let, top)}
begin
  if not(NegSeqItem.checked) then begin
    PhaseItem.checked := false;
    NegSeqItem.checked := true;
    PlaneMenu.caption := 'NEGATIVE SEQUENCE PLANE';
    {copy to form of curves, and recloser form}
    if (sender = NegSeqItem) then begin
      RelayCurr.NegSeqItem_rcClick(sender);
      PQForm.NegSeqItemClick(sender);
      {change also the curves}
      if (GridCalc.GetpAct <> nil) then Relay_Show(GridCalc.GetpAct,'real');
    end;
    {"grey out" of the test inputs of the phase and ground relays}
    GridCalc.GreyOutCells(1,4,CurrTestRow,RelCurrRow);
    { remove "the grey out" from the neg.seq. relay}
    for col := 5 to 6 do begin
      row := CurrTestRow;
      GridCalc.GetpGrid^.cells[col,row  ] := '0';
      GridCalc.GetpGrid^.cells[col,row+1] := '0';
      GridCalc.GetpGrid^.cells[col,row+2] := '0';
    end;
  end;
end;

procedure TRecloserForm.PhaseItemClick(Sender: TObject);
var
  col,row : integer;
  Rect    : TRect;
begin
  if not(PhaseItem.checked) then begin
    PhaseItem.checked := true;
    NegSeqItem.checked := false;
    PlaneMenu.caption := 'PHASE PLANE';
    {copy the state to the relaycurr-form}
    if (sender = PhaseItem) then begin
      RelayCurr.PhaseItem_rcClick(sender);
      PQForm.PhaseItemClick(sender);
      {change also the curves}
      if (GridCalc.GetpAct <> nil) then Relay_Show(GridCalc.GetpAct,'real');
    end;
    {"grey out" of the test inputs of the neg.seq.relays}
{ValueGridDrawCell(Sender, 3, CurrTestRow, Rect,[gdFixed]);}
    GridCalc.GreyOutCells(5,6,CurrTestRow,RelCurrRow);
    { remove "the grey out" from the phase and ground relays}
    for col := 1 to 4 do begin
      row := CurrTestRow;
      GridCalc.GetpGrid^.cells[col,row  ] := '0';
      GridCalc.GetpGrid^.cells[col,row+1] := '0';
      GridCalc.GetpGrid^.cells[col,row+2] := '0';
    end;
  end;
end;

procedure TRecloserForm.FormHide(Sender: TObject);
{unmasrk component, when the recloser form changed to not visible,
 but not when closing the whole program}
var
  ipSet : longint;
begin
  if (GridCalc.GetpAct <> nil) and (not appl_close) then begin
    GridCalc.GetpAct^.GetipSet(ipSet);
    unmark(ipSet);
    CopyGroupForm.visible := false;   {hide, if it happens to be visible}
    {clear the dislpay of the CT parameters}
    GridCalc.ClearCTtexts;
  end;
  ResetInAutoWarning;
  CancelModeButClick(sender);
  InfoItem.checked := false;
  InfoMemo.visible := false;
end;

procedure TRecloserForm.HintButClick(Sender: TObject);
begin
  GridCalc.HintButClick(sender);
end;

procedure TRecloserForm.ExitItemClick(Sender: TObject);
begin
//CharForm.visible := false;
  CharForm.close;
  close;
//  visible := false;
end;

procedure TRecloserForm.ValueGridEnter(Sender: TObject);
{onko tarpeen, auttaako?}
var
cs : boolean;
begin
  {must select cell, because it does not work first time, for some reason}
  if (FirstTime) then begin
    ValueGridSelectCell(Sender,GridCalc.GetActCol,GridCalc.GetActRow, cs);
    FirstTime := false;
  end;
end;

procedure TRecloserForm.CloseLabelClick(Sender: TObject);
begin
  CurvePanel.visible := false;
end;

procedure TRecloserForm.SaveItemClick(Sender: TObject);
{save the data of the selected curve to file}
var
  col     : integer;
  curr    : single;    {current}
  DirName : string;    {name of the saving directory}
  iCurve  : integer;   {index of the curve}
  ii      : integer;   {index}
  ndata   : integer;   {number of data pairs}
  Outfile : TextFile;  {file where written}
  temps   : single;    {time}
  txt     : string;    {temporary}
begin
  if (SaveDlg.execute) then begin
    DirName := '';                                {initialize}
    DirName := ExtractFileDir(SaveDlg.filename);  {get directory}
    {if reasonable directory name found, save it for next time}
    if (length(DirName) >=2) then SaveDlg.InitialDir := DirName;
    try
      AssignFile(Outfile, SaveDlg.filename);      {open the given file,BUT ERRORS ?}
      rewrite(outfile);
      ndata := high(ReclCurr);                    {number of current-time data pairs}
      col := GetActCol;                           {column = index of relay module}
      if (col >= 1) and (col <= 6) then begin
        txt := ValueGrid.cells[col,CurveRow];           {index of curve as text}
        iCurve := strtoint(txt);                  {index of the curve}
        {get current and time from the tables (arrays)}
        for ii := 1 to ndata do begin
          GetDataWithIndex(iCurve, ii, curr, temps);
          writeln(outfile,sixplaces(curr)+'  '+format('%7.4f',[temps]));
        end;
      end;
    finally
      closefile(outfile);
    end;
  end;
end;


procedure TRecloserForm.FormShow(Sender: TObject);
{some texts depend on the relay type}
begin
  if (GetRelayTypeCh = 'UD') then begin           {user defined curve}
    ValueGrid.cells[0,30] := '  relative current';
//  InfoItem.enabled := true;
  end else begin
    ValueGrid.cells[0,30] := '  multiples of p.u. current';
//  InfoItem.enabled := false;
  end;
  GridCalc.SaveParSetIndex;
  if (InfoMemo.top < 0) then InfoMemo.top := 0
  else if (InfoMemo.top > OKBut.top) then InfoMemo.top := OKBut.top;
  GridCalc.PutJustShown(true);
  {test values not yet calculated}
  ValueGrid.cells[1,TimeTestRow] := '';  {row for the test time}
  ValueGrid.cells[1,RelCurrRow]:= '';    {row for the relative current}
  ValueGrid.cells[2,TimeTestRow] := '';
  ValueGrid.cells[2,RelCurrRow]:= '';
  ValueGrid.cells[3,TimeTestRow] := '';
  ValueGrid.cells[3,RelCurrRow]:= '';
end;

procedure TRecloserForm.IncMenuClick(Sender: TObject);
begin
  {if user defined relay, hide the form of current-time points}
  if (GridCalc.GetRelayType = 'UD') then begin
    if (CharForm.visible) then begin     {form for entering data visible}
      CharForm.OKButtonClick(CharForm.OKButton);    {save data, hide form}
    end;
  end;
  GridCalc.ChangeParamGroup('Inc');
  GetInfoText(GetActCol);
  WarnWhenInAuto;
end;

procedure TRecloserForm.DecMenuClick(Sender: TObject);
begin
  {if user defined relay, hide the form of current-time points}
  if (GridCalc.GetRelayType = 'UD') then begin
    if (CharForm.visible) then begin     {form for entering data visible}
      CharForm.OKButtonClick(CharForm.OKButton);    {save data, hide form}
    end;
  end;
  GridCalc.ChangeParamGroup('Dec');
  GetInfoText(GetActCol);
  WarnWhenInAuto;
end;

procedure TRecloserForm.WarnWhenInAuto;
{show warning, that the parameter group will be reset to the original, because in
 Auto Mode}
begin
  if (AutoManMenu.caption = 'A') then begin
    AMWarnLabel.caption := '   Warning: Param Group will be reset in Auto-mode  ( OK )';
    AMWarnLabel.left := 0;
    AMWarnLabel.top := ModeLabel.top;
    AMWarnLabel.visible := true;
    AMWarnLabel.BringToFront;
    ModeEdit.visible := false;
    RatioEdit.visible := false;
    InomEdit.visible := false;
    ConnEdit.visible := false;
  end;
end;

procedure TRecloserForm.ResetInAutoWarning;
begin
  AMWarnLabel.visible := false;
  ModeEdit.visible := true;
  RatioEdit.visible := true;
  InomEdit.visible := true;
  ConnEdit.visible := true;
end;

procedure TRecloserForm.CopyItemClick(Sender: TObject);
var
  pComp : TpComp;
ii,jj: integer;
lbl: string;
begin
  {if user defined relay, hide the form of current-time points}
  if (GridCalc.GetRelayType = 'UD') then begin
    if (CharForm.visible) then begin     {form for entering data visible}
      CharForm.OKButtonClick(CharForm.OKButton);  {save data, hide form, as if OK-button clicked}
    end;
  end;
  CopyGroupForm.ParamBox.visible := true;
  CopyGroupForm.TextBox.visible := true;
  CopyGroupForm.WhatLabel.visible := true;
  CopyGroupForm.visible := true;
  pComp := GridCalc.GetpAct;
  CopyGroupForm.tag := longint(pComp);  {copy pointer to the relay to the tag of the form}
end;

procedure TRecloserForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  charForm.close;
//CharForm.visible := false;   {hide, if happens to be visible}
end;

procedure TRecloserForm.CTItemClick(Sender: TObject);
{show/hide the parameters of the current transformer}
begin
  CTItem.checked := not CTItem.checked;
  ModeLabel.visible := CTItem.checked;
  RatioLabel.visible := CTItem.checked;
  InomLabel.visible := CTItem.checked;
  ConnLabel.visible := CTItem.checked;
  ModeEdit.visible := CTItem.checked;
  RatioEdit.visible := CTItem.checked;
  InomEdit.visible := CTItem.checked;
  ConnEdit.visible := CTItem.checked;
end;

procedure TRecloserForm.CurvePanelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
{move the panelwith the mouse}
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    CurvePanel.left := CurvePanel.left+X-x0;
    CurvePanel.top  := CurvePanel.top +Y-y0;
  end else begin
    x0 := X;
    y0 := Y;
  end;
end;

procedure TRecloserForm.CurveImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
{move the title of the single line diagram}
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    CurvePanel.left := CurvePanel.left+X-x0;
    CurvePanel.top  := CurvePanel.top +Y-y0;
  end else begin
    x0 := X;
    y0 := Y;
  end;

end;

procedure TRecloserForm.AutoManButClick(Sender: TObject);
{change auto/man mode of parameter group change}
var
  ll   : longint;
  pSet : TpCompSet;
begin
(*if (not AutoManBut.down) then begin
    GridCalc.SetAutoManBut('M');
    GridCalc.GetpAct^.PutPar(gRC_auto,0);
    ResetInAutoWarning;
  end else begin
    GridCalc.SetAutoManBut('A');
    GridCalc.GetpAct^.PutPar(gRC_auto,1);
  end;
  {show auto/man in the symbol (actually in the symbol of the CT)}
  GridCalc.GetpAct^.GetipSet(ll);
  pSet := TpCompSet(ll);
  pSet^.WriteGroupIndex(GridCalc.GetpAct);       {in skemadef.pas}*)
end;

procedure TRecloserForm.GroupItem1Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(1);
end;

procedure TRecloserForm.GroupItem2Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(2);
end;

procedure TRecloserForm.GroupItem3Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(3);
end;

procedure TRecloserForm.GroupItem4Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(4);
end;

procedure TRecloserForm.GroupItem5Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(5);
end;

procedure TRecloserForm.GroupItem6Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(6);
end;

procedure TRecloserForm.AllItemClick(Sender: TObject);
begin
  ConditionForm.AllGroupItemsClick;
end;

procedure TRecloserForm.AMWarnLabelClick(Sender: TObject);
begin
  ResetInAutoWarning;
end;

procedure TRecloserForm.AutoManMenuClick(Sender: TObject);
var
  ll   : longint;
  pSet : TpCompSet;
begin
  if (AutoManMenu.caption = 'A') then begin
    GridCalc.SetAutoManMenu('M');
    GridCalc.GetpAct^.PutPar(gRC_auto,0);
    ResetInAutoWarning;
  end else begin
    GridCalc.SetAutoManMenu('A');
    GridCalc.GetpAct^.PutPar(gRC_auto,1);
    {change the parameter group, if allowed and conditions satisfied}
    ChangeParamGroupIf(GridCalc.GetpAct);
  end;
  {show auto/man in the symbol (actually in the symbol of the CT)}
  GridCalc.GetpAct^.GetipSet(ll);
  pSet := TpCompSet(ll);
  pSet^.WriteGroupIndex(GridCalc.GetpAct);       {in skemadef.pas}
end;

procedure TRecloserForm.InfoItemClick(Sender: TObject);
{show/hide the memo for additional information}
begin
  InfoItem.checked := not InfoItem.checked;
  InfoMemo.visible := InfoItem.checked;
  CurvePanel.visible := false;
  ColorPanel.visible := false;
  {update the info text}
  if (InfoMemo.visible) then
    GetInfoText(ValActCol);
end;

procedure TRecloserForm.InfoMemoMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
{move the memo}
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    InfoMemo.left := InfoMemo.left+X-x0;
    InfoMemo.top  := InfoMemo.top +Y-y0;
  end else begin
    x0 := X;
    y0 := Y;
  end;

end;

procedure TRecloserForm.InfoMemoKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{if editing the info memo, save it}
begin
  CharForm.ReplaceInfoLine(InfoMemo.text);
end;

procedure TRecloserForm.InfoMemoChange(Sender: TObject);
begin
  {display the same info in the form for the current+time values, for user def.relay}
  if (GetRelayTypeCh = 'UD') then CharForm.InfoMemo.text := InfoMemo.text;
end;

procedure TRecloserForm.ValueGridMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  GridCalc.PutJustShown(false);
end;

procedure TRecloserForm.ValueGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  GridCalc.PutJustShown(false);
end;

procedure TRecloserForm.APrimButClick(Sender: TObject);
{if down, display the curent parameters as if the primary current was read
 from the current transformer,  else return to the original mode }
var
  same    : boolean;  {true, when momentary mode = proper mode}
begin
  if (APrimBut.down) then begin
    GridCalc.MomentaryCurrentParam(0,same);     {parameters as if primary current in use}
    if(same) then CancelModeButClick(Sender);        {no need to change mode}
  end else begin
    CancelModeButClick(Sender);
  end;

end;

procedure TRecloserForm.ASecButClick(Sender: TObject);
var
  same    : boolean;  {true, when momentary mode = proper mode}
begin
  if (ASecBut.down) then begin
    GridCalc.MomentaryCurrentParam(1,same);     {parameters as if secondary current in use}
    if(same) then CancelModeButClick(Sender);        {no need to change mode}
  end else begin
    CancelModeButClick(Sender);
  end;
end;

procedure TRecloserForm.XInomButClick(Sender: TObject);
var
  same    : boolean;  {true, when momentary mode = proper mode}
begin
  if (XInomBut.down) then begin
    GridCalc.MomentaryCurrentParam(2,same);     {parameters as if x Inom Sec current in use}
    if(same) then CancelModeButClick(Sender);        {no need to change mode}
  end else begin
    CancelModeButClick(Sender);
  end;
end;

procedure TRecloserForm.CancelModeButClick(Sender: TObject);
{return the mode buttons (and their effect) to the normal (up) state}
begin
  APrimBut.down := false;
  ASecBut.down := false;
  XInomBut.down := false;
  GridCalc.ResetCurrentParam;  {get back the original parameters}
end;

procedure TRecloserForm.ShowImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{determine the flag from the position of the mouse}
var
  CRect  : TRect;     {rectangle in the grid}
  jj     : integer;   {index for the group}
  key    : word;
  NoHide : boolean;   {must not hide the curve}
begin
 {must not hide the curve, if time difference calculation active for this curve}
  NoHide := GridCalc.CannotHideCurve;
  jj := ((Y-GImarg) div GIlinesp);    {index of curve}
  if (jj < 0) then jj := 0
  else if (jj > 3) then jj := 3;
  {must not hide curve, if time diff.calculation active}
  if ((jj = 0) and (NoHide)) then begin
    {do nothing}
  end else begin
    ValueGrid.cells[GridCalc.GetShowCol,ShowRow] := inttostr(jj);
    ShowPanel.visible := false;
    {as if value keyed in (written in the cell)}
    key := 40;
    GridCalc.ValueGridKeyUp(key);
    ApplyButClick(sender);
    {show the test-state, see DrawCell}
    CRect := ValueGrid.CellRect(GridCalc.GetShowCol,CurrRow);     {rectangle of the cell for text caption}
    ValueGridDrawCell(Sender,GridCalc.GetShowCol, CurrRow, CRect,[]);
  end;  
end;

end.

