{!!! IF number of parameters is changed, check dimensions in paramrep.pas !!!!}
{vert. scroll bar oli 26.12.2004: 8, 0, 0, 380, false, true  }
{tilanne ennenkuin monen releen kyrt samassa kuvassa  12.2.2011}
unit distance;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Skemadef,Utildef, routines, StdCtrls, ExtCtrls,Drawcomp, compdef,
  Menus,marker, Buttons, Cmatmul,Clipbrd;

type
  TDistrel = class(TForm)
    MhoGrid: TStringGrid;
    DistChar: TImage;
    DummyImage: TImage;
    MarkImage: TImage;
    ImpedEdit: TEdit;
    ExportDialog: TSaveDialog;
    FirstMenu: TMainMenu;
    FileMenu: TMenuItem;
    ExportItem: TMenuItem;
    ExitItem: TMenuItem;
    TitleEdit: TEdit;
    ViewMenu: TMenuItem;
    NotesItem: TMenuItem;
    NotesMemo: TMemo;
    MarkerMenu: TMenuItem;
    Zone1Item: TMenuItem;
    Zone2Item: TMenuItem;
    Zone3Item: TMenuItem;
    Zone4Item: TMenuItem;
    LineItem: TMenuItem;
    OptionsMenu: TMenuItem;
    ShowItem: TMenuItem;
    ColorItem: TMenuItem;
    GridColor: TImage;
    GridItem: TMenuItem;
    IDImage: TImage;
    PointMarker: TMenuItem;
    LineMarker: TMenuItem;
    ResetBut: TSpeedButton;
    DecBut: TSpeedButton;
    IncBut: TSpeedButton;
    OKBut: TSpeedButton;
    CancelBut: TSpeedButton;
    ApplyBut: TSpeedButton;
    HintBut: TSpeedButton;
    ImagePanel: TPanel;
    ColorImage: TImage;
    LoadItem: TMenuItem;
    StepItem: TMenuItem;
    LoadZoneItem: TMenuItem;
    OutZoneItem: TMenuItem;
    ThicknessPanel: TPanel;
    ThicknessImage: TImage;
    UnitsItem: TMenuItem;
    ParamItem: TMenuItem;
    SymbolItem: TMenuItem;
    TitleItem: TMenuItem;
    ImpedanceItem: TMenuItem;
    DecMenu: TMenuItem;
    GroupMenu: TMenuItem;
    IncMenu: TMenuItem;
    CopyItem: TMenuItem;
    AutoManMenu: TMenuItem;
    CondItem1: TMenuItem;
    CondItem2: TMenuItem;
    CondItem3: TMenuItem;
    CondItem4: TMenuItem;
    CondItem5: TMenuItem;
    CondItem6: TMenuItem;
    AllItem: TMenuItem;
    Warnedit: TEdit;
    CopyToCItem: TMenuItem;
    ScaleItem: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MhoGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
{   procedure MhoGridEnter(Sender: TObject);}
    procedure FormDeactivate(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure ApplyButClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure HintButClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure IncButClick(Sender: TObject);
    procedure DecButClick(Sender: TObject);
    procedure ResetButClick(Sender: TObject);
    procedure DistCharMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ExportItemClick(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure TitleEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure NotesItemClick(Sender: TObject);
//  procedure NotesMemoExit(Sender: TObject);
    procedure FormActivate(Sender: TObject);
//  procedure NotesMemoKeyUp(Sender: TObject; var Key: Word;
//    Shift: TShiftState);
    procedure MarkerMenuClick(Sender: TObject);
    procedure Zone1ItemClick(Sender: TObject);
    procedure Zone2ItemClick(Sender: TObject);
    procedure Zone3ItemClick(Sender: TObject);
    procedure Zone4ItemClick(Sender: TObject);
    procedure LineItemClick(Sender: TObject);
    procedure ShowItemClick(Sender: TObject);
    procedure ColorItemClick(Sender: TObject);
    procedure GridItemClick(Sender: TObject);
    procedure GridColorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DistCharMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DistCharMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PointMarkerClick(Sender: TObject);
    procedure LineMarkerClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MhoGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure MhoGridMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure MhoGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImpedEditClick(Sender: TObject);
    procedure TitleEditClick(Sender: TObject);
//  procedure NotesMemoClick(Sender: TObject);
    procedure ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MhoGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MhoGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LoadItemClick(Sender: TObject);
    procedure StepItemClick(Sender: TObject);
    procedure LoadZoneItemClick(Sender: TObject);
    procedure OutZoneItemClick(Sender: TObject);
    procedure ThicknessImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure UnitsItemClick(Sender: TObject);
    procedure ParamItemClick(Sender: TObject);
    procedure SymbolItemClick(Sender: TObject);
    procedure TitleItemClick(Sender: TObject);
    procedure ImpedanceItemClick(Sender: TObject);
    procedure DecMenuClick(Sender: TObject);
    procedure IncMenuClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure AutoManMenuClick(Sender: TObject);
    procedure CondItem1Click(Sender: TObject);
    procedure CondItem2Click(Sender: TObject);
    procedure CondItem3Click(Sender: TObject);
    procedure CondItem4Click(Sender: TObject);
    procedure CondItem5Click(Sender: TObject);
    procedure CondItem6Click(Sender: TObject);
    procedure AllItemClick(Sender: TObject);
    procedure WarneditClick(Sender: TObject);
    procedure CopyToCItemClick(Sender: TObject);
    procedure ScaleItemClick(Sender: TObject);
{   procedure SaveActRelay(pComp : TpComp);}
  private
    { Private declarations }
  public
    { Public declarations }
  end;

{define a class for diverse functions}
type
  TpDist = ^TDist;
  TDist = Class(TObject)
  procedure initialize(pApply,pCancel, pHint, pOK : TpButton; pStrGrid : TpGrid;
                       pDForm : TpForm; pDChar : TpImage; pImpEd, pTitlEd, pWarnEd : TpEdit;
                       pNMemo : TpMemo; pDumimg, pMrkID : TpImage; pImgPnl,
                       pThPnl : TpPanel; pThImg : TpImage; pMenuAM: TpMenuItem);
  procedure SaveActRelay(pComp : TpComp);
  procedure GetOldWidth(var oldw : integer);
  procedure PutOldWidth(oldw : integer);
  procedure FormDeactivate(Sender: TObject);
  procedure FormPaint;
  procedure FormResize;
  procedure ClearDistChar(toile: TCanvas);
  function  pDistrel   : TpForm;
  function  pDistGrid  : TpGrid;
  function  pDistChar  : TpImage;
  function  pDistImped : TpEdit;
  function  pDistNotes : TpMemo;
  function  pDummyImg  : TpImage;
  function  pTitleEdit : TpEdit;
  function  GetActRel  : TpComp;
  procedure PutpList(pLL : TpListBox);
  procedure DrawGrid(toile: TCanvas; color: TColor);
  procedure DrawImpedances(pComp : TpComp; toile: TCanvas);
  procedure DrawColors(toile: TCanvas);
  procedure DrawLineImpedance(Zline,fline: single; toile: TCanvas);
  procedure DrawOhms(toile : TCanvas);
  procedure CalculateScale( zm : single{; var scale, step : single});
  procedure MouseImpedance(x,y : integer; var txt : string);
  procedure DrawDiagram(Fname : string);
  procedure NotesMemoKeyUp(Sender: TObject; var Key: Word;
            Shift: TShiftState);
  procedure DrawImpedMarkers(pComp: TpComp; toile: TCanvas; scale : single; grnd: boolean);
  procedure SaveLineColor(clr: TColor);
  procedure PutNewColor(clr: TColor);
  procedure SetClrChange;
  procedure ResetClrChange;
  procedure MouseDownAtID(x,y : integer);
  procedure MouseUpAtID(x, y: Integer);
  procedure DrawLoadZones(toile: TCanvas; txout: boolean);
  procedure DrawOutOfStepChar(toile : TCanvas; txout : boolean);
  procedure ClickNonData;
  procedure PutImpedZoneRows(phThRow, grThRow : integer);
  procedure PutNameRows(fwRow,rvRow: integer);
  procedure GetNameRows(var fwRow, rvRow : integer);
  procedure PutParGroupRow(pgRow: integer);
  function  GetParGroupRow: integer;
  procedure PutfwIDRows(xrow,yrow : integer);
  procedure GetfwIDRows(var xrow,yrow : integer);
  procedure PutrvIDRows(xrow,yrow : integer);
  procedure GetrvIDRows(var xrow,yrow : integer);
  procedure PutLineRows(fwClr, rvClr, fwThick, rvThick : integer);
  procedure PutLoadZoneRows(fwMVA,fwposA,fwnegA,rvMVA,rvposA,rvnegA : integer);
  procedure Putz6Rows(rName,rTop,rBot,rRight,rLeft,rColor,rThickn,rIDx,rIDy : integer);
  procedure Putz5Rows(rName,rTop,rBot,rRight,rLeft,rColor,rThickn,rIDx,rIDy : integer);
  procedure PosToImped(x,y : integer; var res, reac : single);
  procedure ParameterTexts;
  procedure ImpedToPos(res, reac : single; var x,y : integer);
  procedure SelectCell(col,row : longint);
  procedure DrawCell(Col, Row: Longint; Rect: TRect);
  procedure PrepareThicknessPanel;
  procedure ThicknessImageMouseUp(x,y : integer);
  procedure DecodeThickness(var th1,th2,th3,th4,th5 : integer);
  procedure EncodeThickness(th1,th2,th3,th4,th5 : integer);
  procedure SetPhaseGround(phase : boolean);
  procedure PutOhmCoord(Rx, Ry, Xx, Xy: integer);
  procedure UpdateMarkerString(age,pl: integer; LineOld: string; var LineNew: string);
  procedure PutParGroupMenus(pCaption,pInc,pDec: TpMenuItem);
  function  MarkerAge(Mline: string; var nSep: integer): integer;
  function  GetLineColor: TColor;
  function  ColorChanged: boolean;
  function  NewColor: TColor;
  function  isResistLine(imrk : integer): boolean;
  function  SizeScaling : single;
  function  OrigWidth: integer;
  function  RowVisible(arow : integer): boolean;
  function  GetGroupIndex: integer;
  function  GetGroupIndexRow: integer;
  procedure PutGroupIndex(igrp: integer);
  procedure ChangeParamGroup(IncOrDec: string);
  function  ParamGroupIndex: integer;
  procedure FromGridToParam(Sender: TObject);
  procedure FromGridToParamGroup;
  procedure FromParamGroupToGrid(igrp: integer);
  procedure FromParamGroupToComp(igrp: integer; pComp: TpComp);
  procedure FromCompToGrid(pComp: TpComp);
  procedure ShowGroupCaption(igrp: integer);
  procedure PutAMcaption(AorM: char);
  procedure SaveParSetIndex;
  procedure SetWarning;
  procedure SetParWarning(parnam, minval, maxval: string);
  procedure PutOrig(X,Y : single);
  private
    phThRow_d   : integer;      {row for thickness of impedance zone lines}
    grThRow_d   : integer;      {row for thickness of impedance zone lines}
    fwColRow_d  : integer;      {index for forward color row}
    rvColRow_d  : integer;      {index for reverse color row}
    fwThRow_d   : integer;      {index of forward line thickness}
    rvThRow_d   : integer;      {index of reverse line thickness}
    fwNameR_d   : integer;      {index for forward name row}
    rvNameR_d   : integer;      {index for reverse name row}
    fwMVARow_d  : integer;      {index for forward apparent power row}
    rvMVARow_d  : integer;      {index for reverse apparent power row}
    fwPosARow_d : integer;      {index of forward positive angle row}
    rvPosARow_d : integer;      {index of reverse positive angle row}
    fwNegARow_d : integer;      {index of forward negative angle row}
    rvNegARow_d : integer;      {index of reverse negative angle row}
    fwIDxRow_d  : integer;      {row of the x-coord. of the ID of the forward load zone}
    rvIDxRow_d  : integer;      {row of the x-coord. of the ID of the reverse load zone}
    parGrRow_d  : integer;      {row for the index of the parameter group}
    fwIDyRow_d  : integer;      {row of the y-coord. of the ID of the forward load zone}
    rvIDyRow_d  : integer;      {row of the y-coord. of the ID of the reverse load zone}
    z6IDxRow_d  : integer;      {x-coord for ID of zone 6}
    z6IDyRow_d  : integer;      {y-coord for ID of zone 6}
    z6NameRow_d : integer;      {row for name (identifier)}
    z6TopRow_d  : integer;      {top reactance}
    z6BotRow_d  : integer;      {bottom reactance}
    z6RightRow_d: integer;      {right resistance}
    z6LeftRow_d : integer;      {left resistance}
    z6ColRow_d  : integer;      {color of the line}
    z6ThRow_d   : integer;      {line thickness}
    z5IDxRow_d  : integer;      {x-coord for ID of zone 5}
    z5IDyRow_d  : integer;      {y-coord for ID of zone 5}
    z5NameRow_d : integer;      {row for name (identifier)}
    z5TopRow_d  : integer;      {top reactance}
    z5BotRow_d  : integer;      {bottom reactance}
    z5RightRow_d: integer;      {right resistance}
    z5LeftRow_d : integer;      {left resistance}
    z5ColRow_d  : integer;      {color of the line}
    z5ThRow_d   : integer;      {line thickness}
    nMark_d     : integer;      {no of point-markers, counted in DrawImpedMarkers}
    LMark_d     : integer;      {no of line-markers}
    li_d        : integer;      {index of moving ID of a line-marker}
    lx_d,ly_d   : integer;      {new position and moving-flags of ID of markers}
    oi_d        : integer;      {index of moving "Ohm"}
    ox_d,oy_d   : integer;      {new position and moving-flags of "Ohm"}
    pi_d        : integer;      {index of moving ID of a point-marker}
    px_d,py_d   : integer;      {new position and moving-flags of ID of markers}
    zi_d        : integer;      {index of moving ID of a load zone}
    zx_d,zy_d   : integer;      {new position and moving-flags of ID of markers}
    thwid_d     : integer;      {width of space reserved for one line thickness-sub-image}
    thhei_d     : integer;      {height of space reserved for one line thickness-sub-image}
    thspc_d     : integer;      {width of space between line thickness-sub-images}
    phase_d     : boolean;      {true = phase distance relay, false = ground dist.rel}
    ohmRx_d     : integer;      {x-coordinate of "ohm"-mark on the R-axis, from the left border}
    ohmRy_d     : integer;      {y-coordinate of "ohm"-mark on the R-axis, from the middle}
    ohmXx_d     : integer;      {x-coordinate of "ohm"-mark on the X-axis, from the middle}
    ohmXy_d     : integer;      {y-coordinate of "ohm"-mark on the X-axis, from the bottom}
    origX_d     : single;       {relative position of origo = fraction of width}
    origY_d     : single;       {relative position of origo = fraction of height}
    pActRel     : TpComp;       {pointer to the distance relay for which data shown}
    pApplyBut   : TpButton;     {pointer to the Apply-button}
    pCancelBut  : TpButton;     {pointer to Cancel-button}
    pChar       : TpImage;      {pointer to the characteristics}
    pForm       : TpForm;       {pointer to the form}
    pGrpCaption : TpMenuItem;   {pointer to the menu item displaying the parameter group}
    pIncGrp     : TpMenuItem;   {pointer to the menu item increasing the parameter group}
    pDecGrp     : TpMenuItem;   {pointer to the menu item decreasing the parameter group}
    pGrid       : TpGrid;       {pointer to the parameter grid}
    pHintBut    : TpButton;     {pointer to Hint-button}
    pImgPanel   : TpPanel;      {pointer to the panel for the color menu}
    pImpEdit    : TpEdit;       {pointer to the edit for the cursor position}
    pWarnEdit   : TpEdit;       {edit for warning}
    pLmList     : TpListBox;    {pointer to the list box of line markers}
    pNotes      : TpMemo;       {pointer to the memo for notes}
    pOKBut      : TpButton;     {pointer to the OK-button}
    pTitle      : TpEdit;       {pointer to the title edit}
    pDimage     : TpImage;      {pointer to dummy image}
    pMarkerID   : TpImage;      {pointer to the image for moving the marker ID}
    pThPanel    : TpPanel;      {panel for the line thickness menu}
    pThImage    : TpImage;      {image for the line thickness menu}
    pAMmenu     : TpMenuItem;   {flag for auto/man change of param.group}
    ParSetInd_d : integer;      {index of the parameter group (or set) in use, at form show}
    width_old   : integer;      {old width of form}
    clGrid      : TColor;       {new grid color}
    ClrChange   : boolean;      {grid color changed}
    owid        : integer;      {original width (and height) of the graph.image}
    Mrkxx       : array[0..20] of integer; {for saving the position of the marker}
    Mrkyy       : array[0..20] of integer;
    IDrxx       : array[0..20] of integer; {relative position of the ID of the markers}
    IDryy       : array[0..20] of integer;
    Linxy       : array[0..20] of integer; {for saving the position of the line}
    LIDxx       : array[0..20] of integer; {(relative) position of the ID of the line}
    LIDyy       : array[0..20] of integer;
    {Note: one cooridante of the ID of a line is relative, the other is absolute}
  public
    ButNomTop     : integer;             {nominal y-coord. of the buttons}
    FormNomHeight : integer;             {nominal height of the form}
    GridNomHeight : integer;             {nominal height of the grid}
    GridTotHeight : integer;             {total height of the grid}
    CharNomTop    : integer;             {nominal y-coord of the char.image}
    modscale      : integer;             {factor for changing the scale}
    scale         : single;              {the scale of the image of char.}
    step          : single;              {the distance between markings on the imped.axes}
    TooSmall      : boolean;             {flag for too small a scale}
    spare   : array[0..68] of string;    {for saving parameters, for apply-cancel}
    pointeg : array[1..8] of longint;    {pointers to form and components as integers}
  end;

procedure DrawMhoChar(scale,mag,alpha : single; color : TColor; thc: integer; toile: TCanvas);
procedure DrawAllMhoChar(pComp : TpComp; toile: TCanvas);
procedure DistanceRelayShow;
function  DistHiddenRow(irow : integer): boolean;
function  NumberOfSpaces(txa : string): integer;

var
  Distrel : TDistrel;
  Dist    : TDist;     {object for diverse procedures}
implementation

uses
  imagopas, skemproc, polygon, emtp, Impmark, RXLines, PQRelay, CopyGroup,
  Condition;
const
  CRwidth = 16;              {width (and height) of a small color rectangle}
  CRspace = 4;               {width of space between color rectangles}
  scroll_pos : integer = 0;  {position of vertical scroll bar}
  nBasicPar     = 22;        {number of basic parameters}
  phThicknRow   = 21;        {row for thickness of phase circles}
  ForwardRow    = 22;        {row with the text 'forward'}
  fwNameRow     = 23;        {name of the forward load zone}
  fwMVARow      = 24;        {forward apparent power row}
  fwPosAngleRow = 25;        {forward positive load angle row}
  fwNegAngleRow = 26;        {forward negative load angle row}
  fwColorRow    = 27;        {row for selecting the color of forward line}
  fwThicknRow   = 28;        {forward line thickness row}
  ReverseRow    = 29;        {row with the text 'reverse'}
  rvNameRow     = 30;        {name of the reverse load zone}
  rvMVARow      = 31;        {reverse apparent power row}
  rvPosAngleRow = 32;        {reverse positive load angle row}
  rvNegAngleRow = 33;        {reverse negative load angle row}
  rvColorRow    = 34;        {color row of reverse line}
  rvThicknRow   = 35;        {reverse line thickness row}
  Zone6Row      = 36;        {title row for zone 6}
  z6NameRow     = 37;        {row for name (identifier)}
  z6TopRow      = 38;        {top reactance}
  z6BotRow      = 39;        {bottom reactance}
  z6RightRow    = 40;        {right resistance}
  z6LeftRow     = 41;        {left resistance}
  z6ColorRow    = 42;        {color of the line}
  z6ThicknRow   = 43;        {line thickness}
  Zone5Row      = 44;        {title row for zone 6}
  z5NameRow     = 45;        {row for name (identifier)}
  z5TopRow      = 46;        {top reactance}
  z5BotRow      = 47;        {bottom reactance}
  z5RightRow    = 48;        {right resistance}
  z5LeftRow     = 49;        {left resistance}
  z5ColorRow    = 50;        {color of the line}
  z5ThicknRow   = 51;        {line thickness}
  {52 : spare}
  parGroupRow   = 53;        {index for parameter group}
  {for y-coordinate, not available for the user}
  fwIDyRow      = 54;        {row for saving y of forward ID}
  rvIDyRow      = 55;        {row for saving y of reverse ID}
  z6IDyRow      = 56;        {row for saving y of zone 6 ID}
  z5IDyRow      = 57;        {row for saving y of zone 5 ID}
  grThicknRow   = 58;        {row for thickness of ground circles}
  xxc = 80;                  {size of the corner with symbols}
  nLDit         = 10;        {number of data items for one line marker}
  nPDit         = 8;         {number of data items for one line marker}

var
  xxx     : integer;

{$R *.DFM}

function DistHiddenRow(irow : integer): boolean;
{checks is the given index a row of hidden parameters, not to be shown
 NOTE  index irow starts at zero}
var
  bpu : boolean;  {temporary}
begin
  bpu := (irow = fwNameRow)  or
         (irow = rvNameRow)  or
         (irow = ForwardRow) or
         (irow = ReverseRow) or
         (irow = Zone6Row)   or
         (irow = z6NameRow)  or
         (irow = Zone5Row)   or
         (irow = z5NameRow)  or
         (irow > z5ThicknRow);
  DistHiddenRow := bpu;
end;

procedure TDistrel.FormCreate(Sender: TObject);
var
  ii    : integer;
  y0,y1 : integer;
begin
  Dist := TDist.create;         {create object for procedures}
  Dist.Initialize(@ApplyBut,@CancelBut, @HintBut, @OKBut,@MhoGrid,@Distrel,@DistChar,
                  @ImpedEdit,@TitleEdit,@Warnedit,@Imagoo.MatMemo,@DummyImage,
                  @IDImage, @ImagePanel,
                  @ThicknessPanel,@ThicknessImage,@AutoManMenu);
  Dist.width_old := DistRel.width;   {save original width}
 {set size etc. of the prameter grid}
  with MhoGrid do begin
    height := DefaultRowHeight*RowCount+GridLineWidth*(RowCount+3);
    width := {ColCount}2*DefaultColWidth;
    cells[0, 0] := 'Ko mag';
    cells[0, 1] := 'Ko ang';
    cells[0, 2] := 'Zang';
    cells[0, 3] := 'Z1mag(21)';
    cells[0, 4] := 'Z2mag(21)';
    cells[0, 5] := 'Z3mag(21)';
    cells[0, 6] := 'Z4mag(21)';
    cells[0, 7] := 'T1(21)';
    cells[0, 8] := 'T2(21)';
    cells[0, 9] := 'T3(21)';
    cells[0,10] := 'T4(21)';
    cells[0,11] := 'Z1mag(21N)';
    cells[0,12] := 'Z2mag(21N)';
    cells[0,13] := 'Z3mag(21N)';
    cells[0,14] := 'Z4mag(21N)';
    cells[0,15] := 'T1(21N)';
    cells[0,16] := 'T2(21N)';
    cells[0,17] := 'T3(21N)';
    cells[0,18] := 'T4(21N)';
    cells[0,19] := '|Z line|';
    cells[0,20] := ' line';
    cells[0,21] := ' thickness';
    {continues below...}
  end;
  Dist.GridTotHeight := MhoGrid.height;
  Dist.CharNomTop := DistChar.top;
  Dist.ButNomTop := OKBut.top;
  Dist.FormNomHeight := height; {onko oikein?}
  Dist.GridNomHeight := MhoGrid.DefaultRowHeight*nBasicPar+
                        MhoGrid.GridLineWidth*(nBasicPar+3);
  Dist.PutImpedZoneRows(phThicknRow,grThicknRow);  {rows for impedance zones}
  Dist.PutNameRows(fwNameRow,rvNameRow);     {rows for the names of the load zones}
  Dist.PutParGroupRow(parGroupRow);          {index for the parameter group}
  Dist.PutfwIDRows(forwardRow,fwIDyRow);     {rows for the coordinates of the ID}
  Dist.PutrvIDRows(reverseRow,rvIDyRow);
  Dist.PutLineRows(fwColorRow,rvColorRow,fwThicknRow,rvThicknRow);
  Dist.PutLoadZoneRows(fwMVARow,fwPosAngleRow,fwNegAngleRow,
                       rvMVARow,rvPosAngleRow,rvNegAngleRow);
  Dist.Putz6Rows(z6NameRow,z6TopRow,z6BotRow,z6RightRow,z6LeftRow,
                 z6ColorRow,z6ThicknRow,Zone6Row,z6IDyRow);
  Dist.Putz5Rows(z5NameRow,z5TopRow,z5BotRow,z5RightRow,z5LeftRow,
                 z5ColorRow,z5ThicknRow,Zone5Row,z5IDyRow);
  Dist.ParameterTexts;     {texts to the grid for the load zones and out of step zones}
  Dist.PutParGroupMenus(@GroupMenu,@IncMenu,@DecMenu);
  for ii := 0 to MhoGrid.RowCount-1 do begin
    MhoGrid.cells[1,ii] := '0';
  end;
  {set height of form}
  height := MhoGrid.DefaultRowHeight*nBasicPar+
            MhoGrid.GridLineWidth*(nBasicPar+3)+height-ClientHeight+30;
  {pointers to form and components as integers}
  Dist.pointeg[1] := longint(@DistRel);          {form}
  Dist.pointeg[2] := longint(@DistRel.MhoGrid);  {parameter grid}
  Dist.pointeg[3] := longint(@DistRel.DistChar); {picture of characteristic}
  {put the picture to the right of the parameters}
  DistChar.left := MhoGrid.left+MhoGrid.width+ResetBut.width{8};
  {initially, no picture}
  DistChar.picture := nil;
  DistChar.width := 1;
  DistChar.height := 1;
  {initialize the marker image}
  MarkImage.top := MhoGrid.top+3*MhoGrid.DefaultRowHeight+4*MhoGrid.GridLineWidth;
  MarkImage.height := 8*(MhoGrid.DefaultRowHeight+MhoGrid.GridLineWidth);
  MarkImage.left := MhoGrid.left+2*MhoGrid.DefaultColWidth;
  y0 := 0;
  y1 := MhoGrid.DefaultRowHeight+MhoGrid.GridLineWidth;
  for ii := 1 to 8 do begin
    {use zone colors for each row}
    if      (ii = 1) or (ii = 5) then MarkImage.canvas.pen.color := Zone1Color
    else if (ii = 2) or (ii = 6) then MarkImage.canvas.pen.color := Zone2Color
    else if (ii = 3) or (ii = 7) then MarkImage.canvas.pen.color := Zone3Color
    else if (ii = 4) or (ii = 8) then MarkImage.canvas.pen.color := Zone4Color;
    if (ii <= 4) then begin
      MarkImage.canvas.brush.color := MarkImage.canvas.pen.color;
      MarkImage.canvas.brush.style := bsSolid;
    end else begin
      MarkImage.canvas.brush.style := bsClear;
    end;
    MarkImage.canvas.rectangle(0,y0,MarkImage.width,y1);
    y0 := y1;
    y1 := y1+MhoGrid.DefaultRowHeight+MhoGrid.GridLineWidth;
  end;
  MarkImage.BringToFront;
  {initial directory for saving the graphics}
  if (SetComp.Mho_Dir <> '') then ExportDialog.InitialDir := SetComp.Mho_Dir;
  {initialize the edit for the title (or caption)}
  TitleEdit.top := DistChar.top;
  TitleEdit.left := DistChar.left+64;
  TitleEdit.tag := 0;       {distance from top of DistChar}
  TitleEdit.BringToFront;
  DummyImage.canvas.font.name := TitleEdit.font.name;
  DummyImage.canvas.font.size := TitleEdit.font.size;
  {prepare image for selecting the colors}
  {PQForm.}ColorInitialize(@ColorImage);
  {size and initial position of the color panel}
  ImagePanel.width := ColorImage.width+2*CRspace;
  ImagePanel.height := ImagePanel.width;
  ImagePanel.left := MhoGrid.left+MhoGrid.width;
  {prepare image for selecting the line thcknesses}
  Dist.PrepareThicknessPanel;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'d';
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'O';
  {initialize position of origo}
  Dist.PutOrig(0.5,0.5);
end;

procedure TDist.ParameterTexts;
{set the texts to the grid for the Load zone and out of zones}
begin
  with pGrid^ do begin
    cells[0,fwIDxRow_d]   := 'Load Zone';
    cells[0,fwNameR_d]    := '  name';
    cells[0,fwMVARow_d ]  := '  MVA';
    cells[0,fwPosARow_d]  := '+ load angle';
    cells[0,fwNegARow_d]  := '- load angle';
    cells[0,fwColRow_d]   := '  line color';
    cells[0,fwThRow_d]    := '  thickn. 0..4';
    cells[0,rvNameR_d]    := '  name';
    cells[0,rvMVARow_d]   := '  MVA';
    cells[0,rvPosARow_d]  := '+ load angle';
    cells[0,rvNegARow_d]  := '- load angle';
    cells[0,rvColRow_d]   := '  line color';
    cells[0,rvThRow_d]    := '  thickn. 0..4';
    {out of step characteristics}
    cells[0,z6IDxRow_d]   := 'Out of step';
    cells[0,z6NameRow_d]  := '  name';         {row for name (identifier)}
    cells[0,z6TopRow_d]   := '  top react.';   {top reactance}
    cells[0,z6BotRow_d]   := '  bottom react'; {bottom reactance}
    cells[0,z6RightRow_d] := '  right resist'; {right resistance}
    cells[0,z6LeftRow_d]  := '  left resist';  {left resistance}
    cells[0,z6ColRow_d]   := '  line color';   {color of the line}
    cells[0,z6ThRow_d]    := '  thickn. 0..4'; {line thickness}
    cells[0,z5IDxRow_d]   := '  ';             {title row for zone 6}
    cells[0,z5NameRow_d]  := '  name';         {row for name (identifier)}
    cells[0,z5TopRow_d]   := '  top react';    {top reactance}
    cells[0,z5BotRow_d]   := '  bottom react'; {bottom reactance}
    cells[0,z5RightRow_d] := '  right resist'; {right resistance}
    cells[0,z5LeftRow_d]  := '  left resist';  {left resistance}
    cells[0,z5ColRow_d]   := '  line color';   {color of the line}
    cells[0,z5ThRow_d]    := '  thickn. 0..4'; {line thickness}
  end;
end;

procedure TDist.PrepareThicknessPanel;
{draw the lines of different colors and thicknesses on the image
 set the size of the image and panel}
var
  ii,jj : integer;
  ix,iy : integer;   {coordinates}
  color : Tcolor;    {color of the line}
begin
  {set the size of the image and the panel}
  pThImage^.width := 5*thwid_d+thspc_d;
  pThImage^.height := 5*thhei_d+5*thspc_d;
  pThImage^.top := thspc_d;
  pThImage^.left := thspc_d;
  pThPanel.width := pThImage^.width+2*thspc_d;
  pThPanel.height := pThImage^.height+2*thspc_d;
  {set properties of pen and brush}
  pThImage^.canvas.pen.width := 1;
  pThImage^.canvas.brush.style := bsSolid;
  {draw the lines}
  for jj := 1 to 5 do begin         {flour zones and the line}
    if      (jj = 1) then color := Zone1Color
    else if (jj = 2) then color := Zone2Color
    else if (jj = 3) then color := Zone3Color
    else if (jj = 4) then color := Zone4Color
    else                  color := clBlue;
    iy := (jj-1)*(thhei_d+thspc_d)+(thspc_d div 2);    {y-coord. of the line-image}
    {must do some trick, otherwise the "pen.style := psDot" does not work !?}
    pThImage^.canvas.pen.color := clWhite;
    pThImage^.canvas.brush.color := clWhite;
    pThImage^.canvas.rectangle(0,iy,2,iy+2);
    {end of trick}
    for ii := 1 to 5 do begin             {the thicknesses of the line}
      ix := ii*thwid_d-(thwid_d div 2);       {x-coord of the line}
      if (ii = 1) then begin              {1 = dotted line}
        pThImage^.canvas.pen.style := psDot;
        pThImage^.canvas.pen.color := color;
        pThImage^.canvas.moveto(ix,iy);
        pThImage^.canvas.lineto(ix,iy+thhei_d);
      end else begin
        pThImage^.canvas.brush.color := color;               {fill with the same color}
        pThImage^.canvas.pen.style := psSolid;
        pThImage^.canvas.rectangle(ix,iy,ix+ii-1,iy+thhei_d);  {lines as rectangles}
      end;
    end;
  end;
  {put the panel near to the thickness row}
  pThPanel^.left := pGrid^.left+pGrid^.width;
  pThPanel^.top := pGrid^.top+
     phThRow_d*(pGrid^.DefaultRowHeight+pGrid^.GridLineWidth)-
     (pThPanel^.height div 2);
end;

procedure TDist.DecodeThickness(var th1,th2,th3,th4,th5 : integer);
{the thicknesses are encoded in one number using " base 5"
 th1..th5  the thicknesses of lines 1..5}
var
  apu    : single;  {temporary}
  enth   : integer; {endoced thicknesses}
  ipu    : integer; {temporary}
  sum    : integer; {sum of encoded thicknesses}
begin
  if (phase_d) then                     {phase relay}
    pActRel^.GetPar(phThRow_d+1,apu)    {the encoded thicknesses, as a parameter, as single}
  else                                  {ground relay}
    pActRel^.GetPar(grThRow_d+1,apu);
  enth := round(apu);           {to integer}
  ipu := enth div 625;
  if (ipu < 0) then th5 := 0 else if (ipu <= 4) then th5 := ipu else th5 := 4;
  sum := ipu*625;
  ipu := (enth-sum) div 125;
  if (ipu < 0) then th4 := 0 else if (ipu <= 4) then th4 := ipu else th4 := 4;
  sum := sum+ipu*125;
  ipu := (enth-sum) div 25;
  if (ipu < 0) then th3 := 0 else if (ipu <= 4) then th3 := ipu else th3 := 4;
  sum := sum+ipu*25;
  ipu := (enth-sum) div 5;
  if (ipu < 0) then th2 := 0 else if (ipu <= 4) then th2 := ipu else th2 := 4;
  sum := sum+ipu*5;
  ipu := enth-sum;
  if (ipu < 0) then th1 := 0 else if (ipu <= 4) then th1 := ipu else th1 := 4;
end;

procedure TDist.EncodeThickness(th1,th2,th3,th4,th5 : integer);
{encode the thicknesses by using "base 5"}
var
  apu : single;
  ipu : integer;
begin
  ipu := th1+5*th2+25*th3+125*th4+625*th5;
  apu := ipu;
  if (phase_d) then begin                        {phase relay}
    pActRel^.PutPar(phThRow_d+1,apu);            {save as a parameter}
    pGrid^.Cells[1,phThRow_d] := inttostr(ipu);  {save as string in grid}
  end else begin                                 {ground relay}
    pActRel^.PutPar(grThRow_d+1,apu);            {save as a parameter}
    pGrid^.Cells[1,grThRow_d] := inttostr(ipu);  {save as string in grid}
  end;
end;

procedure TDist.SetPhaseGround(phase : boolean);
{set the phase relay / ground relay flag}
begin
  phase_d := phase;
end;

procedure  TDist.ThicknessImageMouseUp(x,y : integer);
{select the zone and the line thickess corresponding to the mouse coordinates x and y}
var
  dx,dy   : integer;      {dimensions of the area for one line type}
  iline   : integer;      {index of line}
  ithic   : integer;      {index for line thickness}
  thc     : array[1..5] of integer;      {line thickness}
begin
  dx := thwid_d;         {the area for one line type}
  dy := thhei_d+thspc_d;
  iline := (y div dy)+1; {index of line}
  if (iline > 5) then iline := 5;
  ithic := (x div dx);   {index of thickness}
  if (ithic > 4) then ithic := 4;
  {decode the present line thicknesses}
  DecodeThickness(thc[1],thc[2],thc[3],thc[4],thc[5]);
  {replace with the new thickness}
  thc[iline] := ithic;
  {encode and save back}
  EncodeThickness(thc[1],thc[2],thc[3],thc[4],thc[5]);
end;

procedure TDist.ClearDistChar(toile: TCanvas);
{draw a white rectangle}
begin
  toile.pen.color := clWhite;
  toile.brush.color := clWhite;
  toile.brush.style := bsSolid;
  toile.Rectangle(0,0,pChar^.width,pChar^.height);
end;

procedure TDist.PutOhmCoord(Rx, Ry, Xx, Xy: integer);
{put the coordinates of the "Ohm"-markers to private variables
 Rx,Ry   coordinates of Ohm near to the R-axis
 Xx,Xy   coordinates of Ohm near to the X-axis}
begin
  OhmRx_d := Rx;
  OhmRy_d := Ry;
  OhmXx_d := Xx;
  OhmXy_d := Xy;
end;

procedure DrawMhoChar(scale,mag,alpha : single; color : TColor; thc: integer; toile :TCanvas);
{draw a circular char. of distance relay, as
 scale  max R = max X = min -R = min -X
        width of char = height of char = 2*scale
 mag    magnitude = diameter
 alpha  "tilting" angle, in degrees, 0 = points right, 90 = points up
 color  the color of the characteristic
 thc    pen width (line thickness), if = 0, then dotted
 toile  the canvas on which drawn}
var
  alfrad    : single;  {alpha in radians}
  apu       : single;  {temporary}
  ix1,iy1   : integer; {upper left corner of the rectangle containing the circle}
  ix2,iy2   : integer; {lower right corner}
  Rmax,Rmin : single;  {max, min R}
  Xmax,Xmin : single;  {max, min X}
begin
  if (mag <> 0) and (scale > 0) then begin   {reasonable magnitude and scale}
    alfrad := alpha*pi/180;
    Rmax := 0.5*mag*( 1+cos(alfrad));
    Rmin := 0.5*mag*(-1+cos(alfrad));
    Xmax := 0.5*mag*( 1+sin(alfrad));
    Xmin := 0.5*mag*(-1+sin(alfrad));
    apu := DistRel.DistChar.width*Rmax/(2*scale);
    ix2 := (DistRel.DistChar.width div 2)+round(apu);
    apu := DistRel.DistChar.width*Rmin/(2*scale);
    ix1 := (DistRel.DistChar.width div 2)+round(apu);
    apu := DistRel.DistChar.width*Xmax/(2*scale);
    iy1 := (DistRel.DistChar.width div 2)-round(apu);
    apu := DistRel.DistChar.width*Xmin/(2*scale);
    iy2 := (DistRel.DistChar.width div 2)-round(apu);
    if (thc = 0) then begin
      toile.pen.width := 1;
      toile.pen.style := psDot;  {dotted line}
    end else begin
      toile.pen.width := thc;
      toile.pen.style := psSolid;
    end;
    toile.pen.color := color;
    toile.Brush.style := bsClear;
    toile.ellipse(ix1,iy1,ix2,iy2);
  end;
end;

function TDist.pDistrel : TpForm;
{get the pointer to the form}
begin
  pDistrel := TpForm(pointeg[1]);
end;

function TDist.pDistGrid : TpGrid;
{get the pointer to the string grid for the parameters}
begin
  pDistGrid := TpGrid(pointeg[2]);
end;

function  TDist.pDistImpEd : TpEdit;
{get the pointer to the edit for the cursor position}
begin
  pDistImpEd := pImpEdit;
end;

function  TDist.pDistNotes : TpMemo;
{get the pointer to the memo for notes}
begin
  pDistNotes := pNotes;
end;

function TDist.pdistChar : TpImage;
{get the pointer to the characteristics}
begin
  pDistChar := TpImage(pointeg[3]);
end;

function  TDist.pDummyImg  : TpImage;
{get the pointer to the dummy image}
begin
  pDummyImg := pDimage;
end;

function TDist.pTitleEdit : TpEdit;
{get the pointer to the edit for the title}
begin
  pTitleEdit := pTitle;
end;


procedure TDist.Initialize(pApply,pCancel, pHint, pOK : TpButton; pStrGrid : TpGrid;
                           pDForm : TpForm; pDChar : TpImage; pImpEd, pTitlEd,pWarnEd : TpEdit;
                           pNMemo : TpMemo; pDumImg, pMrkID : TpImage;
                           pImgPnl,pThPnl : TpPanel; pThImg : TpImage; pMenuAM: TpMenuItem);
begin
  pApplyBut := pApply;
  pCancelBut := pCancel;
  pHintBut := pHint;
  pOKBut := pOK;
  pGrid := pStrGrid;
  pForm := pDForm;
  pChar := pDChar;
  pImpEdit := pImpEd;
  pTitle := pTitlEd;
  pNotes := pNMemo;
  pDimage := pDumImg;
  pMarkerID := pMrkID;
  pImgPanel := pImgPnl;
  pThPanel := pThpnl;
  pThImage := pThImg;
  pAMmenu := pMenuAM;
  pWarnEdit := pWarnEd;
  modscale := 0;        {factor for changing the scale}
  TooSmall := false;    {flag for too small a scale}
  pActRel := nil;
  clGrid := clSilver;   {initialize grid color}
  ClrChange := false;   {no color change yet}
  owid := pChar^.width;
  thwid_d := 16;         {for line thckness sub-images}
  thhei_d := 12;
  thspc_d := 4;
  {initialize the size of the memo for the notes}
  pNotes^.width := 340;
  pNotes^.height := 128;
  scale := 10;           {some value initially}
end;

function  TDist.GetActRel : TPComp;
begin
  GetActRel := pActRel;
end;

procedure TDist.GetOldWidth(var oldw : integer);
{get the old, stored width of the distrel form}
begin
  oldw := width_old;
end;

procedure TDist.PutOldWidth(oldw : integer);
{save the old width of the distrel form}
begin
  width_old := oldw;
end;

procedure TDist.SaveActRelay(pComp : TpComp);
{save pointer to the relay with data shown}
begin
  pActRel := pComp;
  pForm^.tag := longint(pComp);  {save also as integer}
end;

procedure TDist.FromGridToParamGroup;
{copy the parameters in the grid to the present group, as strings}
var
  igrp   : integer;     {the index of the present parameter group}
  ii     : integer;
  npar   : integer;     {number of parameters}
  pComp  : TpComp;      {pointer to the relay}
  strpar : string;      {all parameters as a string}
begin
  pComp := GetActRel;
  pComp^.GetNpar(npar);        {get no of parameters}
  igrp := ParamGroupIndex;     {the present parameter group}
  strpar := '';                {initialize}
  if (pGrid^.RowCount >= npar) and (npar > 0) then begin
    for ii:=1 to npar do begin
      strpar := strpar+pGrid^.Cells[1,ii-1]+';';
    end;
    pComp^.PutStringPar(strpar,igrp);    {save the parameters as a string}
  end;
end;

procedure TDist.FromParamGroupToGrid(igrp: integer);
{move parameters from group igrp to the grid}
var
  ii    : integer;
  len   : integer;  {length of a string}
  line  : string;   {the parameters as a string}
  npar  : integer;  {number of parameters}
  pComp : TpComp;   {pointer to the relay}
  st1   : string;   {temporary}
begin
  if (igrp > 0) and (igrp <= gParSet) then begin
    pComp := GetActRel;
    pComp^.GetStringPar(line,igrp);   {parameters as a string}
    len := length(line);
    pComp^.GetNpar(npar);             {get no of parameters}
    if (len > 0) then begin           {there are some data}
      for ii := 1 to npar do begin
        ExtractParam(ii,';',line,st1);  {in routines.pas}
        pGrid^.Cells[1,ii-1] := st1;
      end;
    end else begin                    {data missing, fill with zeroes}
      for ii := 1 to npar do begin
        pGrid^.Cells[1,ii-1] := '0';
      end;
    end;
  end;
end;

procedure TDist.FromParamGroupToComp(igrp: integer; pComp: TpComp);
{move parameters from group igrp to the component pComp}
{NOTE although this is a procedure of TDist, the relay must be given as input,
      because this procedure is used (potentionally) for all distance relays,
      not only that one of the form}
var
  apu     : single;   {temporary}
  errc    : integer;  {error flag}
  ii      : integer;
  ipu     : integer;  {temporary}
  len     : integer;  {length of a string}
  line    : string;   {the parameters as a string}
  ll      : longint;  {temporary}
  npar    : integer;  {number of parameters}
  par     : single;   {parameter}
  pSet    : TpCompSet;{poitner to the common}
  str     : string;   {temporary}
  strpar  : string;   {string parameters as one string}
  txt     : string;
begin
  if (igrp > 0) and (igrp <= gParSet) then begin
    pComp^.GetStringPar(line,igrp);   {parameters as a string}
    len := length(line);
    pComp^.GetNpar(npar);             {get no of parameters}
    strpar := '';
    if (len > 0) then begin           {there are some data}
      for ii := 1 to npar do begin
        ExtractParam(ii,';',line,txt);   {one parameter as string, in routines.pas}
        {string parameters are saved together, separately from numerical parameters}
        if (ii-1 = fwNameR_d  ) or (ii-1 = rvNameR_d  ) or
           (ii-1 = z6NameRow_d) or (ii-1 = z5NameRow_d) then begin  {string ?}
          strpar := strpar+txt+';';    {add name to string of all string-parameters}
          pComp^.putpar(ii,Improbg);   {special value as a flag}
        end else begin
          {numerical parameter, change string to numerical, with some checks}
          NextValueFromLine(txt,1,ipu, par, str, errc);
          if (errc = 0) then
            pComp^.putpar(ii,par);     {save the parameter to the component}
        end;
      end;
      pComp^.PutStringPar(strpar,0);   {save the string parameters}
      {save the group index}
      apu := igrp;
      pComp^.PutPar(parGrRow_d+1,apu);
      {write the group on the relay, or, actually, on the current trafo}
      pComp^.GetipSet(ll);
      pSet := TpCompSet(ll);
      pSet^.WriteGroupIndex(pComp);       {in skemadef.pas}
    end;
  end;
end;

procedure TDist.FromCompToGrid(pComp: TpComp);
{move parameters from component to the grid
 pComp  pointer to the component}
var
  apu    : single;    {temporary}
  ii,jj  : integer;   {index}
  ipu    : integer;   {temporary}
  ir     : integer;   {row index}
  istr   : integer;   {counts string parameters}
  lenstr : integer;   {length of string}
  npar   : integer;   {number of parameters}
  str    : string;    {temporary}
  strpar : string;    {string parameters as one string}
  txt    : string;    {temporary}
begin
  {show  parameters on a separate form}
  pComp^.GetNpar(npar);              {no of parameters}
  if (pGrid^.RowCount >= npar) then begin
    pComp^.GetStringPar(strpar,0);     {string parameters in one string}
    istr := 0;
    for ii:= 1 to npar do begin
      pComp^.Getpar(ii,apu);          {get value of parameter i}
      if (apu = improbg) then begin  {flag for string-parameter}
        inc(istr);                   {count string parameters}
        ExtractParam(istr,';',strpar,str);  {get string parameter, in routines.pas}
        txt := '';
        lenstr := length(str);
        if (lenstr > 0) then begin   {there is some string}
          for jj := 1 to lenstr do txt := txt+str[jj];
        end;
      end else begin                 {numerical parameter}
        RemoveSpaces(apu,txt);       {format, and remove spaces, in routines.pas}
      end;
      pGrid^.Cells[1,ii-1] := txt;    {parameter to grid}
      spare[ii-1] := txt;             {save parameters temporarily, for "cancel"}
    end;
    {check the index of the parameter group}
    ipu := GetGroupIndex;
    if (ipu <= 0) or (ipu > gParSet) then begin
      ir := GetGroupIndexRow;
      PutGroupIndex(1);
      pGrid^.Cells[1,ir] := '1';    {parameter to grid}
      spare[ir] := '1';      {save parameters temporarily, for "cancel"}
      ipu := 1;
    end;
    {display also the group index}
    ShowGroupCaption(ipu);
  end;
end;

procedure TDist.ShowGroupCaption(igrp: integer);
{display the group index in the menubar as a caption}
begin
  if (igrp = 1) then
    pGrpCaption^.caption := 'group '+inttostr(igrp)
  else
    pGrpCaption^.caption := 'GROUP '+inttostr(igrp);
end;

procedure TDist.PutAMcaption(AorM: char);
{show the auto/man mode as caption of the menu}
begin
  pAMmenu^.caption := AorM;
end;

procedure TDist.FromGridToParam(Sender: Tobject);
{move parameters values in the grid to parameters of the component}
var
  apu,apv : single;   {temporary}
  apw,apx : single;   {temporary}
  errc    : integer;  {error flag}
  i,ii    : integer;  {index}
  line    : string;   {temporary}
  npar    : integer;  {number of parameters}
  oldval  : single;   {old value of parameter}
  pComp   : TpComp;   {pointer to the relay}
  st1,st2 : string;   {temporary}
  st3,st4 : string;   {temporary}
  strpar  : string;   {all string parameters in one string}
begin
  pComp := GetActRel;
  pComp^.GetNpar(npar);        {get no of parameters}
  if (pGrid^.RowCount >= npar) and (npar > 0) then begin
    strpar := '';              {initialize}
    for i:=1 to npar do begin
      line := pGrid^.Cells[1,i-1];
      {save for next (eventual) "cancel"}
      if (Sender <> pApplyBut^) then spare[i-1] := line;
      if (i-1 = fwNameR_d) or (i-1 = rvNameR_d) or
         (i-1 = z6NameRow_d) or (i-1 = z5NameRow_d) then begin  {string ?}
        strpar := strpar+line+';';   {add name to string of all string-parameters}
        pComp^.putpar(i,Improbg);    {special value as a flag}
      end else begin
        ValuesFromLine(line,1,true,ii, apu,apv,apw,apx,st1,st2,st3,st4,errc); {one parameter a time}
        {set error flag, it is checked and reset in TCompSet.FormMouseDown}
        if (errc <> 0) then begin
          SetComp.err_cs := 1;
        end else begin
          pComp^.getpar(i,oldval);       {get the old value, for comparisons}
          pComp^.putpar(i,apu);          {save the parameter to the component}
          if (oldval <> apu) then SetComp.IsChanged := true; {flag the change}
        end;
      end;
    end;
    pComp^.PutStringPar(strpar,0);
  end;
end;

procedure TDist.FormDeactivate(Sender: TObject);
var
  apu,apv : single;   {temporary}
  apw,apx : single;   {temporary}
  errc    : integer;  {error flag}
  i,ii    : integer;  {indices, temporary}
  inHelp  : boolean;  {true, when clicking the help-memo}
  ipComp  : longint;  {pointer to the component as integer}
  ipSet   : longint;  {pointer to the common as integer}
  line    : string;   {temporary text}
  npar    : integer;  {no of parameters}
  oldval  : single;   {old value of parameter}
  pComp   : TpComp;   {pointer to the (active) component}
  pHelp   : TpMemo;   {pointer to the help memo}
  pMod    : TpElComp; {pointer to the model component}
  strpar  : string;   {all string-parameters in one string}
  st1,st2 : string;   {temporary}
  st3,st4 : string;   {temporary}
  txt     : string;   {temporary}
  xy,xysc : Tpoint;   {mouse coordinates}
begin
  inHelp := false;
  {check first that the help-memo was not clicked}
  if (not {SetComp.}appl_close) then begin  {not when closing}
    if (GetActRel <> nil) then begin
      GetActRel.GetpMod(pMod);         {pointer to the model component}
      if (pMod <> nil) then begin
        pMod^.GetpHelp(pHelp);         {pointer to the help memo}
        if (pHelp <> nil) then begin
          if (pHelp^.visible) then begin
            GetCursorPos(xysc);        {mouse position in screen coordinates}
            xy := Imagoo.ScreentoClient(xysc);  {position in coord. of imagoo-form}
            if (xy.x >= pHelp^.left) and (xy.x <= pHelp^.left+pHelp^.width) and
               (xy.y >= pHelp^.top ) and (xy.y <= pHelp^.top+pHelp^.height) then
               inHelp := true
            else inHelp := false;
          end else begin
            inHelp := false;
          end;
        end else begin
          inHelp := false;
        end;
      end else begin
        inHelp := false;
      end;
    end else begin
      inHelp := false;
    end;
  end;
{  Application.Processmessages;    {gives time for the "help_click" and copy-click to change}
  if (not {SetComp.}appl_close) and (not inHelp) and {must not do this, when deleting..}
     (not SetComp.copy_click)  and                   {..help visible, or copying}
     (not ConditionForm.visible) then begin          {editing conditions for param.group change}
    pComp := GetActRel;                     {get the active component}
    if (pComp <> nil) then begin            {a component active}
      pComp^.Getipset(ipset);               {pointer to the common, as iteger}
      if (Sender = pCancelBut^) then begin    {restore old parameters}
        ipComp := longint(pComp);
        pComp^.GetNpar(npar);              {no of parameters}
        {return the original parameters (original text)}
        strpar := '';
        if (pGrid^.RowCount >= npar) then begin
          for i:= 1 to npar do begin
            txt := spare[i-1];                              {saved, old parameter}
            pGrid^.Cells[1,i-1] := txt;                     {restore parameter from next column}
            if (i-1 = fwNameR_d) or (i-1 = rvNameR_d) or
               (i-1 = z6NameRow_d) or (i-1 = z5NameRow_d) then begin  {string ?}
              strpar := strpar+txt+';';    {add name to string of all string-parameters}
              pComp^.putpar(i,Improbg);    {special value as a flag}
            end else begin
              ValuesFromLine(txt,1,true,ii, apu,apv,apw,apx,st1,st2,st3,st4,errc); {one parameter a time}
              if (errc = 0) then pComp^.putpar(i,apu);        {save the parameter to the component}
            end;
          end;
        end;
        pComp^.PutStringPar(strpar,0);
(*      {save coordinates of the "ohm"-marks}    NOT needed here, saved in MouseUpAtID
        line := inttostr(ohmRx_d)+' '+inttostr(ohmRy_d)+' '+
                inttostr(ohmXx_d)+' '+inttostr(ohmXy_d);     {change to a string}
        pComp^.PutDescrQ(2,'',line,'');   {save as description Q2}  *)
        CalculateAndHide(ipComp);
{       unmark(ipset);  {copy-paste works, when no unmark here}
      end else if (Sender = pHintBut^) then begin
        {do nothing}
      end else begin
        {must not do this, when deleting! or when help memo visible...
         ...(otherwise memo disappears)}
{       if (not SetComp.appl_close) and (not helpvis) then begin}
        FromGridToParam(Sender);       {parameter values from the grid to param. of the component}
        ipComp := longint(pComp);
        CalculateAndHide(ipComp);
        {unmark the component, but not after apply-button}
        if (pComp^.var2_s <> 3) then unmark(ipset); {copy-paste works when no unmark here}
{       end;}
      end;
      {set to non-edit row to prevent resetting the scroll bar}
      if (RowVisible(fwIDxRow_d)) then pGrid^.row := fwIDxRow_d
      else if (RowVisible(rvIDxRow_d)) then pGrid^.row := rvIDxRow_d
      else if (RowVisible(z6IDxRow_d)) then pGrid^.row := z6IDxRow_d
      else if (RowVisible(z5IDxRow_d)) then pGrid^.row := z5IDxRow_d;
      {if in auto mode, and param.group changed manually, change back}
      if (pAMmenu^.caption = 'A') then begin
        if (ParSetInd_d <> GetGroupIndex) then begin  {changed manually}
          ChangeParamGroup(inttostr(ParSetInd_d));    {change back}
        end;
      end;
    end;
  end;
  if ((sender as Tcomponent).name <> 'ApplyBut') and
     ((sender as Tcomponent).name <> 'OKBut')   then
    pWarnEdit^.visible := false;
end;

procedure TDist.FormPaint;
{keep the characteristics visible during scrolling}
var
  ipu,ipv,ipw : integer;
  Dtop        : integer;
begin
  ipu := pForm^.width-pGrid^.width-16-scroll_width;  {available width, for the square image}
  ipv := pForm^.ClientHeight;           {available height}
  if (ipu < ipv) then
    ipw := ipu    {available width smaller than available height}
  else
    ipw := ipv;   {available height smaller than available width}
  ipu := ipw-pChar^.height-(FormNomHeight-GridNomHeight);
  ipv := pGrid^.top+GridNomHeight-pChar^.height;
  if (ipu < ipv) then Dtop := ipu else Dtop := ipv;
  if (Dtop < CharNomTop) then pChar^.top := CharNomTop
  else pChar^.top := Dtop;
  pTitle^.top := pChar^.top;
  {grid height changes when scrolling, so that lower border in place}
  ipu := pForm^.ClientHeight-pGrid^.top-pOKbut^.height;   {TARKISTA}
  if (ipu < GridTotHeight{GridNomHeight}) then pGrid^.height := ipu
  else pGrid^.height := GridTotHeight{GridNomHeight};
  {buttons immediately below the grid}
(*
  ipu := pForm^.height-(FormNomHeight-ButNomTop);
  if (ipu < ButNomTop) then pOKBut^.top := ipu
  else pOKBut^.top := ButNomTop;
*)
  ipu := pForm^.ClientHeight-pOKBut^.height;
  ipv := pGrid^.height+4;

  if (ipu < ipv) then pOKBut^.top := ipu
  else pOKBut^.top := ipv;

  pCancelBut^.top := pOKBut^.top;
  pApplyBut^.top := pOKBut^.top;
  pHintBut^.top := pOKBut^.top;
  pImpEdit^.top := pChar^.top+pChar^.height+2;
//  pNotes^.top := pImpEdit^.top+pImpEdit^.height;
end;

procedure TDist.FormResize;
var
  ipu,ipv,ipw : integer;  {temporary}
  pActR       : TpComp;   {pointer to the active relay}
begin
  if (not {SetComp.}appl_close) then begin
    {cannot adjust width after a "normal" (nonfault) calculation}
    if (SetComp.appl_op = 6 ) or (SetComp.appl_op = 7 )
    or (SetComp.appl_op = 8 ) or (SetComp.appl_op = 11) then begin
      {redraw the characteristics}
      pChar^.picture := nil;
      if (pGrid^.visible) then ipv := pGrid^.width+scroll_width else ipv := 0;
      ipu := pForm^.width-ipv{-pGrid^.width-scroll_width}-24{8};  {preliminary picture width}
{      ipw := pForm^.height-scroll_width-16-pImpedit^.height; {preliminary picture height}
      ipw := pForm^.ClientHeight-pImpedit^.height-2{-pNotes^.height};
      if (ipw < ipu) then ipu := ipw;               {select the smaller dimension}
      if (ipu > 32) then pChar^.width := ipu else pChar^.width := 32;
      pChar^.height := pChar^.width;
      {move graph to left, if parameters not visible}
      if (not pGrid^.visible) then pChar^.left := 8
      else pChar^.left := pGrid^.left+pGrid^.width+16;  {same as at initialization}
      PutOldWidth(pForm^.width);                        {save width of form}
      pActR := GetActRel;
      if (isMho(pActR)) then DrawAllMhoChar(pActR,pChar^.canvas) {redraw the characteristics}
      else DrawAllPolyChar(pActR,pChar^.canvas);
    end else begin
      pForm^.width := pGrid^.width+scroll_width+8{16};    {return the width}
    end;
(*  {show the vertical scroll bar, if needed}
    if (pForm^.ClientHeight < GridTotHeight+pOKBut^.height+8) then
      pForm^.VertScrollBar.visible := true
    else
      pForm^.VertScrollBar.visible := false; *)
    pForm^.invalidate;  {refresh the form, to get the buttons in place (for polyrel)}
  end;
end;

procedure TDistrel.FormResize(Sender: TObject);
{ - After a non-fault-calculation, hide toolbar entries etc. that are not needed
  - Keep the graph visible when scrolling}
begin
  if (not appl_close) then begin
    if (SetComp.appl_op = 6 ) or (SetComp.appl_op = 7 )
    or (SetComp.appl_op = 8 ) or (SetComp.appl_op = 11) then begin
//    distrel.ViewMenu.visible := true;
      distrel.MarkerMenu.visible := true;
//    distrel.notesmemo.visible := distrel.NotesItem.checked;
    end else begin
//    distrel.ViewMenu.visible := false;
      distrel.MarkerMenu.visible := false;
//    distrel.notesmemo.visible := false;
    end;
    Dist.FormResize;
  end;
end;

procedure TDistrel.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {eventual "delete component" must be handled here, because DistRel form has focus}
  if (SetComp.pActComp <> nil) then begin     {some component active}
    if (key = 46) then begin                  {delete-key}
      SetComp.FormKeyDown(Key, Shift);        {delete the component}
    end;
  end;
end;

procedure TDist.SelectCell(col,row : longint);
{no editing in local captions or color cells
 if color cell, display the color palette}
var
  arect : TRect;   {rectangle for determining the location of the cell}
begin
  if (row = fwIDxRow_d) or (row = rvIDxRow_d) or
     (row = fwColRow_d) or (row = rvColRow_d) or
     (row = fwIDyRow_d) or (row = rvIDyRow_d) or
     (row = z6ColRow_d) or (row = z5ColRow_d) or
     (row = z6IDxRow_d) or (row = z6IDyRow_d) or
     (row = z5IDxRow_d) or (row = z5IDyRow_d) or
     (row = phThRow_d ) or (row = grThRow_d ) or
     (row = parGrRow_d)
   then pGrid^.options := pGrid^.options-[goEditing,goAlwaysShowEditor]
   else pGrid^.options := pGrid^.options+[goEditing,goAlwaysShowEditor];
  {show the color menu, if at a color row}
  arect := pGrid^.CellRect(1,row);    {rectangle for the position of the cell}
  if (row = fwColRow_d) or (row = rvColRow_d) or
     (row = z6ColRow_d) or (row = z5ColRow_d) then begin
    pImgPanel^.top := arect.top-pForm^.vertscrollbar.position-(pImgPanel^.height div 2);
    pImgPanel^.visible := true;
    pImgPanel^.bringtofront;
  {show the line thickness row, if at the row}
  end else if (row = phThRow_d) then begin
    pThPanel^.top := arect.top-pForm^.vertscrollbar.position-(pThPanel^.height div 2);
    pThPanel^.visible := true;
    pImgPanel^.visible := false;
  end else begin
    pImgPanel^.visible := false;
    pThPanel^.visible := false;
  end;
end;

procedure TDistrel.MhoGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
var
  arect : TRect;   {rectangle for determining the location of the cell}
begin
  {mark (color) the selected cell, or not}
  if not (ColorItem.checked) then begin
    {send an "enter"-key press, to select the cell (remove the color)}
    keybd_event(VK_SHIFT, 0, 0, 0);
    keybd_event(13, 0, 0, 0);
    keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
  end;
  {no editing in local captions or color cells}
  Dist.SelectCell(col,row);
end;

procedure DistanceRelayShow;
{show the relay char and values of impedances}
begin
  DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
end;

procedure TDist.CalculateScale( zm : single{; var scale, step : single});
{calculate the scale = max. value on the axes and the step = distance
 between markings (if, for exampe scale = 100, then step might be 20,
 i.e markings are at 0, 20, 40, 60, 80 and 100
 zm  the max.value of the impedance = magnitude of characteristics}
const
  ln10 = 2.302585;  {ln(10)}
var
  apu      : single;
  decade   : single;  {the decade of impedance}
  ipu,ipv  : integer; {temporary}
  lgzm     : single;  {log(10) of impedance}
  relscale : single;  {relative scale}
  relstep  : single;  {relative step}
  relz     : single;  {relative value of the impedance, within the decade}
begin
  if (zm > 0) then begin
    lgzm := ln(zm)/ln10;           {log(10) of impedance}
    if (lgzm > 0) then apu := int(lgzm+0.001)+1 {nearest power of ten}
    else               apu := int(lgzm+0.001);
    decade := exp(apu*ln10);       {ten to nearest power of ten larger than the impedance}
    relz := 100*zm/decade;          {relative value of impedance, between 1 and 10}
    if (relz <= 11) then begin
      relstep := 2;
      relscale := round(relz+0.5);  {11 or 12}
    end else if (relz <= 15) then begin
      relstep := 5;
      relscale := round(relz+0.5); {12 .. 16}
    end else if (relz <= 20) then begin
      relstep := 5;
      relscale := 2*round(relz/2+0.5);
    end else if (relz <= 30) then begin
      relstep := 5;
      relscale := 3*round(relz/3+0.5);
    end else if (relz < 40) then begin
      relstep := 5;
      relscale := 4*round(relz/4+0.5);
    end else if (relz <=55) then begin
      relstep := 10;
      relscale := 6*round(relz/6+0.5);
    end else if (relz <=75) then begin
      relstep := 10;
      relscale := 8*round(relz/8+0.5);
    end else begin
      relstep := 20;
      relscale := 10*round(relz/10+0.5);
    end;
    scale := 0.01*decade*relscale;
    step := 0.01*decade*relstep;
    {set flag, if scale too small}
    TooSmall := (scale < 0.051);
  end else begin
    scale := 10;          {just some value}
    step := 2;
  end;
end;

procedure TDist.DrawImpedances(pComp : TpComp; toile: TCanvas);
{mark the impedances of the three phases in the char. picture
 pComp  pointer to the distance relay
 scale  max.impedance value = max value on the axes}
var
  apu   : single;   {temporary}
  c1,c2 : single;   {currents}
  ii    : integer;  {index}
  ix,iy : integer;  {location of the (R,X) point}
  ll    : longint;  {temporary}
  pSet  : TpCompSet;{pointer to the common}
  rr    : single;   {resistance}
  txt   : string;   {text}
  v1,v2 : single;   {voltages}
  xx    : single;   {reactance}
  z1,z2 : single;   {impedances}
  Zcx   : array[1..3] of complex;  {impedances}
begin
  if (pComp <> nil) and (scale > 0) then begin
    pComp^.GetipSet(ll);
    pSet := TpCompSet(ll); {pointer to the common}
    if (pSet^.displ_time > 0) then begin
      {get impedances (only Zcx needed)}
      ImpedanceOut(pComp,true, v1,v2,c1,c2,z1,z2, txt, Zcx);
    end else begin         {impedances with time not needed}
      for ii := 1 to 3 do Zcx[ii] := cplx(0,0);
    end;
    toile.pen.width := 1;
    toile.pen.style := psSolid;
    toile.font.color := clBlack;
    for ii := 1 to 3 do begin
      {impedances at initial time, or at given time > 0}
      if (pSet^.displ_time <= 0) then begin  {at initial time}
        pComp^.GetVar(6*(ii-1)+1,rr);
        pComp^.GetVar(6*(ii-1)+2,xx);
      end else begin                         {at given time}
        rr := Zcx[ii].x;
        xx := Zcx[ii].y;
      end;
      if (rr <> Improbg) and (xx <> Improbg/2) then begin {not undefined imped}
        apu := (pChar^.width div 2)*rr/scale;
        ix  := (pChar^.width div 2)+round(apu);  {x-coordinate of point}
        apu := (pChar^.width div 2)*xx/scale;
        iy  := (pChar^.width div 2)-round(apu);  {y-coordinate of point}
        if      (ii = 1) then begin
          toile.pen.color := clRed;
          toile.Brush.color := clRed;
          txt := 'a';
        end else if (ii = 2) then begin
          toile.pen.color := clLime;
          toile.Brush.color := clLime;
          txt := 'b';
        end else begin
          toile.pen.color := clBlack;
          toile.Brush.color := clBlack;
          txt := 'c';
        end;
        toile.Brush.style := bsSolid;
        toile.rectangle(ix-3,iy-3,ix+3,iy+3);  {the impedance}
        toile.Brush.style := bsClear;
        toile.font.name := 'arial';
        toile.font.size := 9;
        toile.textout(ix+5,iy-3,txt);          {the phase}
      end;
    end;
  end;
end;

procedure TDist.DrawLineImpedance(Zline,fline: single; toile: TCanvas);
{draw the line corresponding to the line impedance
 Zline  magnitude of the line impedance
 fline  angle of the line impedance (rad)
 scale  the scale of the char (max imped.)}
var
  ipu,ipv        : integer;  {temporary}
  ix,iy          : integer;  {coordinates}
  t1,t2,t3,t4,t5 : integer; {line thicknesses}
begin
  if (Zline > 0) and (scale > 0) then begin
    DecodeThickness(t1,t2,t3,t4,t5);
    if (t5 > 0) then begin
      toile.pen.width := t5;
      toile.pen.style := psSolid;
    end else begin
      toile.pen.width := 1;
      toile.pen.style := psDot;
    end;
    toile.pen.color := clBlue;
    ipu := (pChar^.width div 2);
    ipv := (pChar^.height div 2);
    ix := ipu+round(ipu*Zline*cos(fline)/scale);
    iy := ipv-round(ipv*Zline*sin(fline)/scale);
    toile.MoveTo(ipu,ipv);
    toile.LineTo(ix,iy);
  end;
end;

procedure TDist.DrawOhms(toile : TCanvas);
{draw the Ohm marks (units) in the distance relay graph}
var
  ix,iy : integer;  {coordinates}
begin
  toile.font.size := 12;
  {if OhmRx_d is positive, distance is from left edge, else from right edge}
  if (OhmRx_d >= 0) then ix := OhmRx_d else ix := pChar^.width+OhmRx_d;
  iy := (pChar^.height div 2)+OhmRy_d;
  toile.font.name := 'Courier New';
  Toile.TextOut(ix,iy+2,'R');
  toile.font.name := 'symbol';
  Toile.TextOut(ix+12,iy,'[W]');      {Ohm on R-axis}
  ix := (pChar^.width div 2) +OhmXx_d;
  {if OhmXy_d is positive, distance is from top edge, else from bottom edge}
  if (OhmXy_d >= 0) then iy := OhmXy_d else iy := pChar^.height+OhmXy_d;
  toile.font.name := 'Courier New';
  Toile.TextOut(ix,iy+2,'X');
  toile.font.name := 'symbol';
  Toile.TextOut(ix+12,iy,'[W]');      {Ohm on X-axis}
end;


procedure TDist.PutpList(pLL : TpListBox);
begin
  pLmList := pLL;
end;

procedure TDist.DrawGrid(toile: TCanvas; color: TColor);
{draw the grid on the picture of characteristics
 scale  the scale = max value on the axes
 color  the color of the grid}
var
  istep   : integer;   {step as integer}
  ix1,ix2 : integer;   {x-coordinates of the lines}
  iy1,iy2 : integer;   {y-coordinates of the lines}
  jj      : integer;   {counter (for safety)}
  text    : string;    {markings on the axes}
begin
  if (scale > 0) and (step > 0) then begin
    istep := round(step);
    {draw grid lines}
    toile.brush.style := bsClear;
    ix1 := pChar^.width div 2;
    ix2 := ix1;
    jj := 0;
    toile.pen.color := clBlack;   {coordinate axes are black}
    toile.pen.width := 1;
    toile.pen.style := psSolid;
    toile.font.color := clBlack;
    toile.font.size := 8;
    toile.font.name := 'arial';
    while (ix1 < pChar^.width) and (jj < 10) do begin
      {draw vertical positive lines}
      toile.moveto(ix1,0);
      toile.lineto(ix1,pChar^.height);
      {draw vertical negative lines}
      if (ix2 > xxc) then {pChar^.canvas}toile.moveto(ix2,0)
      else               {pChar^.canvas}toile.moveto(ix2,xxc);  {leave space for legend}
      toile.lineto(ix2,pChar^.height);
      {markings on the axes}
      if (istep >=1) then text := inttostr(jj*istep)
      else text := Format('%4.2f', [jj*step]);
      if (jj > 0) then {pChar^.canvas}toile.textout(ix1-8,pChar^.height div 2+2,text);
      if (jj > 0) then {pChar^.canvas}toile.textout(ix2-8,pChar^.height div 2+2,'-'+text);
      {positions of next lines}
      ix1 := round(ix1+0.5*pChar^.width*step/scale);
      ix2 := round(ix2-0.5*pChar^.width*step/scale);
      toile.pen.color := color{clSilver};
      inc(jj);
    end;
    iy1 := pChar^.height div 2;
    iy2 := iy1;
    jj := 0;
    {pChar^.canvas}toile.pen.color := clBlack;   {coordinate axes are black}
    while (iy1 < pChar^.height) and (jj < 10) do begin
      {pChar^.canvas}toile.moveto(0,iy1);
      {pChar^.canvas}toile.lineto(pChar^.width,iy1);
      if (iy2 > xxc) then {pChar^.canvas}toile.moveto(0,iy2)
      else               {pChar^.canvas}toile.moveto(xxc,iy2);
{      image1.canvas.moveto(0,iy2);}
      {pChar^.canvas}toile.lineto(pChar^.width,iy2);
      if (istep >=1) then text := inttostr(jj*istep)
      else text := Format('%4.2f', [jj*step]);
      if (jj > 0) then toile.textout(pChar^.width div 2+4,iy1,'-'+text);
      if (jj > 0) then toile.textout(pChar^.width div 2+4,iy2,text);
      iy1 := round(iy1+0.5*pChar^.height*step/scale);
      iy2 := round(iy2-0.5*pChar^.height*step/scale);
      toile.pen.color := color{clSilver};
      inc(jj);
    end;
  end;
end;

procedure TDist.DrawColors(toile: TCanvas);
{show the colors of the zones}
var
  dix,diy : integer;   {changes in coordinates}
  dy      : integer;
  ix,iy   : integer;   {coordinates}
begin
  ix := {5}13;
  iy := 24;
  dix := 8;
  diy := 4;
  dy := 12;
  toile.font.color := clBlack;
  toile.brush.style := bsSolid;
  toile.pen.color := Zone1Color;
  toile.brush.color := Zone1Color;
  toile.rectangle(ix,iy,ix+dix,iy+diy);
  toile.pen.color := Zone2Color;
  toile.brush.color := Zone2Color;
  toile.rectangle(ix,iy+dy,ix+dix,iy+diy+dy);
  toile.pen.color := Zone3Color;
  toile.brush.color := Zone3Color;
  toile.rectangle(ix,iy+2*dy,ix+dix,iy+diy+2*dy);
  toile.pen.color := Zone4Color;
  toile.brush.color := Zone4Color;
  toile.rectangle(ix,iy+3*dy,ix+dix,iy+diy+3*dy);
  toile.brush.style := bsClear;
  toile.font.name := 'arial';
  toile.font.size := 8;
  toile.textout(ix+dix,iy-(dy div 2),' zone1');
  toile.textout(ix+dix,iy-(dy div 2)+dy,' zone2');
  toile.textout(ix+dix,iy-(dy div 2)+2*dy,' zone3');
  toile.textout(ix+dix,iy-(dy div 2)+3*dy,' zone4');
end;

procedure TDist.MouseImpedance(x,y : integer; var txt : string);
{express  the mouse position in terms of impedance,
 both as R and X, and magnitude and angle
 x,y  the mouse position
 txt  the impedance as text}
var
  angle     : single;   {angle of the impedance}
  hdiv2     : integer;  {half height}
  ipu       : integer;  {temporary}
  magn      : single;   {magnitude of the impedance}
  res,react : single;   {resistance, reactance corresponding to the cursor position}
  wdiv2     : integer;  {width div by 2}
  zz        : complex;  {impedance}
begin
  wdiv2 := pChar^.width div 2;     {half image width}
  ipu := (x-wdiv2);                {cursor x-position wrt origo}
  res := ipu*scale/wdiv2;          {resistance of cursor position}
  hdiv2 := pChar^.height div 2;    {half image height}
  ipu := hdiv2-y;                  {cursor y-position wrt origo}
  react := ipu*scale/hdiv2;        {reactance of the cursor position}
  zz := cplx(res,react);           {impedance}
  magn := Cabs(zz);                {magnitude of the impedance}
  angle := 180*Cangle(zz)/pi;      {angle of the impedance in degrees}
  txt := 'R '+sixsignedchar(res)+' X '+sixsignedchar(react)+' Ohm';
  txt := txt+'  Z '+sixsignedchar(magn)+' Ohm'+' < '+sixsignedchar(angle)+'';
end;

function TDist.MarkerAge(Mline: string; var nSep: integer): integer;
{determine the "age" of the point marker, i.e. the form in which it is saved
 Mline      parameters of the markers as one string
 nSep       number of separators = number of data items
 MarkerAge  the "age" of the markers:
            0 = oldest,
            1 = new, (or not so old)
            2 = most recent for points, almost most recent for lines,
            3 = most recent for lines, -1 = error
the oldest (0) type of marker data (Mline) seems to be:
  marker 1\ R = 1 Ohm\ X = 4 Ohm\   ( 10 )\
It is used for points only
The newer , or not so old (1) is
  marker 1\ R = 1 Ohm\ X = 4 Ohm\   ( 10 )\point\-21\-18\
and the most recent (2) for points, and almost most recent for lines, is:
  marker 1\ R = 1 Ohm\ X = 4 Ohm\   ( 10 )\both\point\-21\-18\ for points
and the most recent for lines (3)
  lineA\ R = -1,5 Ohm\ \   ( 5 )\both\Xstart = -1\Xend = 2\line\4\334\}
var
  age  : integer;  {local age}
  ii   : integer;  {index}
  len  : integer;  {length of string}
  lipo : string;   {line or point}
  nPnt : integer;  {first occurrence of 'point' is the nPnt'th data item}
{ nSep : integer;  {counts separators}
  txt  : string;   {temporary}
  tx5  : string;   {fifth item, for distinguishing "new" and the "most recent" marker}
begin
  nPnt := 0;
  len := length(Mline);
  if (len > 0) then begin
    {count the number of separators, and check the text 'point' or 'line'}
    nSep := 0;
    nPnt := 0;
    txt := '';
    tx5 := '';
    lipo := '';
    for ii := 1 to len do begin
      if (Mline[ii] = gImpedSep) then begin
        inc(nSep);
        {save index of first 'point' or 'line'}
        if (nSep > 1) then begin         {first = identifier, might be line or point!}
          if ((txt = 'point') or (txt = 'line')) and (nPnt = 0) then begin
            nPnt := nSep;
            lipo := txt;                 {save type, line or point}
          end else begin
            txt := '';
          end;
        end else begin
          txt := '';
        end;
      end else begin
        {construct data item, until first 'point' found, but not for the first data item,
         because it is the identifier, that might contain the word 'point' or 'line'}
        if (nPnt = 0) and (nSep > 1) then txt := txt+Mline[ii];
        if (nSep = 4) then tx5 := tx5+Mline[ii]; {fifth item}
      end;
    end;
    {in the oldest type the number of separators is divisible with four, and
     there is no 'point' string (except perhaps as an identifier?)}
    if ((nSep div 4) = (nSep/4.0)) then begin    {divisible by 4}
      {no 'point', or as an identifier = first, fifth, nith... item}
      if (nPnt = 0) or (((nPnt-1) div 4) = ((nPnt-1)/4.0)) then begin
        age := 0;           {old marker}
      end else begin        {2, or multiple 3, ....check more...}
{       if (tx5 = '21') or (tx5 = '21N') or (tx5 = 'both') then age := 2 {recent}
        if (nPnt = 6) then age := 2
        else if (nPnt = 8) then age := 3
        else age := -1;     {error}
      end;
    {new divisible by 7 and 'point' or 'line' is the fifth item}
    end else if ((nSep div 7) = (nSep/7.0)) and (nPnt = 5) then begin
      age := 1;
    end else begin          {most recent point or line, almost recent line, or error}
      if (nPnt = 6) then age := 2
      else if (nPnt = 8) then age := 3
      else age := -1;
    end;
  end else begin            {error case}
    age := -1;              {error flag}
  end;
  MarkerAge := age;
end;

procedure TDist.UpdateMarkerString(age,pl: integer; LineOld: string; var LineNew: string);
{if the string containing data for all markers (of this relay) is not the most
 recend type, it must be updated to correspond to the most recent type
 age      the "age" of the marker  0 = old, 1 = new (but not the most recent), 2 = most recent
 pl       point or line marker, pl = 1 = point, 2 = line
 LineOld  the data for all markers as a string (see MarkerAge for the format)
 LineNew  updated string for the marker data}
const
  OldUp = 'both\point\0\-18\';  {string to update the oldest type (only for point markers)}
var
  ch      : char;     {temporary}
  ii      : integer;  {index}
  iSep    : integer;  {counts separators}
  len     : integer;  {length of string}
  txt     : string;   {temporary}
  tx2,tx3 : string;   {items 2 and 3}
begin
  len := length(LineOld);
  iSep := 0;
  txt := '';
  if (len > 0) then begin             {just to be sure}
    if (age = 0) then begin           {old type of data, point markers only}
      for ii := 1 to len do begin     {scan character for character}
        txt := txt+LineOld[ii];
        if (LineOld[ii] = gImpedSep) then begin  {separator found}
          inc(iSep);
          if (iSep = 4) then begin    {four data items for an old marker}
            txt := txt+OldUp;         {add the updating string}
            iSep := 0;                {reset, start again}
          end;
        end;
      end;
    end else if (age = 1) then begin    {new, but not most recent type of data}
      if (pl = 1) then begin            {point marker}
        for ii := 1 to len do begin     {scan character for character}
          txt := txt+LineOld[ii];
          if (LineOld[ii] = gImpedSep) then begin  {separator found}
            inc(iSep);
            if (iSep = 4) then begin    {four data items for an old marker}
              txt := txt+'both\';       {add the updating string}
            end else if (iSep = 7) then begin  {7 items of data in the "new" type}
              iSep := 0;                {reset, start again}
            end;
          end;
        end;
      end else if (pl = 2) then begin   {line marker}
        {lineA\ R = -1,5 Ohm\ \   ( 5 )\line\4\334\    ..change this...}
        {lineA\ R = -1,5 Ohm\ \   ( 5 )\both\Xstart = -1\Xend = 2\line\4\334\  ..to this}
        tx2 := '';
        tx3 := '';
        iSep := 0;
        for ii := 1 to len do begin
          ch := LineOld[ii];              {one character a time}
          txt := txt+ch;                  {construct the new line}
          if (ch = gImpedSep) then begin  {separator found}
            inc(iSep);
            if (iSep = 4) then begin      {add the new parts here}
              if (tx2 = ' ') then         {horizontal "X-line"}
                txt := txt+'both\Rstart = -100\Rend = 100\'
              else if (tx3 = ' ') then    {vertical "R-line"}
                txt := txt+'both\Xstart = -100\Xend = 100\'
              else                        {error case}
                txt := txt+'both\start = -100\end = 100\';  {just something}
            end else if (iSep = 7) then begin      {end of data for this marker}
              iSep := 0;                  {reset, start again}
              tx2 := '';
              tx3 := '';
            end;
          end else begin                  {not a separator, construct some data items}
            if (iSep = 1) then tx2 := tx2+ch
            else if (iSep = 2) then tx3 := tx3+ch;
          end;
        end;
      end else begin                      {error case}
        LineNew := '';
      end;
    end else if (age = 2) and (pl = 2) then begin  {must change only for lines}
      {lineA\ R = -1,5 Ohm\ \   ( 5 )\both\line\4\334\  ...change this..}
      {lineA\ R = -1,5 Ohm\ \   ( 5 )\both\Xstart = -1\Xend = 2\line\4\334\  ..to this}
      tx2 := '';
      tx3 := '';
      iSep := 0;
      for ii := 1 to len do begin
        ch := LineOld[ii];              {one character a time}
        txt := txt+ch;                  {construct the new line}
        if (ch = gImpedSep) then begin  {separator found}
          inc(iSep);
          if (iSep = 5) then begin      {add the new parts here}
            if (tx2 = ' ') then         {horizontal "X-line"}
              txt := txt+'Rstart = -100\Rend = 100\'
            else if (tx3 = ' ') then    {vertical "R-line"}
              txt := txt+'Xstart = -100\Xend = 100\'
            else                        {error case}
              txt := txt+'start = -100\end = 100\';  {just something}
          end else if (iSep = 8) then begin      {end of data for this marker}
            iSep := 0;                  {reset, start again}
            tx2 := '';
            tx3 := '';
          end;
        end else begin                  {not a separator, construct some data items}
          if (iSep = 1) then tx2 := tx2+ch
          else if (iSep = 2) then tx3 := tx3+ch;
        end;
      end;
    end;
  end else begin              {error case, no proper data??}
    {}
  end;
  LineNew := txt;
end;

function NumberOfSpaces(txa : string): integer;
{conuts number of spaces in txa before a non-space character}
var
  ii     : integer;
  len    : integer;
  nSpace : integer;
begin
  {count number of spaces}
  nSpace := 0;
  len := length(txa);
  if (len > 0) then begin
    for ii := 1 to len do begin
      if (txa[ii] = ' ') then inc(nSpace)
      else break;
    end;
  end;
  NumberOfSpaces := nSpace;
end;

procedure TDist.DrawImpedMarkers(pComp: TpComp; toile: TCanvas; scale : single; grnd: boolean);
{draw the impedance markers on the distance relay diagram
 pComp   pointer to the distance relay
 toile   canvas on which drawn
 scale   max.value of the axes
 grnd    "residual plane" i.e. ground distance relay, if true, else phase plane = phase relay}
const
  gIs = gImpedSep;       {impedance separator, defined in utildef.pas}
var
  age        : integer;   {age of the marker data}
  apu        : single;    {temporary}
  err        : integer;   {error code}
  i4         : integer;   {starting position}
  idata      : integer;   {number of items for marker data: 7 or ..}
  IDx,IDy    : integer;   {relative position of the identifier}
  iEnd       : integer;   {index of last char. of an data item}
  ii,kk      : integer;
  imark      : integer;   {index for markers}
  ipl        : integer;   {index: 1 = point-marker, 2 = line-marker}
  ipu,ipv    : integer;   {temporary}
  iStrt      : integer;   {index for searching parameters}
  itype      : integer;   {type of the marker}
  ix,iy      : integer;   {coordinates}
  kstrt,kend : integer;   {start and end coordinates of a line-marker}
  len,lena   : integer;   {length of line}
  line       : string;    {one line of text = the description}
  LineNew    : string;    {new string of marker data}
  linew      : string;    {new line, for saving old type or marker data as new type}
  mname      : string;    {name of the marker}
  newtype    : boolean;   {flag new marker type}
  nmark      : integer;   {no of markers}
  nSep       : integer;   {number of separators}
  nSpace     : integer;   {number of spaces = codes line thickness}
  par1,par2  : boolean;   {true, 1st,2nd parameter reasonble}
  plane      : string;    {plane on which marker drawn (phase, residual or both)}
  res,reac   : single;    {resistance, reactance}
  RorZ       : char;      {flag for R and X ,or Z and angle}
  rlx        : single;    {relative size of image}
  txa,txb    : string;    {temporary text}
  txc        : string;    {temporary}
  txt        : string;    {temporary}
  v1,v2      : single;    {value of R and X, or Z and angle}
  wid2       : integer;   {width/2 of the image}
  xps        : integer;   {preliminary start coord. of horizontal line}
  Zend       : single;    {R or X where a line marker ends}
  Zstrt      : single;    {R or X where a line marker starts}
begin
  wid2 := pChar^.width div 2;         {width/2 (and height) of the image}
  for ipl := 1 to 2 do begin          {first points, then lines}
    if (ipl = 1) then pComp^.GetDescrG(txa,txb,txc)   {point-markers saved as third description}
    else              pComp^.GetDescrQ(txc,txa,txb);  {line-markers as first descr.}
    len := length(txc);
    if (len > 0) then begin
      age := MarkerAge(txc,nSep);  {age of the data, old, new or most recent}
      if (age = 0) or (age = 1) then
        UpdateMarkerString(age,ipl,txc,LineNew)      {old or new}
      else if (age = 2) then begin
        if (ipl = 1) then LineNew := txc             {for points, age = 2 is the most recent}
        else UpdateMarkerString(age,ipl,txc,LineNew) {for lines, even age = 2 must be updated}
      end else if (age = 3) then
        LineNew := txc                               {for lines, 3 = the most recent}
      else LineNew := '';                     {error case}
      {need number of markers. NOTE may change for line-markers...}
      if (age = 0) then nmark := nSep div 4
      else if (age = 1) then nmark := nSep div 7
      else if (age = 2) then nmark := nSep div 8
      else if (age = 3) then nmark := nSep div nLDit {lditems}
      else nmark := 0;
      if (ipl = 1) then nMark_d := nmark    {save, needed when moving identifier}
      else LMark_d := nmark;                {no of line-markers}
      {line new contains the data for the markers in the same form for all ages.
       Extract the data, if there are markers}
      if (nmark > 0) then begin
        iStrt := 1;                       {start at the beginning of string with data}
        for imark := 1 to nmark do begin  {all markers}
          ExtractNextParam(iStrt, gImpedSep,LineNew,mname,iEnd);  {name of the marker}
          iStrt := iEnd+1;
          ExtractNextParam(iStrt, gImpedSep,LineNew,txa  ,iEnd);  {numerical parameter}
          iStrt := iEnd+1;
          OnlyValue(txa,txb);               {get the value, without additional characters}
          if (length(txb) > 0) then begin
            chkfloat(txb,err,txt);
            if (err = 0) then begin
              v1 := strtofloat(txt);        {numerical value}
              par1 := true;                 {first parameter reasonable}
            end else begin
              v1 := 0;
              par1 := false;
            end;
          end else begin                    {no reasonable value}
            v1 := 0;                        {give some value}
            par1 := false;
          end;
          if (length(txa) > 1) then RorZ := txa[2]  {R for resistance, Z for impedance}
          else RorZ := 'R';                 {error case, just some value}
          ExtractNextParam(iStrt, gImpedSep,LineNew,txa  ,iEnd);  {second numerical parameter}
          iStrt := iEnd+1;
          OnlyValue(txa,txb);               {get the value, without additional characters}
          if (length(txb) > 0) then begin
            chkfloat(txb,err,txt);
            if (err = 0) then begin
              v2 := strtofloat(txt);        {numerical value}
              par2 := true;                 {flag: reasonable value}
            end else begin
              v2 := 0;
              par2 := false;
            end;
          end else begin
            v2 := 0;                        {set some value}
            par2 := false;                  {flag: no reasonable value}
          end;
          {when point, must check Z and fii given, or R and X}
          if (ipl = 1) then begin           {point-marker}
            {if Z and angle saved, must calculate R and X}
            if (RorZ = 'R') then begin
              res := v1;
              reac := v2;
            end else begin
              apu := v2*pi/180.0;           {angle in radians}
              res := v1*cos(apu);
              reac := v1*sin(apu);
            end;
          end else begin                    {line marker}
            if (par1) then begin
              res := v1;
              reac := Improbg;              {use improbable value as a flag, needed??}
            end else if (par2) then begin
              res := Improbg;
              reac := v2;
            end else begin                  {error case}
              res := Improbg;
              reac := Improbg;
            end;
          end;
          ExtractNextParam(iStrt, gImpedSep,LineNew,txa  ,iEnd);  {marker type, or line color}
          iStrt := iEnd+1;
          OnlyValue(txa,txb);               {get the value, without additional characters}
          itype := strtoint(txb);           {type of the marker or color of the line}
          {count number of spaces = line thickness}
          nSpace := NumberOfSpaces(txa);
//          nSpace := 0;
//          lena := length(txa);
//          if (lena > 0) then begin
//            for ii := 1 to lena do begin
//              if (txa[ii] = ' ') then inc(nSpace)
//              else break;
//            end;
//          end;

          ExtractNextParam(iStrt, gImpedSep,LineNew,plane,iEnd);  {plane, where drawn}
          iStrt := iEnd+1;
          {start and end of a line marker}
          if (ipl = 2) then begin           {it is a line marker}
            ExtractNextParam(iStrt, gImpedSep,LineNew,txa  ,iEnd);  {start parameter}
            iStrt := iEnd+1;
            OnlyValue(txa,txb);               {get the value, without additional characters}
            if (length(txb) > 0) then begin
              chkfloat(txb,err,txt);
              if (err = 0) then Zstrt := strtofloat(txt)  {numerical value}
              else Zstrt := -100;                         {just some value}
            end else begin
              Zstrt := -100;                  {just some value}
            end;
            {the end parameter}
            ExtractNextParam(iStrt, gImpedSep,LineNew,txa  ,iEnd);  {start parameter}
            iStrt := iEnd+1;
            OnlyValue(txa,txb);               {get the value, without additional characters}
            if (length(txb) > 0) then begin
              chkfloat(txb,err,txt);
              if (err = 0) then Zend := strtofloat(txt)  {numerical value}
              else Zend := 100;                         {just some value}
            end else begin
              Zend := 100;                    {just some value}
            end;
            {change the start and end points of the line-marker to coordinates}
            if (par1) then begin              {vertical, "R"-line}
              ipu := wid2-round(Zstrt*wid2/scale);      {start-reactance to y-coord}
              ipv := wid2-round(Zend*wid2/scale);       {end-reactance to y-coord}
            end else begin                              {horizontal, "X"-line}
              ipu := round(Zstrt*wid2/scale)+wid2;      {start-resistance to x-coord}
              ipv := round(Zend*wid2/scale)+wid2;       {end-resistance to x-coord}
            end;
            if (ipu < ipv) then begin                   {arrange: start < end}
              kstrt := ipu;
              kend := ipv;
            end else begin
              kstrt := ipv;
              kend := ipu;
            end;
          end;
          {calc. location of marker in image coordinates}
          ix := round(res*wid2/scale)+wid2; {resistance to x-coord}
          iy := wid2-round(reac*wid2/scale);{reactance to y-coord}
          if (ipl = 1) then begin           {point-marker, both coordinates saved}
            Mrkxx[imark-1] := ix;           {save position, needed when identifier moved}
            Mrkyy[imark-1] := iy;
          end else begin                    {line marker, save R or X}
            if (par1) then Linxy[imark-1] := ix    {resistance}
            else           Linxy[imark-1] := iy;   {reactance}
          end;
          {marker type 'point' or 'line' (could be used for checks?}
          ExtractNextParam(iStrt, gImpedSep,LineNew,txa  ,iEnd);
          iStrt := iEnd+1;
          {draw marker, if inside image, but calculate position etc. in any case}
          toile.font.name := 'arial';
          toile.font.size := 8;
          toile.font.color := clBlack;
          {read the (relative) position of the identifier}
          ExtractNextParam(iStrt, gImpedSep,LineNew,txa  ,iEnd);  {x-coordinate, as text}
          iStrt := iEnd+1;
          OnlyValue(txa,txb);               {get the value, without additional characters}
          IDx := strtoint(txb);             {x-coord. of the identifier}
          ExtractNextParam(iStrt, gImpedSep,LineNew,txa  ,iEnd);  {y-coordinate, as text}
          iStrt := iEnd+1;
          OnlyValue(txa,txb);               {get the value, without additional characters}
          IDy := strtoint(txb);             {y-coord. of the identifier}
          {save the relative position of the identifier}
          if (ipl = 1) then begin             {point-marker}
            IDrxx[imark-1] := IDx;            {save relative position..}
            IDryy[imark-1] := IDy;            {..needed when moving the ID}
          end else begin                      {line-marker}
            LIDxx[imark-1] := IDx;
            LIDyy[imark-1] := IDy;
          end;
          {draw point or line, if drawing allowed in this plane (phase or residual)}
          if (plane = 'both') or
             (plane = '21N') and (grnd) or
             (plane = '21')  and (not grnd) then begin
            if (ipl = 1) then begin             {point-marker}
              {draw, if inside image}
              if (ix >= 0) and (ix <= 2*wid2) and (iy >= 0) and (iy <= 2*wid2) then begin
                DrawMark(toile, ix, iy,0, itype , 1.5);  {marker itself}
                toile.font.color := clBlack;
                toile.textout(IDx+ix,IDy+iy,mname);    {write the identifier}
              end;
            end else begin                             {line-marker}
              if (itype >= Low(gColor)) and (itype <= High(gColor)) then
                toile.pen.color := gColor[itype]
              else toile.pen.color := clRed;
              rlx := SizeScaling;                      {take size of image into account}
//            toile.pen.width := 2;
              {line width coded in number of spaces in color row, checked above}
              if (nSpace > 1) then toile.pen.width := nSpace-1 else toile.pen.width := 2;
              if (par1) then begin                     {resistance = vertical line}
                if (ix >= 0) and (ix <= 2*wid2) then begin
                {at least a part of line within image (kstrt < kend, checked above)}
                  if (kstrt <= 2*wid2) and (kend >= 0) then begin
                    if (ix > xxc) then xps := 0        {preliminary start}
                    else xps := xxc;                   {leave space for explanations etc.}
                    if (kstrt > xps) then ipu := kstrt else ipu := xps;
                    if (kend < 2*wid2) then ipv := kend else ipv := 2*wid2;
                    toile.moveto(ix,ipu);              {start at kstrt, if reasonable, else..}
                    toile.lineto(ix,ipv);              {end at kend, if reasonable, else..}
                    ipu := round(rlx*IDy);
                    toile.textout(IDx+ix,ipu,mname);   {write the identifier. x relative, y absolute}
                  end;
                end;
              end else begin                           {reactance = horizontal line}
                if (iy >= 0) and (iy <= 2*wid2) then begin
                  {at least a part of line within image (kstrt < kend, checked above)}
                  if (kstrt <= 2*wid2) and (kend >= 0) then begin
                    if (iy > xxc) then xps := 0        {preliminary start}
                    else xps := xxc;                   {leave space for explanations etc.}
                    if (kstrt > xps) then ipu := kstrt else ipu := xps;
                    if (kend < 2*wid2) then ipv := kend else ipv := 2*wid2;
                    toile.moveto(ipu,iy);              {start at kstrt, if reasonable, else..}
                    toile.lineto(ipv,iy);              {end at kend, if reasonable, else..}
                    ipu := round(rlx*IDx);
                    toile.textout(ipu,IDy+iy,mname);      {write the identifier. x absolute, y relative}
                  end;
                end;
              end;
            end; {}
          end;
        end;
        {save updated parameter string, if updated}
        if (age = 0) or (age = 1) or ((age = 2) and (ipl = 2)) then begin
          if (ipl = 1) then begin       {point marker}
            pComp^.PutDescrG(4,'','',LineNew);
          end else begin                {line marker}
            pComp^.PutDescrQ(1,LineNew,'','');
          end;
        end;
      end;  {end of "there are markers"}
    end;    {end of length of parameter string > 0}
  end;      {end of for loop for points, lines}
end;

procedure TDist.DrawLoadZones(toile: TCanvas; txout: boolean);
{draw the load zones (arc and lines)
 toile  canvas on which drawn
 txout  if true, draw (write) names (identifiers) of zones}
var
  aL1,aL2     : single;    {pos. and neg. forward load angle}
  aL3,aL4     : single;    {pos. and neg. reverse load angle}
  aLi,alJ     : single;    {pos and neg. forw. or reverse load angle}
  apu,apv,apw : single;    {temporary}
  cl1,cl2,clr : integer;   {color index}
  err         : integer;   {error flag}
  fii         : single;    {angle}
  fi1,fi2     : single;    {angles}
  fMVA,rMVA   : single;    {forward and reverse apparent power}
  ID          : string;    {the identifier (name)}
  IDx,IDy     : integer;   {coordinates of the identifiers}
  IDxy        : longint;   {packed coordinates}
  ii,ifr      : integer;   {index}
  ipu,ipx,ipy : integer;   {temporary}
  ix,iy       : integer;   {line coordinates}
  ixo,iyo     : integer;   {line coordinates}
  ix1,iy1     : integer;   {corrected line coordinates}
  OKfor,OKrev : boolean;   {forward, reverse anlges OK}
  pw,pw1,pw2  : integer;   {pen width}
  radius      : single;    {radius of the arc}
  res,reac    : single;    {coordinates of the ID as impedance}
  res1,reac1  : single;    {coordinates of the ID as impedance}
  res2,reac2  : single;    {coordinates of the ID as impedance}
  Volt        : single;    {voltage level}
  wd2         : integer;   {picture width / 2}
{ xystr       : string;    {packed coordinates as a string}
  x1,x2,x3,x4 : integer;   {x-parameters for the arc of the load zone}
  y1,y2,y3,y4 : integer;   {y-parameters for the arc}
  xrow,yrow   : integer;   {indices of coordinate rows}
  Zfr         : single;    {forward, reverse load zone}
begin
  pActRel^.GetSystLev(Volt);
  {read parameters}
  pActRel^.GetPar(fwMVARow_d+1,fMVA);      {apparent power}
  pActRel^.GetPar(fwPosARow_d+1,aL1);  {pos. forward load angle, in degrees}
  pActRel^.GetPar(fwNegARow_d+1,apu);  {neq. forward load angle}
  if (apu < 0) then begin
    aL2 := apu;
  end else begin
    if (apu > 180) then aL2 := apu-360 {change to negative angle}
    else aL2 := apu;
  end;
  pActRel^.GetPar(fwColRow_d+1,apu);          {color index}
  if (apu < 1) then cl1 := 1 else if (apu <= 16) then cl1 := round(apu) else cl1 := 16;
  pActRel^.GetPar(fwThRow_d+1,apu);         {pen width}
  if (apu < 0) then pw1 := 0 else if (apu <= 4) then pw1 := round(apu) else pw1 := 4;
  {reverse load zone}
  pActRel^.GetPar(rvMVARow_d+1,rMVA);           {apparent power}
  pActRel^.GetPar(rvPosARow_d+1,aL3);       {pos.reverse load angle, in degrees}
  pActRel^.GetPar(rvNegARow_d+1,apu);       {neg.reverse load angle}
  if (apu < 0) then aL4 := 360+apu else aL4 := apu;  {use only positive angles}
  pActRel^.GetPar(rvColRow_d+1,apu);          {color index}
  if (apu < 1) then cl2 := 1 else if (apu <= 16) then cl2 := round(apu) else cl2 := 16;
  pActRel^.GetPar(rvThRow_d+1,apu);         {pen width}
  if (apu < 0) then pw2 := 0 else if (apu <= 4) then pw2 := round(apu) else pw2 := 4;
  pActRel^.GetPar(fwIDxRow_d+1,res1);         {x coordinate as resistance}
  pActRel^.GetPar(fwIDyRow_d+1,reac1);        {y coordinate as reactance}
  pActRel^.GetPar(rvIDxRow_d+1,res2);         {x coordinate as resistance}
  pActRel^.GetPar(rvIDyRow_d+1,reac2);        {y coordinate as reactance}
  {check that power and angles in correct range}
  OKfor := (aL1 >= -90) and (aL1 <=  90) and (aL2 >= -90) and (aL2 <=  90) and
           (fMVA > 0);
  OKrev := (aL3 >=  90) and (aL3 <= 270) and (aL4 >=  90) and (aL4 <= 270) and
           (rMVA > 0);
  {draw, if parameters reasonable}
  for ifr := 1 to 2 do begin               {forward and reverse load angle}
    {draw only if angles in the correct range}
    if ((ifr = 1) and (OKfor)) or ((ifr = 2) and (OKrev)) then begin
      if (ifr = 1) then begin
        aLi := aL1;                          {forward angles}
        aLj := aL2;
        Zfr := Volt*Volt/(fMVA*1e6);         {radius of forward zone}
        pw := pw1;                           {pen width}
        clr := cl1;                          {color index}
        ID := pGrid^.cells[1,fwNameR_d];     {the identifier}
        res := res1;
        reac := reac1;
      end else begin
        aLi := aL3;                          {reverse angles}
        aLj := aL4;
        Zfr := Volt*Volt/(rMVA*1e6);         {radius of reverse zone}
        pw := pw2;                           {pen width}
        clr := cl2;                          {color index}
        ID := pGrid^.cells[1,rvNameR_d];     {the identifier}
        res := res2;
        reac := reac2;
      end;
      radius := pChar^.width*Zfr/(2*scale);
      ipu := round(radius);                    {impedance in picture units, as integer}
      x1 := (pChar^.width div 2)-ipu;          {define rectangle containing the circle}
      y1 := x1;
      x2 := (pChar^.width div 2)+ipu;
      y2 := x2;
      {define beginning and end of the arc}
      if (aLi > aLj) then begin                {normally pos. angle larger}
        fi1 := pi*aLj/180;
        fi2 := pi*aLi/180;
      end else begin
        fi1 := pi*aLi/180;
        fi2 := pi*aLj/180;
      end;
      {draw the arc}
      wd2 := pChar^.width div 2;
      x3 := wd2+round(wd2*cos(fi1));
      y3 := wd2-round(wd2*sin(fi1));
      x4 := wd2+round(wd2*cos(fi2));
      y4 := wd2-round(wd2*sin(fi2));
      Toile.pen.color := gColor[clr];
      if (pw < 1) then begin
        Toile.Pen.width := 1;
        Toile.pen.style := psDot;
      end else begin
        Toile.Pen.width := pw;
        Toile.pen.style := psSolid;
      end;
      Toile.arc(x1,y1,x2,y2,x3,y3,x4,y4);
      {the lines from the arc}
      for ii := 1 to 2 do begin               {both lines}
        if (ii = 1) then fii := fi1 else fii := fi2;
        ixo := wd2+round(radius*cos(fii));
        iyo := wd2-round(radius*sin(fii));
        Toile.MoveTo(ixo,iyo);                  {starting point of the line}
        if (fii <= pi/4) and (fii >= -pi/4) then begin {intersects right vertical boundary}
          ix := pChar^.width;
          iy := wd2-round(wd2*sin(fii)/cos(fii));
        end else if (fii >= 3*pi/4) and (fii <= 5*pi/4) then begin {left vert.boundary}
          ix := 0;
          iy := wd2+round(wd2*sin(fii)/cos(fii));
        end else begin                          {intersects horizontal boundary}
          if (fii < 0) or (fii > 5*pi/4) then begin  {intersects bottom}
            iy := pChar^.height;
            ix := wd2-round(wd2*cos(fii)/sin(fii));
          end else begin                        {intersects top}
            iy := 0;
            ix := wd2+round(wd2*cos(fii)/sin(fii));
          end;
        end;
        {do not draw in the corner with the explanations}
        if (ixo >= xxc) or (iyo >= xxc) then begin   {start of the line not in the forbidden area}
          if (ix >= xxc) or (iy >= xxc) then begin   {end of the line not in the area}
            Toile.LineTo(ix,iy);                   {draw the line}
          end else begin                           {end point in the forbidden area}
            if (ix > iy) then begin                {x closer to the boundary of the area}
              ix1 := xxc;                          {end at the boundary}
              apu := wd2-ix;
              apv := wd2-xxc;
              iy1 := wd2-round((wd2-iy)*apv/apu);
              Toile.LineTo(ix1,iy1);
            end else begin                         {y closer to the boundary of the area}
              iy1 := xxc;                          {end at the boundary}
              apu := wd2-iy;
              apv := wd2-xxc;
              ix1 := wd2-round((wd2-ix)*apv/apu);
              Toile.LineTo(ix1,iy1);
            end;
          end;
        end;
      end;
      {get and check ID-coordinates }
      ImpedToPos(res,reac,ipx,ipy);             {impedance to coordinates}
      {not initialized, if both are zero (probably)}
      if (res = 0) and (reac = 0) then begin
        if (ifr = 1) then IDx := 3*(owid div 4) {initialize forward zone..}
        else IDx := owid div 4;                 {..or reverse zone}
        IDy := (owid div 2)-16;                 {y is same for both}
        {must save new positions}
        PosToImped(IDx,IDy,apu,apv);                     {to impedance}
        if (ifr = 1) then begin                          {forward}
          xrow := fwIDxRow_d;
          yrow := fwIDyRow_d;
        end else begin
          xrow := rvIDxRow_d;
          yrow := rvIDyRow_d;
        end;
        pGrid^.cells[1,xRow] := floattostr(apu); {save as a string}
        pGrid^.cells[1,yRow] := floattostr(apv);
        spare[xRow] := pGrid^.cells[1,xRow];
        spare[yRow] := pGrid^.cells[1,yRow];
        pActRel^.PutPar(xRow+1,apu);             {save also numerical value}
        pActRel^.PutPar(yRow+1,apv);
      end else begin
        IDx := ipx;
        IDy := ipy;
      end;
      {write the identifiers, if allowed}
      Toile.font.name := 'arial';
      Toile.font.size := 10;
      Toile.font.color := gColor[clr];
      if {(not Distrel.LoadItem.checked)}(txout) then Toile.textout(IDx,IDy,ID);
    end;
  end;
  toile.pen.style := psSolid;   {reset style, just in case}
end;

procedure TDist.DrawOutOfStepChar(toile : TCanvas; txout : boolean);
{draw the out of step characteristics = parallelpiped defined by resistances and reactances
 toile   canvas on which drawn
 txout   if true, names (identifiers) are written}
var
  angle        : single;  {phase angle of the line impedance}
  apu,apv      : single;
  clr          : single;  {color index as floating}
  cot          : single;  {cot(angle)}
  det          : single;  {1/determinant}
  iclr         : integer; {index of color}
  ID           : string;  {the identifier (name) of the char.}
  IDx,IDy      : integer; {coordinates of the identifier}
  itck         : integer; {line thickness}
  iz           : integer; {index for zone}
  nodraw       : boolean; {do not draw, if errors in data}
  r1,z1,r2,z2  : single;  {corners as impedance}
  r3,z3,r4,z4  : single;  {corners as impedance}
  res,reac     : single;  {coordinates of the identifier, as impedance}
  Rleft,Rright : single;  {resistances defining the sides}
  tck          : single;  {line thickness as floating}
  Xtop,Xbot    : single;  {reactances defining the top and bottom}
  x1,y1,x2,y2  : integer; {coordinates of corners}
  x3,y3,x4,y4  : integer; {coordinates of corners}
  xrow,yrow    : integer; {rows for coordinates}
  zero         : boolean; {some parameter is zero}
begin
  for iz := 1 to 2 do begin                   {zones 6 and 5}
    if (iz = 1) then begin                    {zone 6}
      pActRel^.GetPar(z6TopRow_d+1,Xtop);     {top reactance}
      pActRel^.GetPar(z6BotRow_d+1,Xbot);     {bottom reactance}
      pActRel^.GetPar(z6RightRow_d+1,Rright); {right resistance}
      pActRel^.GetPar(z6LeftRow_d+1,Rleft);   {left resistance}
      pActRel^.GetPar(z6ColRow_d+1,clr);      {color index}
      pActRel^.GetPar(z6ThRow_d+1,tck);       {line thickness}
      pActRel^.GetPar(z6IDxRow_d+1,res);      {x-coord of ID as resistance}
      pActRel^.GetPar(z6IDyRow_d+1,reac);     {x-coord of ID as rectance}
      ID := pGrid^.cells[1,z6NameRow_d];      {the identifier}
    end else begin                            {zone 5}
      pActRel^.GetPar(z5TopRow_d+1,Xtop);     {top reactance}
      pActRel^.GetPar(z5BotRow_d+1,Xbot);     {bottom reactance}
      pActRel^.GetPar(z5RightRow_d+1,Rright); {right resistance}
      pActRel^.GetPar(z5LeftRow_d+1,Rleft);   {left resistance}
      pActRel^.GetPar(z5ColRow_d+1,clr);      {color index}
      pActRel^.GetPar(z5ThRow_d+1,tck);       {line thickness}
      pActRel^.GetPar(z5IDxRow_d+1,res);      {x-coord of ID as resistance}
      pActRel^.GetPar(z5IDyRow_d+1,reac);     {x-coord of ID as rectance}
      ID := pGrid^.cells[1,z5NameRow_d];      {the identifier}
    end;
    {color index between 1 and 16}
    if (clr < 1) then iclr := 1 else if (clr <= 16) then iclr := round(clr) else iclr := 16;
    {line thickness from 0 to 4. 0 = dashed line}
    if (tck < 0) then itck := 0 else if (tck <= 4) then itck := round(tck) else itck := 4;
    if (isMho(pActRel)) then pActRel^.GetPar(21,apu) {line angle in degrees for a Mho relay}
    else pActRel^.GetPar({30}31,apu);           {line angle for a polygon relay}
    angle := pi*apu/180;                    {angle in degrees}
    {do not draw, if some resistance or reactance is zero}
    zero := (Xtop = 0) or (Xbot = 0) or (Rleft = 0) or (Rright = 0);
    nodraw := false;                        {initialize}
    {calculate the corners}
    if ((angle >= pi/2-0.001) and (angle <= pi/2+0.001)) or
       ((angle >= -pi/2-0.001) and (angle <= -pi/2+0.001)) or
       ((angle >= 3*pi/2-0.001) and (angle <= 3*pi/2+0.001)) then begin  {almost 90 degrees}
      r1 := Rright;
      r2 := Rleft;
      r3 := Rleft;
      r4 := Rright;
      z1 := Xtop;
      z2 := Xtop;
      z3 := Xbot;
      z4 := Xbot;
    end else if ((angle >=   -0.1) and (angle <=    0.1)) or
                ((angle >= pi-0.1) and (angle <= pi+0.1)) then begin
      {not reasonable angle, set some values, set error flag}
      r1 := Rright;
      r2 := Rleft;
      r3 := Rleft;
      r4 := Rright;
      z1 := Xtop;
      z2 := Xtop;
      z3 := Xbot;
      z4 := Xbot;
      nodraw := true;
    end else begin  {reasonable angle}
      cot := 1/tan(angle);
      det := 1/(1+cot*cot);
      r1 := det*(Rright+cot*Xtop);
      z1 := det*(-cot*Rright+Xtop);
      r2 := det*(Rleft+cot*Xtop);
      z2 := det*(-cot*Rleft+Xtop);
      r3 := det*(Rleft+cot*Xbot);
      z3 := det*(-cot*Rleft+Xbot);
      r4 := det*(Rright+cot*Xbot);
      z4 := det*(-cot*Rright+Xbot);
    end;
    {change impedances to coordinates}
    ImpedToPos(r1,z1,x1,y1);
    ImpedToPos(r2,z2,x2,y2);
    ImpedToPos(r3,z3,x3,y3);
    ImpedToPos(r4,z4,x4,y4);
    {set pen properties}
    Toile.pen.color := gColor[iclr];
    if (itck <= 0) then begin
      Toile.pen.style := psDot;
      Toile.pen.width := 1;
    end else begin
      Toile.pen.style := psSolid;
      Toile.pen.width := itck;
    end;
    {draw the lines}
    if (not nodraw) and (not zero) then begin   {reasonable parameters}
      Toile.MoveTo(x1,y1);
      Toile.LineTo(x2,y2);
      Toile.LineTo(x3,y3);
      Toile.LineTo(x4,y4);
      Toile.LineTo(x1,y1);
      {write the names (identifiers)}
      {not initialized, if both are zero (probably)}
      if (res = 0) and (reac = 0) then begin
        if (iz = 1) then begin
          IDx := x2;                      {initialize  zone 6..}
          IDy := y2-16;
        end else begin
          IDx := x3+8;              {..or zone 5}
          IDy := y3-16;
        end;
        {must save new positions}
        PosToImped(IDx,IDy,apu,apv);                     {to impedance}
        if (iz = 1) then begin                          {forward}
          xrow := z6IDxRow_d;
          yrow := z6IDyRow_d;
        end else begin
          xrow := z5IDxRow_d;
          yrow := z5IDyRow_d;
        end;
        pGrid^.cells[1,xRow] := floattostr(apu); {save as a string}
        pGrid^.cells[1,yRow] := floattostr(apv);
        spare[xRow] := pGrid^.cells[1,xRow];
        spare[yRow] := pGrid^.cells[1,yRow];
        pActRel^.PutPar(xRow+1,apu);             {save also numerical value}
        pActRel^.PutPar(yRow+1,apv);
      end else begin
        ImpedToPos(res,reac,IDx,IDy);
      end;
      {write the identifiers}
      Toile.font.size := 10;
      Toile.font.color := gColor[iclr];
      if (txout) then Toile.textout(IDx,IDy,ID);
    end;
  end;
  toile.pen.style := psSolid;   {reset style, just in case}
end;

procedure DrawAllMhoChar(pComp : TpComp; toile :TCanvas);
{draw the four distance relay-Mho-characteristics
 pComp  pointer to the distance relay
 toile  canvas on which drawn
 scale  max value on the axes}
const
  zmax  : single = 1.0;   {max. of the magnitudes}
var
  AltState       : boolean;   {true, if the alt-key has been pressed}
  angle          : single;    {"tilting" angle, degrees, 0 = to the right, 90 = upwards}
  apu            : single;    {temporary}
  dix,diy        : integer;   {change in x,y for color code}
  dy             : integer;   {distance between colors}
  fline          : single;    {angle of the line-impedance, in radians}
  GrColor        : TColor;    {color of the grid}
  ground         : boolean;   {true, if ground distance relay}
  ipSet          : longint;   {pointer to the "common" as integer}
  ipu,ipv        : integer;   {temporary}
  ix,iy          : integer;   {coordinates}
  lbl            : string;    {label of the relay}
  pSet           : TpCompSet; {pointer to the "common"}
  scale          : single;    {max.value on the axes}
  step           : single;    {interval between markingsd (grid)}
  t1,t2,t3,t4,t5 : integer;   {line thickness}
  Z1,Z2,Z3,Z4    : single;    {magnitude = diameter of the circle, ohms}
  Zline          : single;    {impedance of the line}
//zmax           : single;    {max. of the magnitudes}
begin
  if (pComp <> nil) then begin
    Dist.ClearDistChar(toile);      {clear first}
    pComp^.GetipSet(ipSet);         {get pointer to the set, as integer}
    pSet := TpCompSet(ipSet);       {pointer to the set, from integer}
    AltState := pComp^.GetAltState; {true, if alt-key pressed}
    pComp^.GetLabel(lbl,ix,iy);     {label of the component}
    pComp^.GetPar(3,angle);
    pComp^.GetPar(20,Zline);        {line impedance}
    pComp^.GetPar(21,apu);
    fline := apu*pi/180;            {phase of line impedance}
    {normally, show the impedance and char according to the fault type, but
    if alt-key is pressed, show the other way around}
    {ground distance relay}
    if ((Imagoo.DistRelBut.caption = gAuto  {'auto' })and((pSet^.Grnd_dist)and(not AltState))) or
       ((Imagoo.DistRelBut.caption = gAuto  {'auto' })and((not pSet^.Grnd_dist)and(AltState))) or
       ((Imagoo.DistRelBut.caption = gGround{'grnd' })and(not AltState)) or
       ((Imagoo.DistRelBut.caption = gPhase {'phase'})and(    AltState)) then begin
      pComp^.GetPar(12,Z1);
      pComp^.GetPar(13,Z2);
      pComp^.GetPar(14,Z3);
      pComp^.GetPar(15,Z4);
      ground := true;
    end else begin                    {some other fault}
      pComp^.GetPar(4,Z1);
      pComp^.GetPar(5,Z2);
      pComp^.GetPar(6,Z3);
      pComp^.GetPar(7,Z4);
      ground := false;
    end;
    {save the relay or calculation type}
    Dist.SetPhaseGround(not ground);
    {find scale, if not constant}
    if (not DistRel.ScaleItem.checked) then begin
      zmax := 0;
      if (abs(Z1) > zmax) then zmax := abs(Z1);
      if (abs(Z2) > zmax) then zmax := abs(Z2);
      if (abs(Z3) > zmax) then zmax := abs(Z3);
      if (abs(Z4) > zmax) then zmax := abs(Z4);
    end;  
    {change the scale by changing the impedance}
    Dist.CalculateScale( (exp(Dist.modscale*0.25))*zmax);
    scale := Dist.scale;
    if (Dist.ClrChange) then begin
      GrColor := Dist.clGrid;                 {lines of selected color}
      Dist.SaveLineColor(Dist.clGrid);        {save to current trafo}
    end else begin
      GrColor := Dist.GetLineColor;                {color from current trafo}
    end;
    Dist.DrawGrid(toile,GrColor);
    if (Distrel.UnitsItem.checked) then Dist.DrawOhms(toile); {draw the units: "Ohms"}
    Dist.DrawImpedMarkers(pComp,toile, scale,ground);
    {draw characteristics, but only if allowed}
    Dist.DecodeThickness(t1,t2,t3,t4,t5);
    if (Distrel.Zone1Item.checked) then DrawMhoChar(scale,Z1,angle,Zone1Color,t1,toile);
    if (Distrel.Zone2Item.checked) then DrawMhoChar(scale,Z2,angle,Zone2Color,t2,toile);
    if (Distrel.Zone3Item.checked) then DrawMhoChar(scale,Z3,angle,Zone3Color,t3,toile);
    if (Distrel.Zone4Item.checked) then DrawMhoChar(scale,Z4,angle,Zone4Color,t4,toile);
    {mark the impedances}
    if (not Distrel.ImpedanceItem.checked) then Dist.DrawImpedances(pComp,toile);
    {impedance of the line, if desired}
    if (Distrel.LineItem.checked) then Dist.DrawLineImpedance(Zline,fline,toile);
    Dist.DrawColors(toile);            {show the colors of the zones}
    if (not Distrel.LoadZoneItem.checked) then
      Dist.DrawLoadZones(toile,not Distrel.LoadItem.checked);   {draw load zones}
    if (not Distrel.OutZoneItem.checked) then
      Dist.DrawOutOfStepChar(toile,not Distrel.StepItem.checked);{draw out of step characteristics}
    {draw also text for the type of the relay}
    if (ground) then begin
      Distrel.caption := lbl+'    Residual plane (21N)';
       {draw the relay symbol, if not hidden}
      if (not Distrel.SymbolItem.checked) then DistGroundRight(toile,13,1,1);
      {move the marker to the rows for ground relay}
      Distrel.MarkImage.top := Distrel.MhoGrid.top+
        11*Distrel.MhoGrid.DefaultRowHeight+12*Distrel.MhoGrid.GridLineWidth;
    end else begin
      Distrel.caption := lbl+'    Phase plane(21)';
      {draw the relay symbol, if not hidden}
      if (not Distrel.SymbolItem.checked) then DistPhaseRight(toile,13,1,1);
      {move the marker to the rows for phase relay}
      Distrel.MarkImage.top := Distrel.MhoGrid.top+
        3*Distrel.MhoGrid.DefaultRowHeight+4*Distrel.MhoGrid.GridLineWidth;
    end;
   {Dist.DrawImpedMarkers(pComp,toile, scale);}
  end;
end;

procedure TDistrel.FormDeactivate(Sender: TObject);
begin
  if not NotesItem.checked then
    Dist.FormDeactivate(Sender);
end;

procedure TDistrel.OKButClick(Sender: TObject);
var
  ipSet : longint;
begin
  if (Dist.GetActRel <> nil) then
     Dist.GetActRel.var2_s := 1;     {flag for the button}
  FormDeactivate(sender);   {save the parameters, recalculate impedances, etc}
  ipSet := longint(@SetComp);
  unmark(ipSet);
end;

procedure TDistrel.CancelButClick(Sender: TObject);
var
  ipSet : longint;
begin
  if (Dist.GetActRel <> nil) then
    Dist.GetActRel.var2_s := 2;     {flag for the button}
  FormDeactivate(sender);   {discard changes, restore impedances etc.}
  ipSet := longint(@SetComp);
  unmark(ipSet);
end;

procedure TDistrel.ApplyButClick(Sender: TObject);
begin
  if (Dist.GetActRel <> nil) then
    Dist.GetActRel.var2_s := 3;    {flag for the button}
  FormDeactivate(sender);  {preliminaily save and show the effect of the changes}
end;

procedure TDistrel.FormPaint(Sender: TObject);
{keep the characteristics visible during scrolling}
begin
  {set pointer here, because at "create" is too early}
  Dist.pLmList := @RXLineForm.LineList;
  Dist.FormPaint;
  ResetBut.top := DistChar.top+xxc-12;  {under the explanations}
  DecBut.top := ResetBut.top;
  IncBut.top := ResetBut.top;
  IncBut.left := DistChar.left+8;
  DecBut.left := IncBut.left+IncBut.width;
  ResetBut.left := DecBut.left+DecBut.width;
  ImpedEdit.left := DistChar.left;
end;

procedure TDistrel.HintButClick(Sender: TObject);
var
  pHelp : TpMemo;     {poointer to the help-memo}
  pMod  : TpElComp;   {pointer to the model component}
begin
  if (Dist.GetActRel <> nil) then begin
    Dist.GetActRel.GetpMod(pMod);
    pMod^.GetpHelp(pHelp);
    if (pHelp <> nil) then begin
      pHelp.top := 200;
      pHelp.left := 100;
      pHelp.width := 430;
      pHelp.height := 530;
      pHelp.visible := true;
    end;
  end;
end;

procedure TDistrel.FormHide(Sender: TObject);
{this is needed to unmark the relay, when the Distance Relay form is minimized
 but are there any side-effects?  Oct 1  2004}
var
  ipset : longint;   {pointer  to the common, as integer}
begin
  if (not {SetComp.}appl_close) and (not SetComp.shut_down) then begin
    if (Dist.GetActRel <> nil) then begin
      Dist.GetActRel.Getipset(ipset);            {pointer to the common, as iteger}
      unmark(ipset);
    end;
    {clear, hide the memo for the notes}
    Dist.pNotes^.clear;
    Dist.pNotes^.visible := false;
    CopyGroupForm.visible := false;   {hide, if it happens to be visible}    
  end;
end;

procedure TDistrel.FormDestroy(Sender: TObject);
begin
  Dist.free;
end;

procedure TDistrel.IncButClick(Sender: TObject);
begin
  if (Dist.modscale < 36) then begin
    inc(Dist.modscale);                   {increase the scale}
    DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
  end;
end;

procedure TDistrel.DecButClick(Sender: TObject);
begin
  if (not Dist.TooSmall) then begin
    dec(Dist.modscale);                   {decrease the scale}
    DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
  end;
end;

procedure TDistrel.ResetButClick(Sender: TObject);
begin
  Dist.modscale := 0;                   {reset the scale}
  DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
end;

procedure TDistrel.DistCharMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
{show the cursor position in terms of impedance, or..
 prepare to move the whole image = change position of origo (not yet...)}
var
  txt       : string;   {temporary}
begin
  Dist.MouseImpedance(x,y,txt);
  ImpedEdit.text := txt;
  {move the rectangle around ID-number, if shown}
  if (IDimage.visible) then begin
    IDimage.left := DistChar.left+x-6;
    IDimage.top := DistChar.top+y-6;
  end else begin
    {move images of axes, in preparation of moving the whole image}
    if (ssLeft in Shift) then begin        {left button pressed}


    end;
  end;
end;

procedure TDist.DrawDiagram(Fname : string);
{draw the distance relay diagram on a file in Windows metafile format
 Fname   the name (as 'C:\dir1\dir2\filename.wmf')of the file where saved}
var
  bpu            : boolean;        {dummy}
  ix,iy          : integer;        {coordinates of the comp.}
  CompMetafile   : TMetafile;
  MetaCanvas     : TMetafileCanvas;
{ pActRel        : TpComp;         {active relay}
begin
{  pActRel := Dist.GetActRel;}
  if (pActRel <> nil) then begin
    {size of the image}
    ix := {Distrel.Distchar}pDistChar^.width;
    iy := {Distrel.Distchar}pDistChar^.height;
    CompMetafile := TMetafile.Create;    {create the metafile}
    CompMetafile.width := ix;
    CompMetafile.height := iy;
    MetaCanvas := TMetafileCanvas.Create(CompMetafile,0); {create it's canvas}
    try
      {draw the components on the canvas of the metafile}
      if (isMho(pActRel)) then DrawAllMhoChar(pActRel, MetaCanvas)
      else DrawAllPolyChar(pActRel, MetaCanvas);
      MetaCanvas.free;
      CompMetafile.SaveToFile(Fname);
    finally
      CompMetafile.Free;
    end;
  end;
end;


procedure TDistrel.ExportItemClick(Sender: TObject);
{export the relay diagram (characteristics, impedances}
var
  DirName   : string;     {name of directory where saved}
  FormImage : TBitmap;    {for saving the whole form as a bitmap}
begin
  ExportDialog.FileName := '';                    {clear initially}
  if (ExportDialog.execute) then begin
    if (ExportDialog.FilterIndex = 1) then begin  {save as a wmf-file}
      Dist.DrawDiagram(ExportDialog.FileName);
    end else begin                                {save as a bitmap or jpeg}
      FormImage := Distrel.getFormImage;
      if (ExportDialog.FilterIndex = 2) then begin  {save as a bitmap}
        FormImage.savetofile(ExportDialog.Filename);
      end else begin                                                {save as a jpeg}
        SaveJpegImage(@Distrel, FormImage, ExportDialog.FileName);  { ..in routines.pas}
      end;
      FormImage.free;
    end;
    DirName := ExtractFilePath(ExportDialog.FileName);
    ExportDialog.InitialDir := DirName;    {save the directory}
  end;
end;

procedure TDistrel.ExitItemClick(Sender: TObject);
begin
  Distrel.visible := false;
end;

procedure TDistrel.TitleEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu     : integer; {temporary}
  pActR   : TpComp;  {pointer to the active relay}
begin
  if (not appl_close) then begin
    {check the length with help of the dummy image, with same font}
    ipu := DummyImage.canvas.textwidth(TitleEdit.text)+16;
    TitleEdit.width := ipu;
    pActR := Dist.GetActRel;
    if (pActR <> nil) then begin
      {save title}
      pActR^.PutDescrG(1,TitleEdit.text,'','');  {save title as a description}
    end;
  end;
end;

procedure TDistrel.FormKeyPress(Sender: TObject; var Key: Char);
{ semicolon ';' not allowed because it is used as a separator when saving to file
  pound '' not allowed, because it is used as line separator}
begin
{  if (key = ';') or (key = '') then key := #0;}
{CANNOT DO in this way, because if keypreview is true, the delete-key of a character
 does not work !?
 That is, delete-key deletes the component, not a character in the grid}
end;

procedure TDistrel.NotesItemClick(Sender: TObject);
{show or hide the notes on the lower part of the form}
const
 NomHeight = 48;
 HidHeight = 1;
begin
  NotesItem.checked := not NotesItem.checked;
  if (NotesItem.checked) then begin                        {display the memo}
//  NotesMemo.height := NomHeight;
//  NotesMemo.visible := NotesItem.checked;
//  Height := height+NomHeight-HidHeight;                   {increase height of form}
  end else begin
//  NotesMemo.height := HidHeight;
//  NotesMemo.visible := false;
//  height := height-NomHeight+HidHeight;                   {decrease height of form}
  end;
  {hide/show the memo for the notes}
  Dist.pNotes^.visible := NotesItem.checked;
  if (Dist.pDistNotes^.visible) then Dist.pDistNotes^.BringToFront;
  {if hidden by the graph, move}
  if (Dist.pDistNotes^.left > DistRel.left-32) and
     (Dist.pDistNotes^.left+Dist.pDistNotes^.width < DistRel.left+DistRel.width+32) then begin
    if (DistRel.left > 32) then Dist.pDistNotes^.left := 16
    else Dist.pDistNotes^.left := DistRel.left+DistRel.width;
  end;
end;

//procedure TDistrel.NotesMemoExit(Sender: TObject);
//var
//  line    : string;  {one line of text}
//  pActRel : TpComp;  {pointer to the active relay}
//begin
(*
  if (not SetComp.appl_close) then begin
    pActRel := Dist.GetActRel;                    {pointer to the relay shown}
    if (pActRel <> nil) then begin
      if (NotesMemo.lines.count > 0) then line := NotesMemo.lines[0]
      else line := '';
      pActRel^.PutDescrG(2,'',line,'');           {save notes as a description}
    end;
  end;
*)
//end;

procedure TDistrel.FormActivate(Sender: TObject);
var
  cnt    : integer;
  ii,jj  : integer;
begin
(*
  {remove empty lines}
  cnt := NotesMemo.lines.count;
  if (cnt > 1) then begin         {more than one line}
    for ii := 1 to cnt-1 do begin
      jj := cnt-ii+1;             {from last to first line}
      {remove line, if empty}
      if (length(NotesMemo.lines[jj]) = 0) then NotesMemo.lines.delete(jj);
    end;
  end;
*)
  if (NotesItem.checked) then Dist.pNotes^.visible := true;
end;

procedure TDist.NotesMemoKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{save the text to the active relay at every key-up!
 (because there is no other way ?)}
var
  cnt     : integer; {no of lines}
  ii      : integer; {index}
  line    : string;  {one line of text}
begin
  if (not {SetComp.}appl_close) then begin
    if (pActRel <> nil) then begin
      cnt := pNotes^.lines.count;
      line := '';
      if (cnt > 0) then begin
        for ii := 0 to cnt-1 do begin
          line := line+pNotes^.lines[ii]+''; {use '' as a separator of lines}
        end;
      end else begin
        line := '';
      end;
      pActRel^.PutDescrG(2,'',line,'');           {save notes as a description}
    end;
  end;
end;

procedure TDist.SaveLineColor(clr: TColor);
{save the color used for the vertical and horizontal grid lines
 It is saved to the current trafo}
var
  ll     : longint;   {temporary}
  pCurrT : TpComp;    {pointer to the current  trafo of this relay}
  pComp  : TpComp;    {pointer to the (last clicked) relay}
begin
  pComp := GetActRel;                {pointer to the relay, from integer}
  pComp^.GetipComp(ll);              {get pointer to the current trafo, as integer}
  if (ll <> 0) then begin            {there (probably) is a trafo}
    pCurrT := TpComp(ll);            {pointer to the current trafo}
    ll := longint(clr);              {change color to longint}
    pCurrT^.PutAdpar(ll);            {save color as the additional parameter}
  end;
end;

procedure TDist.PutNewColor(clr: TColor);
{save the color to Dist}
begin
  clGrid := clr;
end;

procedure TDist.SetClrChange;
{set the flag for the color change}
begin
  ClrChange := true;
end;

procedure TDist.ResetClrChange;
{reset the flag for the color change}
begin
  ClrChange := false;
end;

function TDist.isResistLine(imrk : integer): boolean;
{check is a marker-line vertical = resistance line, or horizontal = reactance line
 imrk   the index of the marker, first = 0}
var
  ii      : integer;   {index}
  ipu     : integer;   {temporary}
  len     : integer;   {length of line}
  line    : string;    {parameter line}
  txa,txb : string;    {temporary}
begin
  pActRel^.GetDescrQ(line,txa,txb);         {descriptions as first parameter}
  len := length(line);
  if (imrk >= 0) and (imrk < Lmark_d) then begin
    ii := nLDit*imrk+3;    {lditems}        {10 items for a marker, reactance is the third}
    ExtractParam(ii,gImpedSep,line,txa);    {' ' for resistance, or ' X = ..' for reactance}
    {check, is it resistance or}
    isResistLine := (txa = ' ')             {is resistance?}
  end else begin
    isResistLine := false;                  {error case, value ?}
  end;
end;

function   TDist.SizeScaling : single;
{get the ratio of present size of image to the original size}
begin
  SizeScaling := pChar^.width/owid;
end;

function  TDist.OrigWidth: integer;
{get the original width of the char.image}
begin
  OrigWidth := owid;
end;

procedure TDist.MouseDownAtID(x,y : integer);
{check, is mouse pressed at an ID of a marker or load zone. If it is, show a small square
 x,y  the mouse coordinates}
var
  atID      : boolean;   {clicking at ID}
  err       : integer;   {error flag}
  ii        : integer;   {index}
  ix,iy     : integer;   {coordinates}
  ixy       : integer;   {scaled position in x or y direction}
  isResi    : boolean;   {vertical, resistance line}
  Lmark     : integer;   {number of line markers}
  nmark     : integer;   {no of point markers}
  res,reac  : single;    {impedance corresponding to the position of the ID}
  rlx       : single;    {relative size of image}
  txc,txt   : string;    {temporary}
  xrow,yrow : integer;   {rows for coordinates }
begin
  {clicking at ID of a point-marker ?}
  nmark := nMark_d;   {no of markers}
  px_d := -1;
  py_d := -1;
  pi_d := -1;
  if (nmark > 0) then begin
    for ii := 0 to nmark-1 do begin
      {clicking at ID of a marker?}
      if (x > IDrxx[ii]+Mrkxx[ii])    and
         (x < IDrxx[ii]+Mrkxx[ii]+18) and
         (y > IDryy[ii]+Mrkyy[ii])    and
         (y < IDryy[ii]+Mrkyy[ii]+12) then begin
        px_d := x;
        py_d := y;
        pi_d := ii;
        {a small rectangle around the first char. of the ID}
        pMarkerID^.top := pChar^.top+IDryy[ii]+Mrkyy[ii];
        pMarkerID^.left := pChar^.left+IDrxx[ii]+Mrkxx[ii];
        pMarkerID^.visible := true;
        pMarkerID^.BringToFront;
        break;
      end;
    end;
  end;
  {clicking at the ID of a line-marker}
  Lmark := Lmark_d{pLmList^.items.count};         {no of line markers}
  lx_d := -1;                            {index of the marker}
  ly_d := -1;
  li_d := -1;
  if (Lmark > 0) then begin
    rlx := SizeScaling;                 {take changed size of graph into account}
    for ii := 0 to Lmark-1 do begin
      isResi := isResistLine(ii);       {vertical (resistance) or horizontal line}
      ixy := round(rlx*LIDyy[ii]);
      if (isResi) then begin            {vertical line: x = relative, y = absolute}
        atID := (x > LIDxx[ii]+Linxy[ii]) and (x < LIDxx[ii]+Linxy[ii]+18) and
                (y > ixy) and (y < ixy+12);
      end else begin                    {horizontal line}
        ixy := round(rlx*LIDxx[ii]);
        atID := (x > ixy) and (x < ixy+18) and
                (y > LIDyy[ii]+Linxy[ii]) and (y < LIDyy[ii]+Linxy[ii]+12);
      end;
      if (atID) then begin              {clicking at ID of a line marker}
        lx_d := x;
        ly_d := y;
        li_d := ii;
        {a small rectangle around the first char. of the ID}
        if (isResi) then begin          {y absolute, x relative}
          pMarkerID^.top := pChar^.top+ixy;
          pMarkerID^.left := pChar^.left+LIDxx[ii]+Linxy[ii];
        end else begin
          pMarkerID^.top := pChar^.top+LIDyy[ii]+Linxy[ii];
          pMarkerID^.left := pChar^.left+ixy;
        end;
        pMarkerID^.visible := true;
        pMarkerID^.BringToFront;
        break;
      end;
    end;
  end;
  {clicking at ID of a load zone}
  zi_d := -1;        {initialize: not clicking at ID of load zone}
  zx_d := -1;
  zy_d := -1;
  for ii := 1 to 4 do begin          {forward, reverse zones and out of step char}
    if (ii = 1) then begin
      xrow := fwIDxRow_d;
      yrow := fwIDyRow_d;
    end else if (ii = 2) then begin
      xrow := rvIDxRow_d;
      yrow := rvIDyRow_d;
    end else if (ii = 3) then begin
      xrow := z6IDxRow_d;
      yrow := z6IDyRow_d;
    end else begin
      xrow := z5IDxRow_d;
      yrow := z5IDyRow_d;
    end;
    txt := pGrid^.cells[1,xRow];       {x-coord. as resistance}
    chkfloat(txt,err,txc);
    if (err = 0) then res := strtofloat(txc)
    else res := 0;                     {just some value}
    txt := pGrid^.cells[1,yRow];       {y-coord. as resistance}
    chkfloat(txt,err,txc);
    if (err = 0) then reac := strtofloat(txc) else reac := 0;
    ImpedToPos(res,reac,ix,iy);        {pos. as impedance to coordinates}
    {mouse down at first char. of ID of load zone}
    if (x > ix) and (x < ix+18) and (y > iy) and (y < iy+12) then begin
      pMarkerID^.top := pChar^.top+iy;
      pMarkerID^.left := pChar^.left+ix;
      pMarkerID^.visible := true;
      pMarkerID^.BringToFront;
      zx_d := x;
      zy_d := y;
      zi_d := ii;        {1 = forward zone, 2 = reverse zone}
      break;
    end;
  end;
  {clicking at the unit of an axis, the "Ohm"}
  oi_d := -1;        {initialize: not clicking at "Ohm"}
  ox_d := -1;
  oy_d := -1;
  for ii := 1 to 2 do begin
    if (ii = 1) then begin                    {coordinates of "Ohm" on the R-axis}
    {distance from left or right edge?}
if (OhmRx_d >= 0) then ix := OhmRx_d else
      ix := pChar^.width+OhmRx_d;
      iy := (pChar^.height div 2)+OhmRy_d;
    end else begin                            {coordinates of "Ohm" on the X-axis}
      ix := (pChar^.width div 2)+OhmXx_d;
      {distance from top or bottom?}
if (OhmXy_d >= 0) then iy := OhmXy_d else
      iy := pChar^.height+OhmXy_d;
    end;
    {clicking near to the "Ohm" ?}
    if (x > ix) and (x < ix+18) and (y > iy+2) and (y < iy+14) then begin
      pMarkerID^.top := pChar^.top+iy+4;
      pMarkerID^.left := pChar^.left+ix;
      pMarkerID^.visible := true;
      pMarkerID^.BringToFront;
      ox_d := x;
      oy_d := y;
      oi_d := ii;        {1 = R-axis, 2 = X-axis}
      break;
    end;
  end;
  {pMarkerID^.visible := true;}
end;

procedure TDist.MouseUpAtID(x, y: Integer);
{if ID of a marker moving, update position and data
 x,y   mouse coordinates}
const
  gIs = gImpedSep;        {impedance separator, defined in utildef.pas}
var
  apu,apv     : single;   {temporary}
  IDx,IDy     : integer;  {position of the identifier}
  ii,kk       : integer;  {indices, counters}
  ipu,ipv,ipw : integer;  {temporary}
  istr,iend   : integer;  {start and end of identifier data}
  len         : integer;  {length of text}
  line        : string;   {new line, with updated marker position}
  Lmrk,Pmrk   : boolean;  {point-marker, line-marker}
  pComp       : TpComp;   {pointer to the relay}
  pli         : integer;  {index of marker}
  res,reac    : single;   {resistance, reactance that correspond to the shift}
  rlx         : single;   {scaling factor due to (eventually) changed image size}
  txa,txb,txc : string;   {temporary}
  xrow,yrow   : integer;  {rows for coordinates}
begin
  pComp := pActRel;                {pointer to the relay of this diagram}
  {ID of a marker moving? }
  Pmrk := (px_d >= 0) and (py_d >= 0)and (pi_d >= 0);  {point marker}
  Lmrk := (lx_d >= 0) and (ly_d >= 0)and (li_d >= 0);  {line marker}
  if (Pmrk or Lmrk) then begin     {marker moving}
    if (Pmrk) then begin           {point marker}
      IDx := IDrxx[pi_d]+x-px_d;   {new relative x-coord}
      IDrxx[pi_d] := IDx;
      IDy := IDryy[pi_d]+y-py_d;   {new relative y-coord}
      IDryy[pi_d] := IDy;
      pli := pi_d;
    end else begin                 {line marker}
      rlx := SizeScaling;          {take size of image into account}
      {vertical (resistance) or horizontal (reactance) line?}
      if isResistLine(li_d) then begin   {vertical line: abs. x, rel. y}
        ipu := x-lx_d;
        ipv := round((y-ly_d)/rlx);
      end else begin
        ipu := round((x-lx_d)/rlx);
        ipv := y-ly_d;
      end;
      IDx := LIDxx[li_d]+ipu;   {new relative or abs. x-coord}
      LIDxx[li_d] := IDx;
      IDy := LIDyy[li_d]+ipv;   {new relative or abs. y-coord}
      LIDyy[li_d] := IDy;
      pli := li_d;
    end;
    {update the string with data for all markers}
    if (Pmrk) then pComp^.GetDescrG(txa,txb,txc)   {markers saved as third description}
    else pComp^.GetDescrQ(txc,txa,txb);            {markers saved as first description}
    {read and copy the data up to the relative pos. of the moved marker ID }
    line := '';                      {initialize}
    {count no of markers, an "Impedance separator" marks the end of oneline for one marker}
    len := length(txc);
    kk := 0;
    {count separators, replace new ID-position}
    {first, the start and end indices of ID-data}
    if (Pmrk) then begin
      istr := nPDit*pli+nPDit-2;
      iend := nPDit*pli+nPDit;
    end else begin
      istr := nLDit*pli+nLDit-2;   {lditems}
      iend := nLDit*pli+nLDit;
    end;
    if (len > 0) then begin
      for ii := 1 to len do begin
        if (txc[ii] = gImpedSep) then begin
          inc(kk);
          if (kk = istr) then begin                {position for the ID's found}
            line := line+gIs+inttostr(IDx)+gIs+
                             inttostr(IDy)+gIs;    {add rel.pos. of the identif.}
          end else begin
            if (kk < istr) or (kk > iend) then begin
              line := line+txc[ii];
            end;
          end;
        end else begin
          {copy unless identifier position}
          if (kk < istr) or (kk >= iend) then begin
            line := line+txc[ii];
          end;
        end;
      end;
      if (Pmrk) then pComp^.PutDescrG(4,'','',line)  {point-markers saved as third description}
      else  pComp^.PutDescrQ(1,line,'','');          {line-markers saved as first description}
    end;
    if (isMho(pComp)) then DrawAllMhoChar(pComp,pChar^.canvas)   {update the image}
    else DrawAllPolyChar(pComp,pChar^.canvas);
  end;
  {ID of a load zone moving ?}
  if (zi_d >= 1) and (zi_d <= 4) and (zx_d >= 0) and (zy_d >= 0) then begin
    if (zi_d = 1) then begin            {forward zone}
      xrow := fwIDxRow_d;
      yrow := fwIDyRow_d;
    end else if (zi_d = 2) then begin
      xrow := rvIDxRow_d;
      yrow := rvIDyRow_d;
    end else if (zi_d = 3) then begin
      xrow := z6IDxRow_d;
      yrow := z6IDyRow_d;
    end else  begin
      xrow := z5IDxRow_d;
      yrow := z5IDyRow_d;
    end;
    pComp^.GetPar(xRow+1,res);               {present x, as resistance}
    pComp^.GetPar(yRow+1,reac);              {present y, as reactance}
    ImpedToPos(res,reac,ipu,ipv);            {impedance to position}
    ipu := ipu+x-zx_d;                       {new x-coord}
    ipv := ipv+y-zy_d;
    PosToImped(ipu,ipv,res,reac);            {position to impedance}
    pComp^.PutPar(xRow+1,res);               {save as a parameter}
    pComp^.PutPar(yRow+1,reac);
    pGrid^.cells[1,xRow] := floattostr(res); {save also as a string}
    pGrid^.cells[1,yRow] := floattostr(reac);
    spare[xRow] := pGrid^.cells[1,xRow];     {necessary, to inactivate "cancel" !}
    spare[yRow] := pGrid^.cells[1,yRow];
    if (isMho(pComp)) then DrawAllMhoChar(pComp,pChar^.canvas)   {update the image}
    else DrawAllPolyChar(pComp,pChar^.canvas);
  end;
  {The "Ohm" moving?}
  if (oi_d >= 1) and (oi_d <= 2) and (ox_d >= 0) and (oy_d >= 0) then begin
    ipu := x-ox_d;              {shift of relative x-coord}
    ipv := y-oy_d;
    if (oi_d = 1) then begin                    {"Ohm" at R-axis}
      {OhmRx_d := OhmRx_d+ipu; the old way}
      {is the distance measured from left or right edge?}
      ipw := OhmRx_d+ipu;
      if (ipw < 0) then begin
        if (-ipw > (pChar^.width div 2)) then   {in the left half of the picture}
          OhmRx_d := pChar^.height +ipw
        else OhmRx_d := ipw;                    {in the right half}
      end else begin
        if (ipw > (pChar^.width div 2)) then    {in the right half}
          OhmRx_d := ipw-pChar^.width
        else OhmRx_d := ipw;
      end;
      OhmRy_d := OhmRy_d+ipv;
    end else begin                              {"Ohm" at X-axis}
      OhmXx_d := OhmXx_d+ipu;
      {is the distance measured from top or bottom?}
      ipw := OhmXy_d+ipv;
      if (ipw < 0) then begin
        if (-ipw > (pChar^.height div 2)) then    {in the upper half of the picture}
          OhmXy_d := pChar^.height +ipw
        else OhmXy_d := ipw;                      {in the lower half}
      end else begin
        if (ipw > (pChar^.height div 2)) then      {in the lower half}
          OhmXy_d := ipw-pChar^.height
        else OhmXy_d := ipw;
      end;
{      OhmXy_d := OhmXy_d+ipv; old way}
    end;
    {save the new relative coordinates of "Ohm" to the component}
    line := inttostr(ohmRx_d)+' '+inttostr(ohmRy_d)+' '+
            inttostr(ohmXx_d)+' '+inttostr(ohmXy_d);     {change to a string}
    pComp^.PutDescrQ(2,'',line,'');   {save as description Q2}
    {update the picture}
    if (isMho(pComp)) then DrawAllMhoChar(pComp,pChar^.canvas)   {update the image}
    else DrawAllPolyChar(pComp,pChar^.canvas);
  end;
  pMarkerID^.visible := false;
end;

procedure TDist.PosToImped(x,y : integer; var res, reac : single);
{determine the impedance that correspond to the position in the graph
 x,y        coordinates of the position
 res,react  the impedance}
var
  width : integer;  {width (and height) of the image}
  wid2  : single;   {width (and height) of the image / 2}
begin
  width := pChar^.width;    {total width of the image}
  wid2 := width/2;
  res := scale*(x-wid2)/wid2;    {resistance}
  reac := scale*(wid2-y)/wid2;   {reactance}
end;

procedure TDist.ImpedToPos(res, reac : single; var x,y : integer);
{determine the coordinates that correspond to the given impedance}
var
  width : integer;  {width (and height) of the image}
  wid2  : single;   {width (and height) of the image / 2}
begin
  width := pChar^.width;    {total width of the image}
  wid2 := width/2;
  x := round(res*wid2/scale+wid2);
  y := round(wid2-reac*wid2/scale);
end;

function TDist.GetLineColor: TColor;
{determines the color used for the vertical and horizontal grid lines}
var
  clr    : TColor;
  ll     : longint;   {temporary}
  pCurrT : TpComp;    {pointer to the current  trafo of this relay}
  pComp  : TpComp;    {pointer to the (last clicked) relay}
begin
  pComp := GetActRel;                {pointer to the relay, from integer}
  pComp^.GetipComp(ll);              {get pointer to the current trafo, as integer}
  if (ll <> 0) then begin            {there (probably) is a trafo}
    pCurrT := TpComp(ll);            {pointer to the current trafo}
    pCurrT^.GetAdpar(ll);            {get additional parameter = color, as integer}
    if (ll <> 0) then clr := TColor(ll)
    else clr := clSilver;
  end else begin
    clr := clSilver;
  end;
  GetLineColor := clr;
end;

function  TDist.ColorChanged: boolean;
{true, if grid color has been changed}
begin
  ColorChanged := ClrChange;
end;

function TDist.NewColor: TColor;
begin
  NewColor := clGrid;
end;

//procedure TDistrel.NotesMemoKeyUp(Sender: TObject; var Key: Word;
//  Shift: TShiftState);
//{save the text to the active relay at every key-up!
// (because there is no other way ?)}
//begin
//  Dist.NotesMemoKeyUp(Sender,Key,Shift);
//end;

procedure TDistrel.MarkerMenuClick(Sender: TObject);
begin
(*
  ImpedanceForm.tag := longint(Dist.pActRel);  {save pointer to relay as integer}
  ImpedanceForm.visible := true;
*)
end;

procedure TDistrel.Zone1ItemClick(Sender: TObject);
begin
  Zone1Item.checked := not Zone1Item.checked;
  DistanceRelayShow;
end;

procedure TDistrel.Zone2ItemClick(Sender: TObject);
begin
  Zone2Item.checked := not Zone2Item.checked;
  DistanceRelayShow;
end;

procedure TDistrel.Zone3ItemClick(Sender: TObject);
begin
  Zone3Item.checked := not Zone3Item.checked;
  DistanceRelayShow;
end;

procedure TDistrel.Zone4ItemClick(Sender: TObject);
begin
  Zone4Item.checked := not Zone4Item.checked;
  DistanceRelayShow;
end;

procedure TDistrel.LineItemClick(Sender: TObject);
begin
  LineItem.checked := not LineItem.checked;
  DistanceRelayShow;
end;

procedure TDistrel.ShowItemClick(Sender: TObject);
{show or hide buttons, etc}
var
  bpu : boolean;
begin
  ShowItem.checked := not ShowItem.checked;
  IncBut.visible := ShowItem.checked;
  DecBut.visible := ShowItem.checked;
  ResetBut.visible := ShowItem.checked;
(*  moved to ParamItem.click
  OKBut.visible := ShowItem.checked;
  CancelBut.visible := ShowItem.checked;
  ApplyBut.visible := ShowItem.checked;
  HintBut.visible := ShowItem.checked;
  MarkImage.visible := ShowItem.checked;
*)
  bpu := (SetComp.appl_op = 6 ) or (SetComp.appl_op = 7 ) or
         (SetComp.appl_op = 8 ) or (SetComp.appl_op = 11);
  ImpedEdit.visible := ShowItem.checked and bpu;
end;

procedure TDistrel.ColorItemClick(Sender: TObject);
begin
  ColorItem.checked := not ColorItem.checked;
end;

procedure TDistrel.GridItemClick(Sender: TObject);
{display the palette (menu) for the color of the grid}
begin
  GridColor.top := DistChar.top+64;
  GridColor.visible := true;
  GridColor.BringToFront;
end;

procedure TDistrel.GridColorMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  GridCol : TColor;
  ll      : longint;
  pComp   : TpComp;
  xcol    : TColor;
begin
  GridCol := GetPixel(GridColor.canvas.handle,x,y);  {get color from the menu}
  GridColor.visible := false;
  Dist.clGrid := GridCol;                 {new color to grid}
  Dist.ClrChange := true;                 {color changed}
  DistanceRelayShow;
  Dist.ClrChange := false;                {reset flag}
end;

procedure TDistrel.DistCharMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  {mouse pressed at ID of a marker?}
  Dist.MouseDownAtID(x,y);
end;

procedure TDistrel.DistCharMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  {ID of a marker moving? }
  Dist.MouseUpAtID(x, y);
end;

procedure TDistrel.PointMarkerClick(Sender: TObject);
begin
  ImpedanceForm.tag := longint(Dist.pActRel);  {save pointer to relay as integer}
  ImpedanceForm.visible := true;
  ImpedanceForm.BringToFront;
end;

procedure TDistrel.LineMarkerClick(Sender: TObject);
begin
  RXLineForm.tag := longint(Dist.pActRel);  {save pointer to relay as integer}
  RXLineForm.visible := true;
  RXLineForm.BringToFront;
end;

procedure TDistrel.FormShow(Sender: TObject);
{produce an artificial mouse clik in order to select the grid.
 If this is not done, and the size of the image is reduced, and scrolled down.
 then a click of the grid resets the scrolling}
var
  ix,iy : dword;
begin
(*
  MhoGrid.SetFocus;
  mouse_event(mouseeventf_leftup,0,0,0,0);          {to finish mouse up at relay}
  ix := (distrel.left+MhoGrid.defaultcolwidth+10);
  iy := (distrel.top+64);
  Setcursorpos(ix,iy);                       {set cursor (mouse) to grid}
  mouse_event(mouseeventf_leftdown,0,0,0,0); {mouse down at grid}
  mouse_event(mouseeventf_leftup,0,0,0,0);
*)
  {save the parameter group index}
  Dist.SaveParSetIndex;
end;

procedure TDist.DrawCell(Col, Row: Longint; Rect: TRect);
{color the cells that cannot be edited and color the "color-cells"}
var
  iclr : integer; {color index}
  ix   : integer; {coordinate}
  txt  : string;  {temporary}
begin
  if (Col = 1) and ((row = fwIDxRow_d) or (row = rvIDxRow_d) or
                    (row = fwIDyRow_d) or (row = rvIDyRow_d) or
                    (row = z6IDxRow_d) or (row = z5IDxRow_d) or
                    (row = z6IDyRow_d) or (row = z5IDyRow_d) or
                    (row = phThRow_d ) or (row = grThRow_d ) or
                    (row = parGrRow_d)) then begin
    if (row = phThRow_d) then begin
      pGrid^.canvas.pen.color := clWhite;
      pGrid^.canvas.brush.color := clWhite;
    end else begin
      pGrid^.canvas.pen.color := pGrid^.FixedColor;
      pGrid^.canvas.brush.color := pGrid^.FixedColor;
    end;
    pGrid^.canvas.rectangle(rect.left,rect.top,rect.left+
           pGrid^.DefaultColWidth,rect.top+pGrid^.DefaultRowHeight);
    if (row = fwIDxRow_d) then begin                       {x stored in "forward" row}
      pGrid^.canvas.TextOut(2+rect.left,rect.top,'forward');
    end else if (row = rvIDxRow_d) then begin              {y stored in "reverse" row}
      pGrid^.canvas.TextOut(2+rect.left,rect.top,'reverse');
    end else if (row = z6IDxRow_d) then begin
      pGrid^.canvas.TextOut(2+rect.left,rect.top,'char. Z6');
    end else if (row = z5IDxRow_d) then begin
      pGrid^.canvas.TextOut(2+rect.left,rect.top,'char. Z5');
    end else if (row = phThRow_d) then begin
      pGrid^.canvas.TextOut(2+rect.left,rect.top,' select ')
    end;
  end;
  {show the color of the color cell}
  if ((row = fwColRow_d) or (row = rvColRow_d) or
      (row = z6ColRow_d) or (row = z5ColRow_d)) and (col = 1) then begin
    txt := pGrid^.cells[col,row];
    iclr := strtoint(txt);
    if (iclr < 1) then iclr := 1;
    if (iclr > 16) then iclr := 16;
    pGrid^.canvas.pen.color := gColor[iclr];
    pGrid^.canvas.brush.color := gColor[iclr];
    {a square indicates the color}
    pGrid^.canvas.rectangle(rect.left,rect.top,rect.left+16,rect.bottom);
  end;
end;

procedure TDistrel.MhoGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
{color the cells that cannot be edited
 and color the "color-cells"}
begin
  Dist.DrawCell(Col, Row, Rect);
end;

procedure TDistrel.MhoGridMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
{save position of scroll bar, so that it can be returned when grid is clicked
 after some component that can have focus}
const
  xo : integer = 0;
  yo : integer = 0;
var
  arow, acol : longint;
begin
  if (x <> xo) and ( y <> yo) then begin  {to prevent taking mouse click as mouse move}
    scroll_pos := vertscrollbar.position;
    xo := x;
    yo := y;
  end;
end;

procedure TDist.ClickNonData;
{When the scroll position of the form is > 0, and a control that can have focus
 (the title, the notes-memo, the edit for the cursor position)
 has been clicked, then the clicking of the grid (may) reset the scroll position
 back to zero (which is annoying). One way to prevent (or correct) this is to
 set the scroll-position back. This is done in  MhoGridMouseDown and
 in MhoGridMouseMove.
 This does not help in the case the clicked cell has been selected (clicked) earlier.
 The cell does not react to "mouse move".(This seems to be a bug in Delphi, I think)
 In this case it helps to set the value of the "row" parameter to a non-editable cell}
begin
  if (pForm^.VertScrollBar.position > 8) then begin
    if (RowVisible(fwIDxRow_d)) then pGrid^.row := fwIDxRow_d
    else if (RowVisible(rvIDxRow_d)) then pGrid^.row := rvIDxRow_d
    else if (RowVisible(z6IDxRow_d)) then pGrid^.row := z6IDxRow_d
    else if (RowVisible(z5IDxRow_d)) then pGrid^.row := z5IDxRow_d;
  end;
end;

procedure TDist.PutImpedZoneRows(phThRow, grThRow : integer);
begin
  phThRow_d := phThRow;
  grThRow_d := grThRow;
end;

procedure TDist.PutNameRows(fwRow,rvRow: integer);
{save the indices for the name rows}
begin
  fwNameR_d := fwRow;
  rvNameR_d := rvRow;
end;

procedure TDist.GetNameRows(var fwRow, rvRow : integer);
{get the indices for the name rows}
begin
  fwRow := fwNameR_d;
  rvRow := rvNameR_d;
end;

procedure TDist.PutfwIDRows(xrow,yrow : integer);
{save the rows for the coordinates (as impedance) of the forward ID}
begin
  fwIDxRow_d := xrow;
  fwIDyRow_d := yrow;
end;

procedure TDist.PutParGroupRow(pgRow: integer);
{save the row for parameter group index}
begin
  parGrRow_d := pgRow;
end;

function TDist.GetParGroupRow: integer;
{get the row for the parameter group index}
begin
  GetParGroupRow := parGrRow_d;
end;

procedure TDist.GetfwIDRows(var xrow,yrow : integer);
{get the rows for the coordinates (as impedance) of the forward ID}
begin
  xrow := fwIDxRow_d;
  yrow := fwIDyRow_d;
end;

procedure TDist.PutrvIDRows(xrow,yrow : integer);
{save the rows for the coordinates (as impedance) of the reverse ID}
begin
  rvIDxRow_d := xrow;
  rvIDyRow_d := yrow;
end;

procedure TDist.GetrvIDRows(var xrow,yrow : integer);
{get the rows for the coordinates (as impedance) of the reverse ID}
begin
  xrow := rvIDxRow_d;
  yrow := rvIDyRow_d;
end;

procedure TDist.PutLineRows(fwClr, rvClr, fwThick, rvThick : integer);
begin
  fwColRow_d := fwClr;
  rvColRow_d := rvClr;
  fwThRow_d := fwThick;
  rvThRow_d := rvThick;
end;

procedure TDist.PutLoadZoneRows(fwMVA,fwposA,fwnegA,rvMVA,rvposA,rvnegA : integer);
begin
  fwMVARow_d := fwMVA;
  fwPosARow_d := fwposA;
  fwNegARow_d := fwnegA;
  rvMVARow_d := rvMVA;
  rvPosARow_d := rvposA;
  rvNegARow_d := rvnegA;
end;

procedure TDist.Putz6Rows(rName,rTop,rBot,rRight,rLeft,rColor,rThickn,rIDx,rIDy : integer);
begin
  z6NameRow_d  := rName;
  z6TopRow_d   := rTop;
  z6BotRow_d   := rBot;
  z6RightRow_d := rRight;
  z6LeftRow_d  := rLeft;
  z6ColRow_d   := rColor;
  z6ThRow_d    := rThickn;
  z6IDxRow_d   := rIDx;
  z6IDyRow_d   := rIDy;
end;

procedure TDist.Putz5Rows(rName,rTop,rBot,rRight,rLeft,rColor,rThickn,rIDx,rIDy : integer);
begin
  z5NameRow_d  := rName;
  z5TopRow_d   := rTop;
  z5BotRow_d   := rBot;
  z5RightRow_d := rRight;
  z5LeftRow_d  := rLeft;
  z5ColRow_d   := rColor;
  z5ThRow_d    := rThickn;
  z5IDxRow_d   := rIDx;
  z5IDyRow_d   := rIDy;
end;

function TDist.RowVisible(arow : integer): boolean;
{check, is row arow visible}
var
  apu,apv   : single;      {temporary}
  botrow    : integer;     {last visible row}
  botspace  : integer;     {space between grid and buttons, if any}
  grheight  : integer;     {visible height of grid}
  ipu,ipv   : integer;     {temporary}
begin
  botrow := pGrid^.VisibleRowCount-1;    {last visible row}
  if (arow > botrow) then begin
    RowVisible := false                  {below last visible row}
  end else begin                         {must check }
    {eventual space between bottom of grid and buttons}
    ipu := pForm^.clientheight-pGrid^.top-pGrid^.height-pOKBut^.height;
    if (ipu > 0) then botspace := ipu else botspace := 0;
    grheight := pForm^.clientheight-pOKbut.height-botspace; {visible height of grid}
    apv := pGrid^.DefaultRowHeight+pGrid^.GridLineWidth; {height of one row}
    ipu := round(grheight/apv+0.5);      {no. of visible rows}
    RowVisible := arow > botrow-ipu;     {arow visible}
  end;
end;

function  TDist.GetGroupIndex: integer;
{get the index of the parameter group read as a parameter}
var
  apu : single;  {temporary}
begin
  pActRel^.GetPar(parGrRow_d+1,apu);
  GetGroupIndex := round(apu);
end;

procedure  TDist.PutGroupIndex(igrp: integer);
{get the index of the parameter group read as a parameter}
var
  apu : single;
begin
  apu := igrp;
  pActRel^.PutPar(parGrRow_d+1,apu);
end;

function  TDist.GetGroupIndexRow: integer;
begin
  GetGroupIndexRow := parGrRow_d;
end;

procedure TDist.PutParGroupMenus(pCaption,pInc,pDec: TpMenuItem);
{put pointers to the menu items used for changing and displaying the parameter group index}
begin
  pGrpCaption := pCaption;
  pIncGrp := pInc;
  pDecGrp := pDec;
end;

function TDist.ParamGroupIndex: integer;
{deduce the index of the present parameter group from the caption}
var
  grp   : char;     {index as char}
  igrp  : integer;  {index of the group}
  len   : integer;  {length of a string}
begin
  {get the index of the present group}
  len := length(pGrpCaption^.caption);
  grp := pGrpCaption^.caption[len];             {index as the first char. of the caption}
  if (grp >= '1') and (grp <= '9') then begin {a reasonable number}
    igrp := strtoint(grp);
    if (igrp > gParSet) then igrp := 1;       {must be a reasonable index}
  end else begin
    igrp := 1;                                {must be a reasonable index}
  end;
  ParamGroupIndex := igrp;
end;

procedure TDist.ChangeParamGroup(IncOrDec: string);
{increase or decrease the index of the parameter group in use, change the parameters
 IncOrDec  if 'Inc' then increase the group, else decrease}
var
  igrp   : integer;  {index of the group}
  igrp0  : integer;  {old index of the group}
  ipu    : integer;
  ll     : longint;
  pSet   : TpCompSet;
begin
  {get the index of the present group}
  igrp0 := ParamGroupIndex ; {old index}
  {save data to the old (present) group}
  FromGridToParamGroup;
  {change the parameter index: up or down}
  igrp := ParamGroupIndex;   {updated below}
  if (IncOrDec = 'Inc') or (IncOrDec = 'inc') then begin  {increase gropu}
    inc(igrp);
    if (igrp > gParSet) then igrp := 1;
  end else if (IncOrDec = 'Dec') or (IncOrDec = 'dec') then begin {decrease group}
    dec(igrp);
    if (igrp < 1) then igrp := gParSet;
  end else if (IncOrDec > '0') and (IncOrDec <= '6') then begin
    igrp := StrToInt(IncOrDec);
  end else begin
    igrp := 1;
  end;
  {read the parameters and put to the grid}
  FromParamGroupToGrid(igrp);
  {display the group, and save}
  //pGrpCaption^.caption := 'Group '+inttostr(igrp);
  ShowGroupCaption(igrp);                 {display in the menu bar}
  ipu := GetGroupIndexRow;
  pGrid^.Cells[1,ipu] := inttostr(igrp);  {"display" in the grid (all parameters must be there)}
{?}PutGroupIndex(igrp);                   {save as a parameter (necessary?)}
  {new parameter values to parameters of component}
  FromGridToParam(nil);
  {update graphics, if visible}
  if (isMho(pActRel)) then DrawAllMhoChar(pActRel,pChar^.canvas) {redraw the characteristics}
  else DrawAllPolyChar(pActRel,pChar^.canvas);
  {write the group on the relay}
  pActRel^.GetipSet(ll);
  pSet := TpCompSet(ll);
  pSet^.WriteGroupIndex(pActRel);       {in skemadef.pas}
end;

procedure TDist.SaveParSetIndex;
{save the index of the parameter set. Used when showing the parameters =
 when clicking the relay
 called in FormShow, this unit
 in AutoChangeParamGroup of Condition.pas}
begin
  ParSetInd_d := GetGroupIndex;
end;

procedure TDist.SetWarning;
{set warning for resetting parameter group}
begin
  if (pAMmenu^.caption = 'A') then begin
    pWarnEdit^.width := 320;
    pWarnEdit^.text := 'Warning: Parameter group reset in Auto-mode (OK)';
    pWarnEdit^.left := 0;
    pWarnEdit^.top := 0;
    pWarnEdit^.visible := true;
    pWarnEdit^.BringToFront;
  end;
end;

procedure TDist.SetParWarning(parnam, minval, maxval: string);
{set warning for resetting parameter group}
begin
  pWarnEdit^.width := 320;
  pWarnEdit^.text := '(X)  '+parnam+' must be between '+minval+' and '+maxval;
  pWarnEdit^.left := 0;
  pWarnEdit^.top := 0;
  pWarnEdit^.visible := true;
  pWarnEdit^.BringToFront;
end;

procedure TDist.PutOrig(X,Y : single);
begin
  origX_d := x;
  origY_d := y;
end;

procedure TDistrel.MhoGridMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  VertScrollBar.position := scroll_pos;
end;

procedure TDistrel.ImpedEditClick(Sender: TObject);
begin
  {try to prevent in advance the reset of the scroll-position}
  Dist.ClickNonData;
end;

procedure TDistrel.TitleEditClick(Sender: TObject);
begin
  {try to prevent in advance the reset of the scroll-position}
  Dist.ClickNonData;
end;

//procedure TDistrel.NotesMemoClick(Sender: TObject);
//begin
//  {try to prevent in advance the reset of the scroll-position}
//  Dist.ClickNonData;
//end;

procedure TDistrel.ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  ii,jj,kk : integer;
begin
  ii := (X div (CRwidth+CRspace))+1;
  jj := (Y div (CRwidth+CRspace))+1;
  kk := (ii-1)*4+jj;                 {color index}
  MhoGrid.cells[MhoGrid.Col,MhoGrid.Row] := inttostr(kk);
  ImagePanel.visible := false;
end;

procedure TDistrel.MhoGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{ ';' and '' are not allowed as input, because they are used as data separators.
  If ';', it is deleted by a backspace}
begin
  if (((key = 188) or (key = 52))and (ssShift in Shift)) then begin  { ';' is not allowed}
    keybd_event(VK_SHIFT, 0, 0, 0);
    keybd_event(VK_BACK, 0, 0, 0);                    {backspace}
    keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
  end;
end;

procedure TDistrel.MhoGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{ '' is not accepted as input, because it is used as a separator}
var
  arow    : integer;
  ii,jj   : integer;
  len     : integer;   {length of string}
  txa     : string;
begin
  if (key = 18) then begin             {altGR (or alt)-key}
    arow := MhoGrid.row;               {active row}
    txa := MhoGrid.cells[1,arow];      {copy to local}
    len := length(txa);
    if (len > 0) then begin
      for ii := 1 to len do begin
        jj := len-ii+1;
        if (txa[jj] = '') then begin  {if '' then delete it by a backspace}
          keybd_event(VK_SHIFT, 0, 0, 0);
          keybd_event(VK_BACK, 0, 0, 0);                    {backspace}
          keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
        end else begin
          break;
        end;
      end;
    end;
  end;
end;

procedure TDistrel.LoadItemClick(Sender: TObject);
{show or hide the names (identifiers) of the load zones}
begin
  LoadItem.checked := not LoadItem.checked;
  DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
end;

procedure TDistrel.StepItemClick(Sender: TObject);
{show or hide the names (identifiers) of the out of step zones}
begin
  StepItem.checked := not StepItem.checked;
  DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
end;

procedure TDistrel.LoadZoneItemClick(Sender: TObject);
begin
  LoadZoneItem.checked := not LoadZoneItem.checked;
  DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
end;

procedure TDistrel.OutZoneItemClick(Sender: TObject);
begin
  OutZoneItem.checked := not OutZoneItem.checked;
  DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
end;

procedure TDistrel.ThicknessImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Dist.ThicknessImageMouseUp(X,Y);
  ThicknessPanel.visible := false;
end;

procedure TDistrel.UnitsItemClick(Sender: TObject);
begin
  UnitsItem.checked := not UnitsItem.checked;
  DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
end;

procedure TDistrel.ParamItemClick(Sender: TObject);
begin
  ParamItem.checked := not ParamItem.checked;
  MhoGrid.visible := not ParamItem.checked;
  VertScrollBar.visible := not ParamItem.checked;
  OKBut.visible := not ParamItem.checked;
  CancelBut.visible := not ParamItem.checked;
  ApplyBut.visible := not ParamItem.checked;
  HintBut.visible := not ParamItem.checked;
  MarkImage.visible := not ParamItem.checked;
end;

procedure TDistrel.SymbolItemClick(Sender: TObject);
begin
  SymbolItem.checked := not SymbolItem.checked;
  DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
end;

procedure TDistrel.TitleItemClick(Sender: TObject);
begin
  TitleItem.checked := not TitleItem.checked;
  TitleEdit.visible := not TitleItem.checked;
end;

procedure TDistrel.ImpedanceItemClick(Sender: TObject);
begin
  ImpedanceItem.checked := not ImpedanceItem.checked;
  DrawAllMhoChar(Dist.GetActRel,Dist.pChar^.canvas);
end;


procedure TDistrel.DecMenuClick(Sender: TObject);
begin
  Dist.ChangeParamGroup('dec');
  Dist.SetWarning; {warning, if auto mode}
end;

procedure TDistrel.IncMenuClick(Sender: TObject);
begin
  Dist.ChangeParamGroup('inc');
  Dist.SetWarning; {warning, if auto mode}
end;

procedure TDistrel.CopyItemClick(Sender: TObject);
begin
  CopyGroupForm.ParamBox.visible := false;
  CopyGroupForm.TextBox.visible := false;
  CopyGroupForm.WhatLabel.visible := false;
  CopyGroupForm.visible := true;
  {copy pointer to the relay to the tag of the form}
  CopyGroupForm.tag := longint(Dist.GetActRel);
end;

procedure TDistrel.AutoManMenuClick(Sender: TObject);
{flip the status auto <-> man of the param.group change}
var
  ll   : longint;   {temporary }
  pSet : TpCompSet;
begin
  Dist.GetActRel^.getAdpar(ll);
  if (ll <> 2) then begin          {in manual mode}
    AutoManMenu.caption := 'A';    {set in automatic mode}
    Dist.GetActRel^.putAdpar(2);   {must use 2, because 1 was earlier in other use}
    {change the parameter group, if allowed and conditions satisfied}
    ChangeParamGroupIf(Dist.GetActRel);
  end else begin                   {in auto-mode, set in manual}
    AutoManMenu.caption := 'M';
    Dist.GetActRel^.putAdPar(0);
    WarnEdit.visible := false;
  end;
  {show auto/man in the symbol (actually in the symbol of the CT)}
  Dist.GetActRel.GetipSet(ll);
  pSet := TpCompSet(ll);
  pSet^.WriteGroupIndex(Dist.GetActRel);       {in skemadef.pas}
end;

procedure TDistrel.CondItem1Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(1);
end;

procedure TDistrel.CondItem2Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(2);
end;

procedure TDistrel.CondItem3Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(3);
end;

procedure TDistrel.CondItem4Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(4);
end;

procedure TDistrel.CondItem5Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(5);
end;

procedure TDistrel.CondItem6Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(6);
end;

procedure TDistrel.AllItemClick(Sender: TObject);
begin
  ConditionForm.AllGroupItemsClick;
end;

procedure TDistrel.WarneditClick(Sender: TObject);
begin
  Warnedit.visible := false;
end;

procedure TDistrel.CopyToCItemClick(Sender: TObject);
begin
  Clipboard.assign(DistChar.picture);
end;

procedure TDistrel.ScaleItemClick(Sender: TObject);
begin
  ScaleItem.checked := not ScaleItem.checked;
end;

end.
